#BEGIN COPYRIGHT
#*************************************************************************
#
# Licensed Materials - Property of IBM
# 5725-C94, 5725-C95, 5725-C96
# (C) Copyright IBM Corporation 2011. All Rights Reserved.
# US Government Users Restricted Rights- Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
#
#*************************************************************************
#END COPYRIGHT

import os.path
from java.lang import System

execfile(os.path.join(System.getProperty("was.install.root"), "BPM/base/profile/actions/scripts/updateServerPolicy.py"))

# ------------------------------------------------------------------------
# Update the server.policy file for the given profile with BPM permissions
# ------------------------------------------------------------------------
def updateServerPolicyForBPM(profileRoot, dbJDBCClasspath = None):
  log("info", "updateServerPolicyFileForBPM", "Input dbJDBCClasspath = " + str(dbJDBCClasspath) + ".")
  wasHome = os.path.join(System.getProperty("was.install.root"))
  if not dbJDBCClasspath:
    dbJDBCClasspath = "${WAS_INSTALL_ROOT}/jdbcdrivers"
  if dbJDBCClasspath.startswith("${WAS_INSTALL_ROOT}"):
    dbJDBCClasspath = dbJDBCClasspath.replace("${WAS_INSTALL_ROOT}", wasHome, 1)
  dbJDBCClasspath = dbJDBCClasspath.replace("\\", "/")
  if os.path.samefile(wasHome, dbJDBCClasspath[:len(wasHome)]):
    dbJDBCClasspath = "${was.install.root}" + dbJDBCClasspath[len(wasHome):]
  elif not dbJDBCClasspath.startswith("/"):
    dbJDBCClasspath = "/" + dbJDBCClasspath
  # don't use specific subdirectories as long as upgradeProfile.py doesn't use them either
  if dbJDBCClasspath.startswith("${was.install.root}/jdbcdrivers/"):
    dbJDBCClasspath = "${was.install.root}/jdbcdrivers"
  log("info", "updateServerPolicyFileForBPM", "Converted dbJDBCClasspath = " + dbJDBCClasspath + ".")
  jrePermissions = ['java.lang.RuntimePermission "accessClassInPackage.sun.swing"', 'java.lang.RuntimePermission "accessClassInPackage.sun.beans.infos"']
  jreCodeBase = 'file:${java.home}/../lib/*'
  neededPermissions = {}
  neededPermissions.update( { jreCodeBase: jrePermissions } )
  updateServerPolicyFile(profileRoot, "JDK classes like Swing need access to classes in sun.* packages", neededPermissions)
  allPermissions = ['java.security.AllPermission']
  neededPermissions = {}
  neededPermissions.update( { 'file:' + dbJDBCClasspath + '/-': allPermissions[:] } )
  neededPermissions.update( { 'file:${was.install.root}/BPM/Lombardi/lib/*': allPermissions[:] } )
  neededPermissions.update( { 'file:${was.install.root}/BPM/Lombardi/process-server/lib/*': allPermissions[:] } )
  neededPermissions.update( { 'file:${was.install.root}/BPM/Lombardi/performance-data-warehouse/lib/*': allPermissions[:] } )
  updateServerPolicyFile(profileRoot, "Needed by Business Process Manager", neededPermissions)
#enddef

