-- BEGIN COPYRIGHT
-- *************************************************************************
-- Licensed Materials - Property of IBM 
-- 5724-L01, 5655-N53, 5724-I82, 5655-R15
-- (C) Copyright IBM Corporation 2010. All rights reserved. 
-- US Government Users Restricted Rights - Use, duplication, or disclosure
-- restricted by GSA ADP Schedule Contract with IBM Corp.
-- *************************************************************************
-- END COPYRIGHT
--






@README@
-- This string was intentionally added to the the SQL file
-- as this script can not be executed directly.  The
-- Database Design Tool should be used to generated versions
-- of this script which can be executed successfully.  See
-- the Information Center for more information on using the
-- Database Design Tool
@README@









if not exists (select name from sysobjects where name = 'LSW_METRIC')
CREATE  TABLE LSW_METRIC(
METRIC_ID UNIQUEIDENTIFIER NOT NULL,
UNIT DECIMAL(38,0) NOT NULL,
ROLLUP_METRIC_REF UNIQUEIDENTIFIER,
ROLLUP_MULTIPLIER DECIMAL(20, 8),
XML_DATA IMAGE,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_SLA')
CREATE  TABLE LSW_SLA(
SLA_ID UNIQUEIDENTIFIER NOT NULL,
ITEM_TYPES DECIMAL(38,0) NOT NULL,
XML_DATA IMAGE NOT NULL,
PARTICIPANT_REF UNIQUEIDENTIFIER,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_SIM_SCENARIO')
CREATE  TABLE LSW_SIM_SCENARIO(
SCENARIO_ID UNIQUEIDENTIFIER NOT NULL,
XML_DATA IMAGE NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_HIST_SCENARIO')
CREATE  TABLE LSW_HIST_SCENARIO(
SCENARIO_ID UNIQUEIDENTIFIER NOT NULL,
XML_DATA IMAGE NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_EVENT_SUBSCRIPTION')
CREATE  TABLE BPM_EVENT_SUBSCRIPTION(
EVENT_SUBSCRIPTION_ID UNIQUEIDENTIFIER NOT NULL,
EVENT_SUBSCRIPTION_TYPE_ID DECIMAL(2, 0) NOT NULL,
SERVER_NAME NVARCHAR(256),
EVENT_CLASS NVARCHAR(256),
OBJECT_TYPE_ID NVARCHAR(256),
OBJECT_TYPE_ID_DISPLAY_NAME NVARCHAR(256),
EVENT_TYPE NVARCHAR(256),
INCLUDE_SUB_TYPE NCHAR(1) DEFAULT 'F',
PROCESS_REF UNIQUEIDENTIFIER,
PARTICIPANT_REF UNIQUEIDENTIFIER,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_EVENT_SUBSCRIPTION_TYPE')
CREATE  TABLE BPM_EVENT_SUBSCRIPTION_TYPE(
EVENT_SUBSCRIPTION_TYPE_ID DECIMAL(2, 0) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT)
;


if not exists (select name from sysobjects where name = 'LSW_STAY_ON_PAGE')
CREATE  TABLE LSW_STAY_ON_PAGE(
STAY_ON_PAGE_ID UNIQUEIDENTIFIER NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_PROC_ARTIFACT_REF')
CREATE  TABLE BPM_PROC_ARTIFACT_REF(
PROC_ARTIFACT_REF_ID UNIQUEIDENTIFIER NOT NULL,
PROCESS_ID UNIQUEIDENTIFIER NOT NULL,
ARTIFACT_REF UNIQUEIDENTIFIER NOT NULL,
ARTIFACT_ID UNIQUEIDENTIFIER NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_CLS_ARTIFACT_REF')
CREATE  TABLE BPM_CLS_ARTIFACT_REF(
CLS_ARTIFACT_REF_ID UNIQUEIDENTIFIER NOT NULL,
CLASS_ID UNIQUEIDENTIFIER NOT NULL,
ARTIFACT_REF UNIQUEIDENTIFIER NOT NULL,
ARTIFACT_ID UNIQUEIDENTIFIER NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_BPD_ARTIFACT_REF')
CREATE  TABLE BPM_BPD_ARTIFACT_REF(
BPD_ARTIFACT_REF_ID UNIQUEIDENTIFIER NOT NULL,
BPD_ID UNIQUEIDENTIFIER NOT NULL,
ARTIFACT_REF UNIQUEIDENTIFIER NOT NULL,
ARTIFACT_ID UNIQUEIDENTIFIER NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_BPD')
CREATE  TABLE LSW_BPD(
BPD_ID UNIQUEIDENTIFIER NOT NULL,
DATA IMAGE NOT NULL,
IS_TRACKING_ENABLED NCHAR(1) NOT NULL,
IS_SPC_ENABLED NCHAR(1) NOT NULL,
RESTRICTED_NAME NVARCHAR(64),
IS_CRITICAL_PATH_ENABLED NCHAR(1) DEFAULT 'T' NOT NULL,
PARTICIPANT_REF UNIQUEIDENTIFIER,
BUSINESS_DATA_PARTICIPANT_REF UNIQUEIDENTIFIER,
PERF_METRIC_PARTICIPANT_REF UNIQUEIDENTIFIER,
TIME_SCHEDULE_TYPE DECIMAL(2, 0) DEFAULT 0,
TIME_SCHEDULE_NAME NVARCHAR(64),
TIME_SCHEDULE_EXPRESSION NVARCHAR(64),
HOLIDAY_SCHEDULE_TYPE DECIMAL(2, 0) DEFAULT 0,
HOLIDAY_SCHEDULE_NAME NVARCHAR(64),
HOLIDAY_SCHEDULE_EXPRESSION NVARCHAR(64),
TIMEZONE_TYPE DECIMAL(2, 0) DEFAULT 0,
TIMEZONE NVARCHAR(64),
TIMEZONE_EXPRESSION NVARCHAR(64),
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
TYPE DECIMAL(2, 0),
ROOT_BPD_ID UNIQUEIDENTIFIER,
PARENT_BPD_ID UNIQUEIDENTIFIER,
PARENT_FLOW_OBJECT_ID NVARCHAR(128),
XML_DATA IMAGE,
TEMPLATE_ID UNIQUEIDENTIFIER,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_BPD_EVENT')
CREATE  TABLE LSW_BPD_EVENT(
BPD_EVENT_ID UNIQUEIDENTIFIER NOT NULL,
UCA_REF UNIQUEIDENTIFIER NOT NULL,
UCA_ID UNIQUEIDENTIFIER NOT NULL,
BPD_ID UNIQUEIDENTIFIER NOT NULL,
BPD_FLOW_OBJECT_ID NVARCHAR(128) NOT NULL,
BPD_OBJECT_ID NVARCHAR(128) NOT NULL,
EVENT_TYPE DECIMAL(2, 0) NOT NULL,
CORRELATION_PARAMETER_ID UNIQUEIDENTIFIER NOT NULL,
DURABLE_SUBSCRIPTION NCHAR(1) DEFAULT 'T' NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_BPD_PARAMETER')
CREATE  TABLE LSW_BPD_PARAMETER(
BPD_PARAMETER_ID UNIQUEIDENTIFIER NOT NULL,
BPD_ID UNIQUEIDENTIFIER NOT NULL,
PARAMETER_TYPE DECIMAL(2, 0) NOT NULL,
IS_ARRAY_OF NCHAR(1) NOT NULL,
CLASS_ID UNIQUEIDENTIFIER NOT NULL,
SEQ DECIMAL(38,0) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DOCUMENTATION NTEXT,
HAS_DEFAULT NCHAR(1),
DEFAULT_VALUE IMAGE,
IS_READ_ONLY NCHAR(1) DEFAULT 'F' NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_SHARED_OBJECT')
CREATE  TABLE BPM_SHARED_OBJECT(
DEFINITION_VERSION_ID UNIQUEIDENTIFIER NOT NULL,
OBJECT_ID UNIQUEIDENTIFIER NOT NULL,
DEFINITION_VERSION DECIMAL(38,0) NOT NULL,
CLASS_VERSION_ID UNIQUEIDENTIFIER NOT NULL,
BPD_INSTANCE_ID DECIMAL(38,0),
TASK_ID DECIMAL(38,0),
CREATED_BY_USER_ID DECIMAL(38,0) NOT NULL,
CREATED_ON DATETIME NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_SHARED_OBJECT_INSTANCE')
CREATE  TABLE BPM_SHARED_OBJECT_INSTANCE(
INSTANCE_VERSION_ID UNIQUEIDENTIFIER NOT NULL,
INSTANCE_VERSION DECIMAL(38,0) NOT NULL,
DEFINITION_VERSION_ID UNIQUEIDENTIFIER NOT NULL,
JDATA IMAGE,
CREATED_BY_USER_ID DECIMAL(38,0) NOT NULL,
CREATED_ON DATETIME NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_SHARED_OBJECT_VALUE')
CREATE  TABLE BPM_SHARED_OBJECT_VALUE(
VALUE_ID UNIQUEIDENTIFIER NOT NULL,
INSTANCE_VERSION_ID UNIQUEIDENTIFIER NOT NULL,
FIELD_PATH NVARCHAR(1024) NOT NULL,
VALUE IMAGE NOT NULL,
PRIOR_VALUE IMAGE NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_COACH_VIEW')
CREATE  TABLE BPM_COACH_VIEW(
COACH_VIEW_ID UNIQUEIDENTIFIER NOT NULL,
IS_TEMPLATE NCHAR(1),
LAYOUT IMAGE,
PALETTE_ICON UNIQUEIDENTIFIER,
PREVIEW_IMAGE UNIQUEIDENTIFIER,
HAS_LABEL NCHAR(1),
LABEL_POSITION DECIMAL(2, 0),
NINE_SLICE_X1_COORD DECIMAL(5, 0),
NINE_SLICE_X2_COORD DECIMAL(5, 0),
NINE_SLICE_Y1_COORD DECIMAL(5, 0),
NINE_SLICE_Y2_COORD DECIMAL(5, 0),
EMIT_BOUNDARY NCHAR(1),
LOAD_JS_FUNCTION NTEXT,
UNLOAD_JS_FUNCTION NTEXT,
VIEW_JS_FUNCTION NTEXT,
CHANGE_JS_FUNCTION NTEXT,
COLLABORATION_JS_FUNCTION NTEXT,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
VALIDATE_JS_FUNCTION NTEXT,
USE_URL_BINDING NCHAR(1) DEFAULT 'F',
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_COACH_VIEW_LOCAL_RES')
CREATE  TABLE BPM_COACH_VIEW_LOCAL_RES(
COACH_VIEW_LOCAL_RES_ID UNIQUEIDENTIFIER NOT NULL,
COACH_VIEW_ID UNIQUEIDENTIFIER NOT NULL,
RESOURCE_BUNDLE_GROUP_ID UNIQUEIDENTIFIER NOT NULL,
SEQ DECIMAL(38,0),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_COACH_VIEW_BINDING_TYPE')
CREATE  TABLE BPM_COACH_VIEW_BINDING_TYPE(
COACH_VIEW_BINDING_TYPE_ID UNIQUEIDENTIFIER NOT NULL,
COACH_VIEW_ID UNIQUEIDENTIFIER NOT NULL,
IS_LIST NCHAR(1),
CLASS_ID UNIQUEIDENTIFIER,
SEQ DECIMAL(38,0),
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_COACH_VIEW_CONFIG_OPTION')
CREATE  TABLE BPM_COACH_VIEW_CONFIG_OPTION(
COACH_VIEW_CONFIG_OPTION_ID UNIQUEIDENTIFIER NOT NULL,
COACH_VIEW_ID UNIQUEIDENTIFIER NOT NULL,
IS_LIST NCHAR(1),
PROPERTY_TYPE NVARCHAR(64),
LABEL NVARCHAR(64),
CLASS_ID UNIQUEIDENTIFIER,
PROCESS_ID UNIQUEIDENTIFIER,
SEQ DECIMAL(38,0),
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GROUP_NAME NVARCHAR(64),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_COACH_VIEW_RESOURCE')
CREATE  TABLE BPM_COACH_VIEW_RESOURCE(
COACH_VIEW_RESOURCE_ID UNIQUEIDENTIFIER NOT NULL,
COACH_VIEW_ID UNIQUEIDENTIFIER NOT NULL,
FILE_PATH NVARCHAR(255),
IE_CONDITION NVARCHAR(1024),
MEDIA_QUERY NVARCHAR(1024),
ASSET_UUID UNIQUEIDENTIFIER,
SEQ DECIMAL(38,0),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_COACH_VIEW_INLINE_SCRIPT')
CREATE  TABLE BPM_COACH_VIEW_INLINE_SCRIPT(
COACH_VIEW_INLINE_SCRIPT_ID UNIQUEIDENTIFIER NOT NULL,
COACH_VIEW_ID UNIQUEIDENTIFIER NOT NULL,
SCRIPT_TYPE NVARCHAR(64),
SCRIPT_BLOCK NTEXT,
SEQ DECIMAL(38,0),
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_COACH_VIEW_AMD_DEP')
CREATE  TABLE BPM_COACH_VIEW_AMD_DEP(
COACH_VIEW_AMD_DEP_ID UNIQUEIDENTIFIER NOT NULL,
COACH_VIEW_ID UNIQUEIDENTIFIER NOT NULL,
MODULE_ID NVARCHAR(1024),
FUNCTION_ARGUMENT NVARCHAR(255),
SEQ DECIMAL(38,0),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_COACHNG')
CREATE  TABLE BPM_COACHNG(
COACHNG_ID UNIQUEIDENTIFIER NOT NULL,
TITLE NVARCHAR(64),
LAYOUT_DATA IMAGE,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_COACHNG_BOUNDARY_EVENT')
CREATE  TABLE BPM_COACHNG_BOUNDARY_EVENT(
COACHNG_BOUNDARY_EVENT_ID UNIQUEIDENTIFIER NOT NULL,
COACHNG_ID UNIQUEIDENTIFIER NOT NULL,
SEQ DECIMAL(38,0) NOT NULL,
END_STATE_ID NVARCHAR(128) NOT NULL,
EVENT_LABEL NTEXT,
VIEW_PATH NTEXT,
IS_VALIDATE_BOUNDARY_EVENT NCHAR(1) DEFAULT 'F',
FIRE_VALIDATION DECIMAL(1, 0) DEFAULT 0,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_COACH')
CREATE  TABLE LSW_COACH(
COACH_ID UNIQUEIDENTIFIER NOT NULL,
TITLE NVARCHAR(64),
LAYOUT_REF UNIQUEIDENTIFIER,
LAYOUT_DATA NTEXT,
XSL_REF UNIQUEIDENTIFIER,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_COACH_BUTTON')
CREATE  TABLE LSW_COACH_BUTTON(
COACH_BUTTON_ID UNIQUEIDENTIFIER NOT NULL,
COACH_ID UNIQUEIDENTIFIER NOT NULL,
SEQ DECIMAL(38,0) NOT NULL,
END_STATE_ID NVARCHAR(128) NOT NULL,
IS_SPECIAL NCHAR(1),
IS_DISPLAYED NCHAR(1),
BUTTON_LABEL NVARCHAR(64),
BUTTON_HINT NVARCHAR(255),
BUTTON_TEXT NTEXT,
BUTTON_EXPRESSION NVARCHAR(64),
IS_CHECK_BOX_VISIBLE NCHAR(1),
IS_UNCHECK_ALLOWED NCHAR(1),
META_DATA IMAGE,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_COACH_RESOURCE')
CREATE  TABLE LSW_COACH_RESOURCE(
COACH_RESOURCE_ID UNIQUEIDENTIFIER NOT NULL,
COACH_ID UNIQUEIDENTIFIER NOT NULL,
VIRTUAL_NAME NVARCHAR(100) NOT NULL,
TYPE NVARCHAR(64) NOT NULL,
RESOURCE_DATA IMAGE,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_INFOPATH_FORM')
CREATE  TABLE LSW_INFOPATH_FORM(
INFOPATH_FORM_ID UNIQUEIDENTIFIER NOT NULL,
URL NVARCHAR(1024),
TEMPLATE_VERSION NVARCHAR(32),
DATA_SOURCE_CLASS_REF UNIQUEIDENTIFIER,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_EM_TASK')
CREATE  TABLE LSW_EM_TASK(
TASK_ID DECIMAL(38,0) NOT NULL,
DESCRIPTION NVARCHAR(120),
QUEUE_ID DECIMAL(38,0),
SCHEDULED_TIME DATETIME NOT NULL,
DISCRIMINATOR DECIMAL(12, 0) IDENTITY,
TASK_STATUS DECIMAL(38,0),
TASK_OWNER DECIMAL(38,0),
BLACKOUT_CALENDAR_ID DECIMAL(38,0),
BLACKOUT_BEHAVIOR DECIMAL(38,0),
TASK_EXECUTION_CLASS NVARCHAR(120) NOT NULL,
TASK_ARGUMENTS_STR NVARCHAR(1000),
TASK_ARGUMENTS IMAGE,
REPEAT_STRING NVARCHAR(512),
IN_CLOSING_TRANSACTION DECIMAL(1, 0),
RE_EXECUTE_COUNT DECIMAL(38,0),
LAST_SCHEDULED_TIME DATETIME,
LAST_EXECUTION_TIME DATETIME)
;


if not exists (select name from sysobjects where name = 'LSW_EM_TASK_KEYWORDS')
CREATE  TABLE LSW_EM_TASK_KEYWORDS(
TASK_ID DECIMAL(38,0) NOT NULL,
KEYWORD NVARCHAR(120) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_EM_INSTANCE')
CREATE  TABLE LSW_EM_INSTANCE(
OWNER_ID DECIMAL(38,0) NOT NULL,
NAME NVARCHAR(50) NOT NULL,
EXPIRATION DATETIME,
STATUS DECIMAL(38,0))
;


if not exists (select name from sysobjects where name = 'LSW_EM_TASK_HISTORY')
CREATE  TABLE LSW_EM_TASK_HISTORY(
TASK_ID DECIMAL(38,0) NOT NULL,
EXECUTION_ATTEMPT DECIMAL(38,0) NOT NULL,
SUCCESS DECIMAL(38,0),
ERROR_MESSAGE NTEXT,
DESCRIPTION NVARCHAR(120),
QUEUE_ID DECIMAL(38,0),
SCHEDULED_TIME DATETIME NOT NULL,
DISCRIMINATOR DECIMAL(38,0),
EM_NAME NVARCHAR(64),
BLACKOUT_CALENDAR_ID DECIMAL(38,0),
BLACKOUT_BEHAVIOR DECIMAL(38,0),
TASK_EXECUTION_CLASS NVARCHAR(120) NOT NULL,
TASK_ARGUMENTS IMAGE,
IN_CLOSING_TRANSACTION DECIMAL(1, 0),
EXECUTION_TIME DATETIME,
EXECUTION_DURATION DECIMAL(12, 3))
;


if not exists (select name from sysobjects where name = 'LSW_UCA_SYNC_QUEUE')
CREATE  TABLE LSW_UCA_SYNC_QUEUE(
SYNC_QUEUE_ID DECIMAL(38,0) NOT NULL,
DESCRIPTION NVARCHAR(450),
QUEUE_OWNER DECIMAL(38,0))
;


if not exists (select name from sysobjects where name = 'LSW_ENV_VAR_SET')
CREATE  TABLE LSW_ENV_VAR_SET(
ENV_VAR_SET_ID UNIQUEIDENTIFIER NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_ENV_VAR')
CREATE  TABLE LSW_ENV_VAR(
ENV_VAR_ID UNIQUEIDENTIFIER NOT NULL,
ENV_VAR_SET_ID UNIQUEIDENTIFIER NOT NULL,
ENV_VAR_TYPE_ID DECIMAL(2, 0) NOT NULL,
DEFAULT_VALUE NTEXT,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_ENV_VAR_VAL')
CREATE  TABLE LSW_ENV_VAR_VAL(
ENV_VAR_VAL_ID DECIMAL(38,0) NOT NULL,
BRANCH_ID UNIQUEIDENTIFIER,
SNAPSHOT_ID UNIQUEIDENTIFIER,
TIP NCHAR(1),
ENV_VAR_ID UNIQUEIDENTIFIER NOT NULL,
VALUE NTEXT,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_ENV_TYPE')
CREATE  TABLE LSW_ENV_TYPE(
ENV_TYPE_ID DECIMAL(2, 0) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT)
;


if not exists (select name from sysobjects where name = 'LSW_ENV_VAR_TYPE')
CREATE  TABLE LSW_ENV_VAR_TYPE(
ENV_VAR_TYPE_ID DECIMAL(2, 0) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT)
;


if not exists (select name from sysobjects where name = 'LSW_ENV_VAR_DEFAULT')
CREATE  TABLE LSW_ENV_VAR_DEFAULT(
ENV_VAR_DEFAULT_ID UNIQUEIDENTIFIER NOT NULL,
ENV_TYPE_ID DECIMAL(2, 0) NOT NULL,
ENV_VAR_ID UNIQUEIDENTIFIER NOT NULL,
VALUE NTEXT NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_EPV')
CREATE  TABLE LSW_EPV(
EPV_ID UNIQUEIDENTIFIER NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
EXT_DESCRIPTION NTEXT,
FEEDBACK NVARCHAR(255),
PARTICIPANT_REF UNIQUEIDENTIFIER,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL,
LAST_MODIFIED DATETIME NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_EPV_VAR')
CREATE  TABLE LSW_EPV_VAR(
EPV_VAR_ID UNIQUEIDENTIFIER NOT NULL,
EPV_ID UNIQUEIDENTIFIER NOT NULL,
NAME NVARCHAR(64) NOT NULL,
VAR_NAME NVARCHAR(64) NOT NULL,
EXT_DESCRIPTION NTEXT,
VARIABLE_TYPE_REF UNIQUEIDENTIFIER NOT NULL,
DEFAULT_VALUE NVARCHAR(255),
IS_CHG_ACTIVE_PROC NCHAR(1),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_EPV_VAR_VALUE')
CREATE  TABLE LSW_EPV_VAR_VALUE(
EPV_VAR_VALUE_ID DECIMAL(38,0) NOT NULL,
SNAPSHOT_ID UNIQUEIDENTIFIER,
TIP NCHAR(1),
BRANCH_ID UNIQUEIDENTIFIER,
EPV_VAR_ID UNIQUEIDENTIFIER NOT NULL,
EFFECTIVE_ON DATETIME NOT NULL,
VALUE NTEXT,
REASON NTEXT,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_BLUEPRINT_SUBSCRIPTION')
CREATE  TABLE LSW_BLUEPRINT_SUBSCRIPTION(
BLUEPRINT_SUBSCRIPTION_ID UNIQUEIDENTIFIER NOT NULL,
PROCESS_ID NVARCHAR(25) NOT NULL,
BLUEPRINT_ID NVARCHAR(25) NOT NULL,
ROOT_BPD_ID UNIQUEIDENTIFIER NOT NULL,
ACCOUNT NVARCHAR(255),
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_EXTACT_PARAMETER')
CREATE  TABLE LSW_EXTACT_PARAMETER(
EA_PARAMETER_ID UNIQUEIDENTIFIER NOT NULL,
EXTERNAL_ACTIVITY_ID UNIQUEIDENTIFIER NOT NULL,
PARAMETER_TYPE DECIMAL(2, 0) NOT NULL,
SEQ DECIMAL(38,0) NOT NULL,
NAME NVARCHAR(255) NOT NULL,
DESCRIPTION NTEXT,
CLASS_REF UNIQUEIDENTIFIER NOT NULL,
IS_ARRAY_OF NCHAR(1) NOT NULL,
HAS_DEFAULT NCHAR(1) NOT NULL,
DEFAULT_VALUE IMAGE,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_EXTACT_PROPERTY')
CREATE  TABLE LSW_EXTACT_PROPERTY(
EA_PROPERTY_ID UNIQUEIDENTIFIER NOT NULL,
EXTERNAL_ACTIVITY_ID UNIQUEIDENTIFIER NOT NULL,
SEQ DECIMAL(38,0) NOT NULL,
NAME NVARCHAR(255) NOT NULL,
VALUE NVARCHAR(255) NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_EXTERNAL_ACTIVITY')
CREATE  TABLE LSW_EXTERNAL_ACTIVITY(
EXTERNAL_ACTIVITY_ID UNIQUEIDENTIFIER NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_MANAGED_ASSET')
CREATE  TABLE LSW_MANAGED_ASSET(
MANAGED_ASSET_ID UNIQUEIDENTIFIER NOT NULL,
ASSET_UUID UNIQUEIDENTIFIER,
MIME_TYPE NVARCHAR(100) DEFAULT 'application/octet-stream',
CHAR_ENCODING NVARCHAR(100) DEFAULT 'UTF-8',
ASSET_TYPE_CODE NVARCHAR(1) DEFAULT 'W' NOT NULL,
LENGTH DECIMAL(38,0),
LOCAL_LAST_MODIFICATION DECIMAL(38,0),
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
IS_DOCUMENTATION_FILE NCHAR(1) DEFAULT 'F' NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_MANAGED_ASSET_DATA')
CREATE  TABLE LSW_MANAGED_ASSET_DATA(
ASSET_DATA_ID UNIQUEIDENTIFIER NOT NULL,
ASSET_DATA IMAGE)
;


if not exists (select name from sysobjects where name = 'BPM_CONTRIBUTION')
CREATE  TABLE BPM_CONTRIBUTION(
CONTRIBUTION_ID UNIQUEIDENTIFIER NOT NULL,
FILENAME NVARCHAR(1024) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
CREATED_BY_USER_ID DECIMAL(38,0) NOT NULL,
CREATED_ON DATETIME NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_CTRB_PROPERTY')
CREATE  TABLE BPM_CTRB_PROPERTY(
PROPERTY_ID UNIQUEIDENTIFIER NOT NULL,
CONTRIBUTION_ID UNIQUEIDENTIFIER NOT NULL,
PROP_VALUE NVARCHAR(1000),
PROP_TYPE_CODE DECIMAL(8, 0) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_CTRB_DEPENDENCY')
CREATE  TABLE BPM_CTRB_DEPENDENCY(
CTRB_DEPENDENCY_ID UNIQUEIDENTIFIER NOT NULL,
LIBRARY_NAME NVARCHAR(1024) NOT NULL,
CONTRIBUTION_ID UNIQUEIDENTIFIER NOT NULL,
CONTRIBUTION_REF UNIQUEIDENTIFIER,
DEPLOY_WITH NCHAR(1) NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_ARTIFACT')
CREATE  TABLE BPM_ARTIFACT(
ARTIFACT_ID UNIQUEIDENTIFIER NOT NULL,
ART_DATA_UUID UNIQUEIDENTIFIER,
CONTRIBUTION_ID UNIQUEIDENTIFIER NOT NULL,
MEDIA_TYPE NVARCHAR(100) DEFAULT 'application/octet-stream',
CHAR_ENCODING NVARCHAR(100) DEFAULT 'UTF-8',
LENGTH DECIMAL(38,0),
FULL_PATH NVARCHAR(1024) NOT NULL,
DIGEST NVARCHAR(45) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
CREATED_BY_USER_ID DECIMAL(38,0) NOT NULL,
CREATED_ON DATETIME NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_ARTIFACT_DATA')
CREATE  TABLE BPM_ARTIFACT_DATA(
ART_DATA_ID UNIQUEIDENTIFIER NOT NULL,
ART_DATA IMAGE)
;


if not exists (select name from sysobjects where name = 'BPM_MON_MODEL_DATA')
CREATE  TABLE BPM_MON_MODEL_DATA(
MM_ID UNIQUEIDENTIFIER NOT NULL,
NAME NVARCHAR(128) NOT NULL,
DATA IMAGE)
;


if not exists (select name from sysobjects where name = 'LSW_SAVED_SEARCHES')
CREATE  TABLE LSW_SAVED_SEARCHES(
SEARCH_ID DECIMAL(38,0) NOT NULL,
SEARCH_NAME NVARCHAR(30) NOT NULL,
QUERY NTEXT NOT NULL,
USER_ID DECIMAL(38,0))
;


if not exists (select name from sysobjects where name = 'LSW_INSTALLATION')
CREATE  TABLE LSW_INSTALLATION(
INSTALLATION_ID UNIQUEIDENTIFIER NOT NULL,
SNAPSHOT_ID UNIQUEIDENTIFIER NOT NULL,
STATUS DECIMAL(2, 0) NOT NULL,
DETAILS IMAGE)
;


if not exists (select name from sysobjects where name = 'LSW_RELEASE')
CREATE  TABLE LSW_RELEASE(
RELEASE_ID UNIQUEIDENTIFIER NOT NULL,
CREATED_BY_USER_ID DECIMAL(38,0) NOT NULL,
CREATED_ON DATETIME NOT NULL,
SNAPSHOT_ID UNIQUEIDENTIFIER NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_USER_FAVORITE')
CREATE  TABLE LSW_USER_FAVORITE(
FAVORITE_ID UNIQUEIDENTIFIER NOT NULL,
USER_ID DECIMAL(38,0) NOT NULL,
PO_TYPE DECIMAL(8, 0) NOT NULL,
PO_ID UNIQUEIDENTIFIER NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_SMART_FOLDER')
CREATE  TABLE LSW_SMART_FOLDER(
SMART_FOLDER_ID DECIMAL(38,0) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
SHARED NCHAR(1) DEFAULT 'F',
LIVE NCHAR(1) DEFAULT 'F',
INCLUDE_TK NCHAR(1) DEFAULT 'F',
DATA IMAGE,
SNAPSHOT_ID UNIQUEIDENTIFIER NOT NULL,
CREATED_BY_USER_ID DECIMAL(38,0) NOT NULL,
CREATED_ON DATETIME NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_CA_TEMPLATE')
CREATE  TABLE LSW_CA_TEMPLATE(
ID DECIMAL(38,0) NOT NULL,
NAME NVARCHAR(128) NOT NULL,
BPD_GUID NVARCHAR(128) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_CA_TEMPLATE_DATA')
CREATE  TABLE LSW_CA_TEMPLATE_DATA(
ID DECIMAL(38,0) NOT NULL,
CA_GUID NVARCHAR(128) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_LAUNCHER')
CREATE  TABLE LSW_LAUNCHER(
LAUNCHER_ID UNIQUEIDENTIFIER NOT NULL,
SEQ DECIMAL(38,0) NOT NULL,
USER_ID DECIMAL(38,0) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NVARCHAR(255),
CMD NVARCHAR(1000) NOT NULL,
CMD_TYPE DECIMAL(38,0))
;


if not exists (select name from sysobjects where name = 'LSW_BREAKPOINT')
CREATE  TABLE LSW_BREAKPOINT(
BREAKPOINT_ID UNIQUEIDENTIFIER NOT NULL,
USER_ID DECIMAL(38,0) NOT NULL,
PROCESS_ID UNIQUEIDENTIFIER NOT NULL,
PROCESS_ITEM_ID UNIQUEIDENTIFIER NOT NULL,
PROCESS_ITEM_NAME NVARCHAR(64),
IS_CONDITION_IN_USE NCHAR(1),
CONDITION NVARCHAR(1000))
;


if not exists (select name from sysobjects where name = 'BPM_OSLC_PROVIDER')
CREATE  TABLE BPM_OSLC_PROVIDER(
PROVIDER_ID UNIQUEIDENTIFIER NOT NULL,
NAME NVARCHAR(256),
URL NVARCHAR(1024) NOT NULL,
DATA NTEXT,
CREATED_BY_USER_ID DECIMAL(38,0) NOT NULL,
CREATED_ON DATETIME NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_CLASS')
CREATE  TABLE LSW_CLASS(
CLASS_ID UNIQUEIDENTIFIER NOT NULL,
IS_SYSTEM NCHAR(1),
SHARED NCHAR(1),
LIFETIME NCHAR(1),
TYPE DECIMAL(3, 0) NOT NULL,
XML_DATA IMAGE,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_LAYOUT')
CREATE  TABLE LSW_LAYOUT(
LAYOUT_ID UNIQUEIDENTIFIER NOT NULL,
TYPE NVARCHAR(64) NOT NULL,
URL NVARCHAR(255),
DOCUMENT_TYPE NVARCHAR(64),
IMAGE_URL NVARCHAR(255),
META_DATA_LABEL NVARCHAR(255),
META_DATA_UI NVARCHAR(255),
LAYOUT_DATA IMAGE,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_LAYOUT_PARAM')
CREATE  TABLE LSW_LAYOUT_PARAM(
LAYOUT_PARAM_ID UNIQUEIDENTIFIER NOT NULL,
LAYOUT_ID UNIQUEIDENTIFIER NOT NULL,
NAME NVARCHAR(64) NOT NULL,
TYPE DECIMAL(38,0),
SEQ DECIMAL(38,0),
VALUE NVARCHAR(64),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_PROJECT_DEFAULTS')
CREATE  TABLE LSW_PROJECT_DEFAULTS(
PROJECT_DEFAULTS_ID UNIQUEIDENTIFIER NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL,
PARTICIPANT_REF UNIQUEIDENTIFIER,
DEFAULT_XSL_REF UNIQUEIDENTIFIER,
DEFAULT_CSS_REF UNIQUEIDENTIFIER,
DEFAULT_JS_REFS NVARCHAR(2000),
IS_WBM_ENABLED NCHAR(1),
NAMESPACE NVARCHAR(256),
IS_IID_OPTIMIZED NCHAR(1))
;


if not exists (select name from sysobjects where name = 'LSW_RESOURCE_BUNDLE_GROUP')
CREATE  TABLE LSW_RESOURCE_BUNDLE_GROUP(
RESOURCE_BUNDLE_GROUP_ID UNIQUEIDENTIFIER NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_RESOURCE_BUNDLE')
CREATE  TABLE LSW_RESOURCE_BUNDLE(
RESOURCE_BUNDLE_ID UNIQUEIDENTIFIER NOT NULL,
RESOURCE_BUNDLE_GROUP_ID UNIQUEIDENTIFIER NOT NULL,
LOCALE_LANGUAGE NVARCHAR(2),
LOCALE_COUNTRY NVARCHAR(2),
LOCALE_VARIANT NVARCHAR(32),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_RESOURCE_BUNDLE_KEY')
CREATE  TABLE LSW_RESOURCE_BUNDLE_KEY(
RESOURCE_BUNDLE_KEY_ID UNIQUEIDENTIFIER NOT NULL,
RESOURCE_BUNDLE_ID UNIQUEIDENTIFIER,
AKEY NVARCHAR(64) NOT NULL,
VALUE NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_SCRIPT')
CREATE  TABLE LSW_SCRIPT(
SCRIPT_ID UNIQUEIDENTIFIER NOT NULL,
SCRIPT_TYPE_ID DECIMAL(38,0),
IS_ACTIVE NCHAR(1),
IS_RULE NCHAR(1),
SCRIPT IMAGE,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_SERVER')
CREATE  TABLE LSW_SERVER(
CREATED_BY_USER_ID DECIMAL(38,0) NOT NULL,
CREATED_ON DATETIME NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL,
SERVER_ID UNIQUEIDENTIFIER NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
ADDRESS NVARCHAR(128),
PROVIDER_URL NVARCHAR(500) NOT NULL,
PORT NVARCHAR(5) NOT NULL,
IS_OFFLINE NCHAR(1) DEFAULT '0',
LAST_HEARTBEAT DATETIME,
IS_AVAILABLE NCHAR(1) DEFAULT '0',
TYPE DECIMAL(38,0) DEFAULT 0,
USER_NAME NVARCHAR(50),
PASSWORD NVARCHAR(250),
IS_ENCRYPTED NCHAR(1) DEFAULT '0',
INSTALLER_GROUP_ID DECIMAL(38,0))
;


if not exists (select name from sysobjects where name = 'LSW_DEPLOYMENT')
CREATE  TABLE LSW_DEPLOYMENT(
DEPLOYMENT_ID UNIQUEIDENTIFIER NOT NULL,
CREATED_BY_USER_ID DECIMAL(38,0) NOT NULL,
CREATED_ON DATETIME NOT NULL,
SNAPSHOT_ID UNIQUEIDENTIFIER NOT NULL,
SERVER_ID UNIQUEIDENTIFIER NOT NULL,
INSTANCE_COUNT DECIMAL(38,0) DEFAULT 0,
STATUS NVARCHAR(64),
STATE DECIMAL(2, 0) DEFAULT 0 NOT NULL,
STATUS_DESCRIPTION NVARCHAR(250))
;


if not exists (select name from sysobjects where name = 'LSW_SERVER_CAPABILITY')
CREATE  TABLE LSW_SERVER_CAPABILITY(
SERVER_CAPABILITY_ID UNIQUEIDENTIFIER NOT NULL,
SERVER_ID UNIQUEIDENTIFIER NOT NULL,
CAPABILITY_TYPE NVARCHAR(64) NOT NULL,
CAPABILITY_VERSION NVARCHAR(64) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_CAPABILITY_TYPE')
CREATE  TABLE LSW_CAPABILITY_TYPE(
CAPABILITY_TYPE_ID DECIMAL(2, 0) NOT NULL,
CAPABILITY_CONFIG_ID NVARCHAR(64) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
IS_OPTIONAL NCHAR(1) DEFAULT '0')
;


if not exists (select name from sysobjects where name = 'LSW_DEPLOYMENT_PACKAGE')
CREATE  TABLE LSW_DEPLOYMENT_PACKAGE(
SNAPSHOT_ID UNIQUEIDENTIFIER,
SERVER_ID UNIQUEIDENTIFIER NOT NULL,
DEPLOYMENT_PACKAGE IMAGE)
;


if not exists (select name from sysobjects where name = 'BPM_REGISTRATION')
CREATE  TABLE BPM_REGISTRATION(
REG_ID UNIQUEIDENTIFIER NOT NULL,
PC_URL NVARCHAR(256) NOT NULL,
PC_ID UNIQUEIDENTIFIER NOT NULL,
PC_NAME NVARCHAR(128) NOT NULL,
PC_VER NVARCHAR(16) NOT NULL,
REG_USER NVARCHAR(256) NOT NULL,
REGISTERED_ON DATETIME,
ACTIVE NCHAR(1) DEFAULT 'T' NOT NULL,
IS_INITIATOR NCHAR(1) DEFAULT 'T' NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_REPOSITORY_LOG')
CREATE  TABLE BPM_REPOSITORY_LOG(
REPOSITORY_LOG_ID UNIQUEIDENTIFIER NOT NULL,
PROJECT_ID UNIQUEIDENTIFIER,
ACTION_TYPE DECIMAL(8, 0) NOT NULL,
TARGET_ITEM_NAME NVARCHAR(198),
REPOSITORY_UUID UNIQUEIDENTIFIER,
CREATED_BY_USER NVARCHAR(256),
CREATED DATETIME,
PROPERTIES NTEXT)
;


if not exists (select name from sysobjects where name = 'BPM_SHARED_TK_USAGES')
CREATE  TABLE BPM_SHARED_TK_USAGES(
SHARED_TK_USAGE_ID UNIQUEIDENTIFIER NOT NULL,
PROJECT_ID UNIQUEIDENTIFIER NOT NULL,
SNAPSHOT_ID UNIQUEIDENTIFIER NOT NULL,
REGISTRATION_ID UNIQUEIDENTIFIER NOT NULL,
DEPENDENT_PROJECT_NAME NVARCHAR(128) NOT NULL,
IS_TOOLKIT NCHAR(1) DEFAULT 'F' NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_SNAPSHOT_STATUS')
CREATE  TABLE BPM_SNAPSHOT_STATUS(
STATUS_ID UNIQUEIDENTIFIER NOT NULL,
STATUS NVARCHAR(64) NOT NULL,
IS_SYSTEM NCHAR(1) DEFAULT 'F' NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_PROJECT_SUBSCRIPTION')
CREATE  TABLE BPM_PROJECT_SUBSCRIPTION(
PROJECT_SUBSCRIPTION_ID UNIQUEIDENTIFIER NOT NULL,
REGISTRATION_ID UNIQUEIDENTIFIER NOT NULL,
PROJECT_ID UNIQUEIDENTIFIER NOT NULL,
SUBSCRIBED_BY DECIMAL(38,0) NOT NULL,
SUBSCRIBED_ON DATETIME NOT NULL,
STATUS NVARCHAR(64),
ACTIVE NCHAR(1) DEFAULT 'F' NOT NULL,
SHARED_BY_USER_ID NVARCHAR(256),
SHARED_ON DATETIME,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_PROJECT_SUBSCRIBED')
CREATE  TABLE BPM_PROJECT_SUBSCRIBED(
PROJECT_SUBSCRIBED_ID UNIQUEIDENTIFIER NOT NULL,
REGISTRATION_ID UNIQUEIDENTIFIER NOT NULL,
PROJECT_ID UNIQUEIDENTIFIER NOT NULL,
SUBSCRIBED_BY NVARCHAR(256) NOT NULL,
SUBSCRIBED_ON DATETIME NOT NULL,
LAST_MODIFICATION DATETIME)
;


if not exists (select name from sysobjects where name = 'BPM_PC_IDX_ACTION')
CREATE  TABLE BPM_PC_IDX_ACTION(
ACTION_ID UNIQUEIDENTIFIER NOT NULL,
PO_ID UNIQUEIDENTIFIER NOT NULL,
PO_TYPE DECIMAL(8, 0) NOT NULL,
USER_ACTION DECIMAL(8, 0) NOT NULL,
CREATED_BY_USER_ID DECIMAL(38,0) NOT NULL,
CREATED_ON DATETIME NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_PC_INDEXER')
CREATE  TABLE BPM_PC_INDEXER(
INDEXER_ID UNIQUEIDENTIFIER NOT NULL,
LAST_INDEXED_ON DATETIME NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT)
;


if not exists (select name from sysobjects where name = 'BPM_GOVERNANCE_ASSIGNMENT')
CREATE  TABLE BPM_GOVERNANCE_ASSIGNMENT(
ASSIGNMENT_ID UNIQUEIDENTIFIER NOT NULL,
PROJECT_ID UNIQUEIDENTIFIER NOT NULL,
EVENT_TYPE_ID UNIQUEIDENTIFIER NOT NULL,
GOV_SNAPSHOT_ID UNIQUEIDENTIFIER NOT NULL,
GOV_PROCESS_ID UNIQUEIDENTIFIER NOT NULL,
GOV_PROCESS_TYPE DECIMAL(8, 0) NOT NULL,
ACTIVE NCHAR(1) DEFAULT 'T' NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_GOVERNANCE_EVENT')
CREATE  TABLE BPM_GOVERNANCE_EVENT(
EVENT_TYPE_ID UNIQUEIDENTIFIER NOT NULL,
EVENT_TYPE DECIMAL(8, 0) NOT NULL,
EVENT_TYPE_NAME NVARCHAR(198) NOT NULL,
GOV_DEFAULT_SNAPSHOT_ID UNIQUEIDENTIFIER NOT NULL,
GOV_DEFAULT_PROCESS_ID UNIQUEIDENTIFIER NOT NULL,
GOV_DEFAULT_PROCESS_TYPE DECIMAL(8, 0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_PERF_DATA_TRANSFER')
CREATE  TABLE LSW_PERF_DATA_TRANSFER(
PERF_DATA_TRANSFER_ID NVARCHAR(64) NOT NULL,
DATA IMAGE NOT NULL,
TIME_CLAIMED DATETIME,
CLAIMED_BY NVARCHAR(64))
;


if not exists (select name from sysobjects where name = 'LSW_TRACKING_GROUP')
CREATE  TABLE LSW_TRACKING_GROUP(
TRACKING_GROUP_ID UNIQUEIDENTIFIER NOT NULL,
EXTERNAL_UNIQUE_ID NVARCHAR(64) NOT NULL,
IS_ENABLED NCHAR(1),
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_TRACKED_VARIABLE')
CREATE  TABLE LSW_TRACKED_VARIABLE(
TRACKED_VARIABLE_ID UNIQUEIDENTIFIER NOT NULL,
TRACKING_GROUP_ID UNIQUEIDENTIFIER NOT NULL,
EXTERNAL_UNIQUE_ID NVARCHAR(64) NOT NULL,
TYPE NVARCHAR(8) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_TRACKING_POINT')
CREATE  TABLE LSW_TRACKING_POINT(
TRACKING_POINT_ID UNIQUEIDENTIFIER NOT NULL,
TRACKING_GROUP_REF UNIQUEIDENTIFIER,
EXTERNAL_UNIQUE_ID NVARCHAR(64) NOT NULL,
OTHER_TASK_ID NVARCHAR(64),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_TRACKED_VARIABLE_USE')
CREATE  TABLE LSW_TRACKED_VARIABLE_USE(
TRACKING_VARIABLE_USE_ID UNIQUEIDENTIFIER NOT NULL,
TRACKED_VARIABLE_ID UNIQUEIDENTIFIER NOT NULL,
TRACKING_POINT_ID UNIQUEIDENTIFIER NOT NULL,
VALUE_EXPRESSION NVARCHAR(255),
IS_EXPRESSION_ENABLED NCHAR(1),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_TIMING_INTERVAL')
CREATE  TABLE LSW_TIMING_INTERVAL(
TIMING_INTERVAL_ID UNIQUEIDENTIFIER NOT NULL,
EXTERNAL_UNIQUE_ID NVARCHAR(64) NOT NULL,
INTERVAL_START NVARCHAR(8) NOT NULL,
INTERVAL_END NVARCHAR(8) NOT NULL,
XML_DATA IMAGE,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_TIMING_INTERVAL_BOUND')
CREATE  TABLE LSW_TIMING_INTERVAL_BOUND(
TIMING_INTERVAL_BOUND_ID UNIQUEIDENTIFIER NOT NULL,
TIMING_INTERVAL_ID UNIQUEIDENTIFIER NOT NULL,
TRACKING_POINT_EUID NVARCHAR(64) NOT NULL,
BOUND NVARCHAR(8) NOT NULL,
BPD_REF UNIQUEIDENTIFIER,
PROCESS_REF UNIQUEIDENTIFIER,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_ECM_CONNECTOR')
CREATE  TABLE BPM_ECM_CONNECTOR(
ECM_CONNECTOR_ID UNIQUEIDENTIFIER NOT NULL,
DEFINITION IMAGE NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_ILOG_DECISION')
CREATE  TABLE LSW_ILOG_DECISION(
ILOG_DECISION_ID UNIQUEIDENTIFIER NOT NULL,
DEFINITION IMAGE NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_SCA_CONNECTOR')
CREATE  TABLE LSW_SCA_CONNECTOR(
SCA_CONNECTOR_ID UNIQUEIDENTIFIER NOT NULL,
MODULE_NAME NVARCHAR(256),
EXPORT_NAME NVARCHAR(256),
MODULE_VERSION NVARCHAR(32),
OPERATION_NAME NVARCHAR(256),
LAST_SYNCHRONIZED NVARCHAR(128),
IS_ASYNC_INVOCATION NCHAR(1),
OPERATION_STYLE DECIMAL(1, 0),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_STEP')
CREATE  TABLE LSW_STEP(
STEP_ID UNIQUEIDENTIFIER NOT NULL,
IS_IC_ACTIVE NCHAR(1) NOT NULL,
IC_REF UNIQUEIDENTIFIER,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_CONNECTOR')
CREATE  TABLE LSW_CONNECTOR(
CONNECTOR_ID UNIQUEIDENTIFIER NOT NULL,
IS_SYSTEM NCHAR(1) NOT NULL,
DEFINITION IMAGE NOT NULL,
CONNECTOR_TYPE DECIMAL(2, 0) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_IC')
CREATE  TABLE LSW_IC(
IC_ID UNIQUEIDENTIFIER NOT NULL,
IS_TEMPLATE NCHAR(1),
CONNECTOR_REF UNIQUEIDENTIFIER NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_JAVA_CONNECTOR')
CREATE  TABLE LSW_JAVA_CONNECTOR(
JAVA_CONNECTOR_ID UNIQUEIDENTIFIER NOT NULL,
DEFINITION IMAGE NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_WS_CONNECTOR')
CREATE  TABLE LSW_WS_CONNECTOR(
WS_CONNECTOR_ID UNIQUEIDENTIFIER NOT NULL,
DEFINITION IMAGE NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_ILOG_CONNECTOR')
CREATE  TABLE LSW_ILOG_CONNECTOR(
ILOG_CONNECTOR_ID UNIQUEIDENTIFIER NOT NULL,
DEFINITION IMAGE NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_ICMCASE_CONNECTOR')
CREATE  TABLE LSW_ICMCASE_CONNECTOR(
ICMCASE_CONNECTOR_ID UNIQUEIDENTIFIER NOT NULL,
DEFINITION IMAGE NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_EPV_PROCESS_LINK')
CREATE  TABLE LSW_EPV_PROCESS_LINK(
EPV_PROCESS_LINK_ID UNIQUEIDENTIFIER NOT NULL,
EPV_ID UNIQUEIDENTIFIER NOT NULL,
PROCESS_ID UNIQUEIDENTIFIER NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_RESOURCE_PROCESS_LINK')
CREATE  TABLE LSW_RESOURCE_PROCESS_LINK(
RESOURCE_PROCESS_LINK_ID UNIQUEIDENTIFIER NOT NULL,
RESOURCE_BUNDLE_GROUP_ID UNIQUEIDENTIFIER NOT NULL,
PROCESS_ID UNIQUEIDENTIFIER NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_EXCEPTION')
CREATE  TABLE LSW_EXCEPTION(
EXCEPTION_ID UNIQUEIDENTIFIER NOT NULL,
MESSAGE NTEXT,
ATTACHED_PROCESS_REF UNIQUEIDENTIFIER,
FAULT_STYLE DECIMAL(2, 0),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_EXIT_POINT')
CREATE  TABLE LSW_EXIT_POINT(
EXIT_POINT_ID UNIQUEIDENTIFIER NOT NULL,
HALT_PROCESS NCHAR(1),
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_TASK_SENDER_FILE')
CREATE  TABLE LSW_TASK_SENDER_FILE(
TASK_SENDER_FILE_ID UNIQUEIDENTIFIER NOT NULL,
TASK_SENDER_ID UNIQUEIDENTIFIER NOT NULL,
SEQ DECIMAL(38,0) NOT NULL,
FILE_NAME NVARCHAR(255),
IS_LOCKED NCHAR(1),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_TASK_SENDER_ADDR')
CREATE  TABLE LSW_TASK_SENDER_ADDR(
TASK_SENDER_ADDR_ID UNIQUEIDENTIFIER NOT NULL,
TASK_SENDER_ID UNIQUEIDENTIFIER NOT NULL,
SEQ DECIMAL(38,0) NOT NULL,
SEND_TO NVARCHAR(255),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_PROCESS_ITEM_PRE_POST')
CREATE  TABLE LSW_PROCESS_ITEM_PRE_POST(
PROCESS_ITEM_PRE_POST_ID UNIQUEIDENTIFIER NOT NULL,
PROCESS_ITEM_ID UNIQUEIDENTIFIER NOT NULL,
LOCATION DECIMAL(1, 0) NOT NULL,
SCRIPT IMAGE,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_PROCESS_LINK')
CREATE  TABLE LSW_PROCESS_LINK(
PROCESS_LINK_ID UNIQUEIDENTIFIER NOT NULL,
PROCESS_ID UNIQUEIDENTIFIER NOT NULL,
NAME NVARCHAR(64),
DESCRIPTION NTEXT,
FROM_PROCESS_ITEM_ID UNIQUEIDENTIFIER NOT NULL,
END_STATE_ID NVARCHAR(128) NOT NULL,
TO_PROCESS_ITEM_ID UNIQUEIDENTIFIER NOT NULL,
DATA IMAGE,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_FILE')
CREATE  TABLE LSW_FILE(
FILE_ID DECIMAL(38,0) NOT NULL,
FILE_NAME NVARCHAR(128) NOT NULL,
CONTENT_TYPE NVARCHAR(128) NOT NULL,
CREATED_BY DECIMAL(38,0) NOT NULL,
CREATED_DATE DATETIME,
FILE_DETAIL IMAGE NOT NULL,
IS_LOCKED NCHAR(1))
;


if not exists (select name from sysobjects where name = 'LSW_IC_INPUT_PROPERTY')
CREATE  TABLE LSW_IC_INPUT_PROPERTY(
IC_INPUT_PROPERTY_ID UNIQUEIDENTIFIER NOT NULL,
IC_ID UNIQUEIDENTIFIER NOT NULL,
KEY_VAL NVARCHAR(1000) NOT NULL,
NAME NVARCHAR(1000) NOT NULL,
CLASS_TYPE NVARCHAR(1024) NOT NULL,
DESCRIPTION NVARCHAR(255) NOT NULL,
VALUE IMAGE,
SEQ DECIMAL(38,0) NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_IC_OUTPUT_PROPERTY')
CREATE  TABLE LSW_IC_OUTPUT_PROPERTY(
IC_OUTPUT_PROPERTY_ID UNIQUEIDENTIFIER NOT NULL,
IC_ID UNIQUEIDENTIFIER NOT NULL,
KEY_VAL NVARCHAR(1000) NOT NULL,
NAME NVARCHAR(1000) NOT NULL,
CLASS_TYPE NVARCHAR(1024),
DESCRIPTION NVARCHAR(255),
VALUE NTEXT,
SEQ DECIMAL(38,0) NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_PARAMETER_MAPPING')
CREATE  TABLE LSW_PARAMETER_MAPPING(
PARAMETER_MAPPING_ID UNIQUEIDENTIFIER NOT NULL,
PROCESS_PARAMETER_ID UNIQUEIDENTIFIER NOT NULL,
PARENT_TYPE DECIMAL(38,0) NOT NULL,
PARENT_ID UNIQUEIDENTIFIER NOT NULL,
USE_DEFAULT NCHAR(1),
VALUE IMAGE,
CLASS_REF UNIQUEIDENTIFIER NOT NULL,
IS_LIST NCHAR(1),
IS_INPUT NCHAR(1),
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_PRIORITY')
CREATE  TABLE LSW_PRIORITY(
PRIORITY_ID DECIMAL(38,0) NOT NULL,
RANKING DECIMAL(38,0),
IS_DEFAULT NCHAR(1) DEFAULT 'F',
LEGACY_GUID NVARCHAR(128),
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT)
;


if not exists (select name from sysobjects where name = 'LSW_PROCESS')
CREATE  TABLE LSW_PROCESS(
PROCESS_ID UNIQUEIDENTIFIER NOT NULL,
IMAGE NVARCHAR(255),
TAB_GROUP NVARCHAR(255),
STARTING_PROCESS_ITEM_ID UNIQUEIDENTIFIER,
IS_ROOT_PROCESS NCHAR(1) NOT NULL,
PROCESS_TYPE DECIMAL(38,0) DEFAULT 0 NOT NULL,
DATA IMAGE,
IS_ERROR_HANDLER_ENABLED NCHAR(1) NOT NULL,
ERROR_HANDLER_ITEM_ID UNIQUEIDENTIFIER,
IS_LOGGING_VARIABLES NCHAR(1),
IS_TRANSACTIONAL NCHAR(1),
PROCESS_TIMING_LEVEL NCHAR(1),
PARTICIPANT_REF UNIQUEIDENTIFIER,
EXPOSED_TYPE DECIMAL(38,0),
IS_TRACKING_ENABLED NCHAR(1) NOT NULL,
XML_DATA IMAGE,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_PROCESS_ITEM')
CREATE  TABLE LSW_PROCESS_ITEM(
PROCESS_ITEM_ID UNIQUEIDENTIFIER NOT NULL,
PROCESS_ID UNIQUEIDENTIFIER NOT NULL,
NAME NVARCHAR(64) NOT NULL,
TWCOMPONENT_NAME NVARCHAR(80) NOT NULL,
TWCOMPONENT_ID UNIQUEIDENTIFIER NOT NULL,
IS_LOG_ENABLED NCHAR(1),
IS_TRACE_ENABLED NCHAR(1),
TRACE_CATEGORY NVARCHAR(255),
TRACE_LEVEL DECIMAL(1, 0),
TRACE_MESSAGE NTEXT,
TRACE_SYMBOL_TABLE NCHAR(4),
IS_EXEC_CONTEXT_TRACED NCHAR(1),
SAVE_EXEC_CONTEXT NCHAR(1) NOT NULL,
DOCUMENTATION NTEXT,
DATA IMAGE,
IS_ERROR_HANDLER_ENABLED NCHAR(1) NOT NULL,
ERROR_HANDLER_ITEM_ID UNIQUEIDENTIFIER,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_SUBPROCESS')
CREATE  TABLE LSW_SUBPROCESS(
SUBPROCESS_ID UNIQUEIDENTIFIER NOT NULL,
ATTACHED_PROCESS_REF UNIQUEIDENTIFIER,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_PROCESS_LABEL')
CREATE  TABLE LSW_PROCESS_LABEL(
PROCESS_LABEL_ID UNIQUEIDENTIFIER NOT NULL,
PROCESS_ID UNIQUEIDENTIFIER NOT NULL,
DESCRIPTION NTEXT,
DATA IMAGE,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_PROCESS_VARIABLE')
CREATE  TABLE LSW_PROCESS_VARIABLE(
PROCESS_VARIABLE_ID UNIQUEIDENTIFIER NOT NULL,
NAME NVARCHAR(255) NOT NULL,
DESCRIPTION NTEXT,
PROCESS_ID UNIQUEIDENTIFIER NOT NULL,
NAMESPACE DECIMAL(2, 0) NOT NULL,
SEQ DECIMAL(38,0) NOT NULL,
IS_ARRAY_OF NCHAR(1) NOT NULL,
CLASS_ID UNIQUEIDENTIFIER NOT NULL,
HAS_DEFAULT NCHAR(1) NOT NULL,
DEFAULT_VALUE IMAGE,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_PROCESS_PARAMETER')
CREATE  TABLE LSW_PROCESS_PARAMETER(
PROCESS_PARAMETER_ID UNIQUEIDENTIFIER NOT NULL,
PROCESS_ID UNIQUEIDENTIFIER NOT NULL,
PARAMETER_TYPE DECIMAL(2, 0) NOT NULL,
IS_ARRAY_OF NCHAR(1) NOT NULL,
CLASS_ID UNIQUEIDENTIFIER NOT NULL,
SEQ DECIMAL(38,0) NOT NULL,
HAS_DEFAULT NCHAR(1),
DEFAULT_VALUE IMAGE,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_SWITCH')
CREATE  TABLE LSW_SWITCH(
SWITCH_ID UNIQUEIDENTIFIER NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_SWITCH_CONDITION')
CREATE  TABLE LSW_SWITCH_CONDITION(
SWITCH_CONDITION_ID UNIQUEIDENTIFIER NOT NULL,
SWITCH_ID UNIQUEIDENTIFIER NOT NULL,
SEQ DECIMAL(38,0) NOT NULL,
END_STATE_ID NVARCHAR(128) NOT NULL,
CONDITION NVARCHAR(1000),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_TASK_SENDER')
CREATE  TABLE LSW_TASK_SENDER(
TASK_SENDER_ID UNIQUEIDENTIFIER NOT NULL,
ACTION DECIMAL(1, 0) NOT NULL,
SUBJECT NVARCHAR(255),
PRIORITY DECIMAL(38,0) NOT NULL,
IS_ORIGINAL_DATE_KEPT NCHAR(1),
DUE_IN_OPTION DECIMAL(2, 0) NOT NULL,
DUE_DATE_INCR_DATA NVARCHAR(255),
DUE_DATE_INCR_NUMBER DECIMAL(3, 0),
DUE_DATE_FIXED_DATA NVARCHAR(255),
DUE_DATE_FIXED_TIME DATETIME,
DUE_DATE_SPECIFIC_DATE NVARCHAR(255),
DUE_DATE_INCR_TYPE DECIMAL(1, 0),
ATTACHED_PROCESS_REF UNIQUEIDENTIFIER,
IS_SEND_OTHER_TASK NCHAR(1),
OTHER_TASK_ID NVARCHAR(64),
MESSAGE IMAGE,
IS_IGNORE_EXCEPTION NCHAR(1),
IS_REPARENT_TASK NCHAR(1),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_TASK_SENDER_EXVAR')
CREATE  TABLE LSW_TASK_SENDER_EXVAR(
TASK_SENDER_EXVAR_ID UNIQUEIDENTIFIER NOT NULL,
TASK_SENDER_ID UNIQUEIDENTIFIER NOT NULL,
VARIABLE_NAME NVARCHAR(255),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_REPORT')
CREATE  TABLE LSW_REPORT(
REPORT_ID UNIQUEIDENTIFIER NOT NULL,
DEFAULT_START_PAGE_ID UNIQUEIDENTIFIER,
PARTICIPANT_REF UNIQUEIDENTIFIER,
SECURITY_GROUP NVARCHAR(64),
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_REPORT_EPV_LINK')
CREATE  TABLE LSW_REPORT_EPV_LINK(
REPORT_EPV_LINK_ID UNIQUEIDENTIFIER NOT NULL,
REPORT_ID UNIQUEIDENTIFIER NOT NULL,
EPV_REF UNIQUEIDENTIFIER NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_REPORT_RBG_LINK')
CREATE  TABLE LSW_REPORT_RBG_LINK(
REPORT_RBG_LINK_ID UNIQUEIDENTIFIER NOT NULL,
REPORT_ID UNIQUEIDENTIFIER NOT NULL,
RBG_REF UNIQUEIDENTIFIER NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_REPORT_DATASOURCE')
CREATE  TABLE LSW_REPORT_DATASOURCE(
REPORT_DATASOURCE_ID UNIQUEIDENTIFIER NOT NULL,
REPORT_ID UNIQUEIDENTIFIER NOT NULL,
LAYOUT_REF UNIQUEIDENTIFIER NOT NULL,
SCRIPT IMAGE,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_REPORT_TG_LINK')
CREATE  TABLE LSW_REPORT_TG_LINK(
REPORT_TG_LINK_ID UNIQUEIDENTIFIER NOT NULL,
REPORT_ID UNIQUEIDENTIFIER NOT NULL,
TRACKING_GROUP_REF UNIQUEIDENTIFIER NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_REPORT_PAGE')
CREATE  TABLE LSW_REPORT_PAGE(
REPORT_PAGE_ID UNIQUEIDENTIFIER NOT NULL,
REPORT_ID UNIQUEIDENTIFIER NOT NULL,
HEIGHT DECIMAL(38,0) NOT NULL,
WIDTH DECIMAL(38,0) NOT NULL,
DATA IMAGE,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_REPORT_CHART')
CREATE  TABLE LSW_REPORT_CHART(
REPORT_CHART_ID UNIQUEIDENTIFIER NOT NULL,
REPORT_ID UNIQUEIDENTIFIER NOT NULL,
LAYOUT_REF UNIQUEIDENTIFIER,
DATA IMAGE,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_REPORT_VARIABLES')
CREATE  TABLE LSW_REPORT_VARIABLES(
REPORT_VARIABLES_ID UNIQUEIDENTIFIER NOT NULL,
REPORT_ID UNIQUEIDENTIFIER NOT NULL,
VALUE NVARCHAR(1000),
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_REPORT_DATASOURCE_IC_LINK')
CREATE  TABLE LSW_REPORT_DATASOURCE_IC_LINK(
REPORT_DATASOURCE_IC_LINK_ID UNIQUEIDENTIFIER NOT NULL,
REPORT_DATASOURCE_ID UNIQUEIDENTIFIER NOT NULL,
IC_REF UNIQUEIDENTIFIER NOT NULL,
POS DECIMAL(38,0) NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_REPORT_DATASOURCE_SRV_LINK')
CREATE  TABLE LSW_REPORT_DATASOURCE_SRV_LINK(
REPORT_DATASOURCE_SRV_LINK_ID UNIQUEIDENTIFIER NOT NULL,
REPORT_DATASOURCE_ID UNIQUEIDENTIFIER NOT NULL,
SERVICE_REF UNIQUEIDENTIFIER NOT NULL,
POS DECIMAL(38,0) NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_REPORT_DS_LAYOUT_LINK')
CREATE  TABLE LSW_REPORT_DS_LAYOUT_LINK(
REPORT_DS_LAYOUT_LINK_ID UNIQUEIDENTIFIER NOT NULL,
REPORT_DATASOURCE_ID UNIQUEIDENTIFIER NOT NULL,
LAYOUT_REF UNIQUEIDENTIFIER NOT NULL,
SEQ DECIMAL(38,0) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
LABEL NVARCHAR(255) NOT NULL,
DEFAULT_VALUE NVARCHAR(1000),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_SCBD')
CREATE  TABLE LSW_SCBD(
SCBD_ID UNIQUEIDENTIFIER NOT NULL,
TITLE NVARCHAR(255),
REPORT_TITLE NVARCHAR(255),
ALERT_TITLE NVARCHAR(255),
LAYOUT_REF UNIQUEIDENTIFIER NOT NULL,
PARTICIPANT_REF UNIQUEIDENTIFIER,
CSS_OVERRIDE NVARCHAR(255),
ENABLED NCHAR(1),
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_SCBD_RPT_LINK')
CREATE  TABLE LSW_SCBD_RPT_LINK(
SCBD_RPT_LINK_ID UNIQUEIDENTIFIER NOT NULL,
SCBD_ID UNIQUEIDENTIFIER NOT NULL,
REPORT_REF UNIQUEIDENTIFIER NOT NULL,
SEQ DECIMAL(38,0) NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_BLACKOUT_CALENDAR')
CREATE  TABLE LSW_BLACKOUT_CALENDAR(
CALENDAR_ID DECIMAL(38,0) NOT NULL,
IS_BLACKED_OUT DECIMAL(38,0),
NEXT_START DATETIME,
NEXT_END DATETIME)
;


if not exists (select name from sysobjects where name = 'LSW_HOLIDAY_SCHEDULE')
CREATE  TABLE LSW_HOLIDAY_SCHEDULE(
HOLIDAY_ID DECIMAL(38,0) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
HOLIDAY_LIST NVARCHAR(2000))
;


if not exists (select name from sysobjects where name = 'LSW_TIME_PERIOD')
CREATE  TABLE LSW_TIME_PERIOD(
PERIOD_ID DECIMAL(38,0) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
START_TIME NCHAR(4),
END_TIME NCHAR(4),
EFFECTIVE_DAYS NVARCHAR(1024))
;


if not exists (select name from sysobjects where name = 'LSW_TIME_SCHEDULE')
CREATE  TABLE LSW_TIME_SCHEDULE(
SCHEDULE_ID DECIMAL(38,0) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
EXCLUDE_HOLIDAY NCHAR(1) DEFAULT 'F' NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_TIME_SCHEDULE_PERIOD')
CREATE  TABLE LSW_TIME_SCHEDULE_PERIOD(
SCHEDULE_ID DECIMAL(38,0) NOT NULL,
PERIOD_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_BPD_SOAPHEADER')
CREATE  TABLE BPM_BPD_SOAPHEADER(
BPD_INSTANCE_ID DECIMAL(38,0) NOT NULL,
DATA IMAGE)
;


if not exists (select name from sysobjects where name = 'BPM_TASK_ACTIVITY_MEASURES')
CREATE  TABLE BPM_TASK_ACTIVITY_MEASURES(
TASK_MEASURES_ID DECIMAL(38,0) NOT NULL,
CREATED_BY_BPD_FLOW_OBJECT_ID NVARCHAR(512) NOT NULL,
USER_ID DECIMAL(38,0),
COMPLETION_COUNT DECIMAL(8, 0) NOT NULL,
AVG_COMPLETION_TIME DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_TASK_MARKERS')
CREATE  TABLE BPM_TASK_MARKERS(
MARKER_ID DECIMAL(38,0) NOT NULL,
TASK_ID DECIMAL(38,0),
MARKER_TYPE DECIMAL(38,0) NOT NULL,
CREATOR DECIMAL(38,0) NOT NULL,
TARGET_USER DECIMAL(38,0) NOT NULL,
MARKER_COMMENT IMAGE,
CREATED_DATE DATETIME NOT NULL,
BPD_INSTANCE_ID DECIMAL(38,0))
;


if not exists (select name from sysobjects where name = 'LSW_BPD_DOCUMENTS')
CREATE  TABLE LSW_BPD_DOCUMENTS(
DOC_ID DECIMAL(38,0) NOT NULL,
BPD_ID UNIQUEIDENTIFIER NOT NULL,
PARENT_DOC_ID DECIMAL(38,0) NOT NULL,
DOC_NAME NVARCHAR(50) NOT NULL,
FILENAME NVARCHAR(1000) NOT NULL,
DESCRIPTION NTEXT,
FILETYPE DECIMAL(4, 0) DEFAULT -1 NOT NULL,
AUTHOR_ID DECIMAL(38,0) NOT NULL,
AUTHORED_DTG DATETIME NOT NULL,
VERSION DECIMAL(4, 0) NOT NULL,
CONTENT_TYPE NVARCHAR(128),
DOCUMENT IMAGE)
;


if not exists (select name from sysobjects where name = 'LSW_BPD_INSTANCE_VARIABLES')
CREATE  TABLE LSW_BPD_INSTANCE_VARIABLES(
BPD_INST_VARS_ID DECIMAL(38,0) NOT NULL,
BPD_INSTANCE_ID DECIMAL(38,0) NOT NULL,
VARIABLE_NAME NVARCHAR(512) NOT NULL,
ALIAS NVARCHAR(512),
BOOLEAN_VALUE NCHAR(1),
STRING_VALUE NVARCHAR(512),
INT_VALUE DECIMAL(38,0),
DEC_VALUE DECIMAL(17, 2),
DATE_VALUE DATETIME,
VARIABLE_TYPE NVARCHAR(64) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_BPD_INSTANCE')
CREATE  TABLE LSW_BPD_INSTANCE(
BPD_INSTANCE_ID DECIMAL(38,0) NOT NULL,
INSTANCE_NAME NVARCHAR(512),
BPD_REF DECIMAL(38,0) NOT NULL,
CACHED_BPD_VERSION_ID UNIQUEIDENTIFIER NOT NULL,
CREATE_DATETIME DATETIME NOT NULL,
DUE_DATE DATETIME,
LAST_MODIFIED_DATETIME DATETIME NOT NULL,
SAVE_SEQ DECIMAL(38,0) NOT NULL,
EXECUTION_STATUS DECIMAL(38,0) NOT NULL,
ERROR NTEXT,
ERROR_STACK_TRACE NTEXT,
SHAREPOINT_SITE_URL NVARCHAR(512),
TIP NCHAR(1) NOT NULL,
SNAPSHOT_ID UNIQUEIDENTIFIER NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_BPD_INSTANCE_DATA')
CREATE  TABLE LSW_BPD_INSTANCE_DATA(
BPD_INSTANCE_ID DECIMAL(38,0) NOT NULL,
DATA IMAGE)
;


if not exists (select name from sysobjects where name = 'LSW_BPD_NOTIFICATION')
CREATE  TABLE LSW_BPD_NOTIFICATION(
BPD_NOTIFICATION_ID DECIMAL(38,0) NOT NULL,
BPD_INSTANCE_ID DECIMAL(38,0) NOT NULL,
STATUS DECIMAL(38,0) NOT NULL,
ERROR NTEXT,
ERROR_STACK_TRACE NTEXT,
DATA IMAGE)
;


if not exists (select name from sysobjects where name = 'LSW_BPD_INSTANCE_COMMENT')
CREATE  TABLE LSW_BPD_INSTANCE_COMMENT(
COMMENT_ID DECIMAL(4, 0) NOT NULL,
BPD_INSTANCE_ID DECIMAL(38,0),
USER_ID DECIMAL(38,0),
DATE_TIME DATETIME,
SUBJECT NVARCHAR(255),
COMMENT NTEXT)
;


if not exists (select name from sysobjects where name = 'LSW_BPD_INSTANCE_DOCUMENTS')
CREATE  TABLE LSW_BPD_INSTANCE_DOCUMENTS(
DOC_ID DECIMAL(38,0) NOT NULL,
BPD_INSTANCE_ID DECIMAL(38,0) NOT NULL,
PARENT_DOC_ID DECIMAL(38,0) NOT NULL,
DOC_NAME NVARCHAR(50) NOT NULL,
FILENAME NVARCHAR(1000) NOT NULL,
FILETYPE DECIMAL(4, 0) DEFAULT -1 NOT NULL,
AUTHOR_ID DECIMAL(38,0) NOT NULL,
AUTHORED_DTG DATETIME NOT NULL,
VERSION DECIMAL(4, 0) NOT NULL,
CONTENT_TYPE NVARCHAR(128),
DOCUMENT IMAGE,
HIDE_IN_PORTAL NCHAR(1))
;


if not exists (select name from sysobjects where name = 'LSW_BPD_INSTANCE_DOC_PROPS')
CREATE  TABLE LSW_BPD_INSTANCE_DOC_PROPS(
NAME NVARCHAR(1000) NOT NULL,
VALUE NVARCHAR(1000),
DOC_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_BPD_STATUS_CODES')
CREATE  TABLE LSW_BPD_STATUS_CODES(
STATUS_ID DECIMAL(4, 0) NOT NULL,
NAME NVARCHAR(50),
CONST_VALUE NVARCHAR(50))
;


if not exists (select name from sysobjects where name = 'LSW_FILE_TYPES')
CREATE  TABLE LSW_FILE_TYPES(
FILETYPE_ID DECIMAL(38,0) NOT NULL,
EXT NVARCHAR(10),
FILETYPE NVARCHAR(50))
;


if not exists (select name from sysobjects where name = 'LSW_DUR_MSG_RECEIVED')
CREATE  TABLE LSW_DUR_MSG_RECEIVED(
MSG_ID DECIMAL(38,0) NOT NULL,
CREATED_ON DATETIME NOT NULL,
UCA_ID UNIQUEIDENTIFIER NOT NULL,
VALUES_DATA IMAGE,
CORRELATION_KEY DECIMAL(38,0) NOT NULL,
CORRELATION_TYPE DECIMAL(2, 0) NOT NULL,
CORRELATION_STRING NVARCHAR(255),
CORRELATION_BLOB IMAGE)
;


if not exists (select name from sysobjects where name = 'LSW_INST_MSG_INCL')
CREATE  TABLE LSW_INST_MSG_INCL(
ID DECIMAL(38,0) NOT NULL,
CREATED_ON DATETIME NOT NULL,
BPD_INSTANCE_ID DECIMAL(38,0) NOT NULL,
DURABLE NCHAR(1) DEFAULT 'T' NOT NULL,
EVENT_ID UNIQUEIDENTIFIER,
SUB_EVENT_ID DECIMAL(38,0),
UCA_ID UNIQUEIDENTIFIER NOT NULL,
CORRELATION_KEY DECIMAL(38,0) NOT NULL,
CORRELATION_TYPE DECIMAL(2, 0) NOT NULL,
CORRELATION_STRING NVARCHAR(255),
CORRELATION_BLOB IMAGE)
;


if not exists (select name from sysobjects where name = 'LSW_INST_MSG_EXCL')
CREATE  TABLE LSW_INST_MSG_EXCL(
ID DECIMAL(38,0) NOT NULL,
CREATED_ON DATETIME NOT NULL,
BPD_INSTANCE_ID DECIMAL(38,0) NOT NULL,
EVENT_ID UNIQUEIDENTIFIER,
SUB_EVENT_ID DECIMAL(38,0),
MSG_ID DECIMAL(38,0) NOT NULL,
WAIT_ID DECIMAL(38,0))
;


if not exists (select name from sysobjects where name = 'LSW_RUNTIME_ERROR')
CREATE  TABLE LSW_RUNTIME_ERROR(
ERROR_ID DECIMAL(38,0) NOT NULL,
TIP NCHAR(1) NOT NULL,
SNAPSHOT_ID UNIQUEIDENTIFIER,
ERROR_MESSAGE NTEXT,
LOGGED DATETIME NOT NULL,
BPD_INSTANCE_ID DECIMAL(38,0),
TASK_ID DECIMAL(38,0),
SOURCE_REF DECIMAL(38,0) NOT NULL,
SOURCE_GUID NVARCHAR(128) NOT NULL,
SOURCE_NAME NVARCHAR(64),
SOURCE_ITEM NVARCHAR(64),
SOURCE_SUBITEM NVARCHAR(64),
JAVA_TRACE IMAGE,
JS_TRACE IMAGE,
TW_TRACE IMAGE,
ERROR_CODE NVARCHAR(220),
ERROR_DATA IMAGE,
FAULT_STYLE DECIMAL(2, 0) DEFAULT 0 NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_SLA_PROCESSING')
CREATE  TABLE LSW_SLA_PROCESSING(
SLA_GUID NVARCHAR(128) NOT NULL,
VIOLATION_LEVEL DECIMAL(31, 6) NOT NULL,
VALUE DECIMAL(30, 10) NOT NULL,
NI_VIOLATION_LEVEL DECIMAL(31, 6) NOT NULL,
NI_VALUE DECIMAL(30, 10) NOT NULL,
END_TIME DATETIME NOT NULL,
TIME_LOWER_BOUND DATETIME)
;


if not exists (select name from sysobjects where name = 'LSW_STORED_SYMBOL_TABLE')
CREATE  TABLE LSW_STORED_SYMBOL_TABLE(
SYMBOL_TABLE_ID UNIQUEIDENTIFIER NOT NULL,
TASK_ID DECIMAL(38,0) NOT NULL,
STORED_SYMBOL_TABLE IMAGE)
;


if not exists (select name from sysobjects where name = 'LSW_TASK_STATUS_CODES')
CREATE  TABLE LSW_TASK_STATUS_CODES(
STATUS_ID DECIMAL(4, 0) NOT NULL,
NAME NVARCHAR(50),
STATUS_VALUE NVARCHAR(2))
;


if not exists (select name from sysobjects where name = 'LSW_TASK_EXTACT_DATA')
CREATE  TABLE LSW_TASK_EXTACT_DATA(
TASK_EXTACT_DATA_ID DECIMAL(38,0) NOT NULL,
TASK_ID DECIMAL(38,0) NOT NULL,
EXTERNAL_ACTIVITY_REF DECIMAL(38,0),
DATA IMAGE)
;


if not exists (select name from sysobjects where name = 'LSW_TASK')
CREATE  TABLE LSW_TASK(
TASK_ID DECIMAL(38,0) NOT NULL,
TIP NCHAR(1) NOT NULL,
SNAPSHOT_ID UNIQUEIDENTIFIER,
USER_ID DECIMAL(38,0) NOT NULL,
GROUP_ID DECIMAL(38,0) NOT NULL,
EXPERT_PARTICIPANT_REF DECIMAL(38,0),
STATUS NVARCHAR(2) NOT NULL,
PRIORITY_ID DECIMAL(38,0) NOT NULL,
DUE_DATE DATETIME NOT NULL,
DUE_TIME DATETIME,
AT_RISK_DATE DATETIME,
SUBJECT NVARCHAR(255) NOT NULL,
RCVD_DATETIME DATETIME NOT NULL,
RCVD_FROM DECIMAL(38,0) NOT NULL,
RCVD_TASK_ID DECIMAL(38,0),
COLLABORATION NCHAR(1) DEFAULT 'F' NOT NULL,
SENT_DATETIME DATETIME,
READ_DATETIME DATETIME,
CLOSE_DATETIME DATETIME,
CLOSE_BY DECIMAL(38,0),
ORIG_TASK_ID DECIMAL(38,0),
START_PROCESS_REF DECIMAL(38,0),
CACHED_PROCESS_VERSION_ID UNIQUEIDENTIFIER,
GROUP_ID_TYPE DECIMAL(38,0),
EXECUTION_STATUS DECIMAL(38,0),
BPD_INSTANCE_ID DECIMAL(38,0),
CREATED_BY_BPD_REF DECIMAL(38,0),
CACHED_CBB_VERSION_ID UNIQUEIDENTIFIER,
CREATED_BY_BPD_FLOW_OBJECT_ID NVARCHAR(128),
ASSUMER_ID DECIMAL(38,0),
ATTACHED_FORM_REF DECIMAL(38,0),
CACHED_FORM_VERSION_ID UNIQUEIDENTIFIER,
ATTACHED_EXT_ACTIVITY_REF DECIMAL(38,0),
CACHED_EXTACT_VERSION_ID UNIQUEIDENTIFIER,
SHAREPOINT_DISCUSSION_URL NVARCHAR(512),
ACTIVITY_NAME NVARCHAR(128))
;


if not exists (select name from sysobjects where name = 'LSW_TASK_IPF_DATA')
CREATE  TABLE LSW_TASK_IPF_DATA(
TASK_INFOPATHFORM_DATA_ID DECIMAL(38,0) NOT NULL,
TASK_ID DECIMAL(38,0) NOT NULL,
INFOPATH_FORM_REF UNIQUEIDENTIFIER,
DATA IMAGE)
;


if not exists (select name from sysobjects where name = 'LSW_TASK_FILE')
CREATE  TABLE LSW_TASK_FILE(
TASK_ID DECIMAL(38,0) NOT NULL,
SEQ DECIMAL(38,0) NOT NULL,
FILE_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_TASK_ADDR')
CREATE  TABLE LSW_TASK_ADDR(
TASK_ADDR_ID DECIMAL(38,0) NOT NULL,
TASK_ID DECIMAL(38,0) NOT NULL,
SEQ DECIMAL(38,0) NOT NULL,
SEND_TO_ID NVARCHAR(255) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_TASK_NARR')
CREATE  TABLE LSW_TASK_NARR(
TASK_NARR_ID DECIMAL(38,0) NOT NULL,
TASK_ID DECIMAL(38,0) NOT NULL,
SEQ DECIMAL(38,0) NOT NULL,
NARRATIVE IMAGE,
NARRATIVE_RAW IMAGE)
;


if not exists (select name from sysobjects where name = 'LSW_TASK_ACTION')
CREATE  TABLE LSW_TASK_ACTION(
TASK_ACTION_ID UNIQUEIDENTIFIER NOT NULL,
CAN_CHANGE_DUEDATE NCHAR(1),
DUE_IN_OPTION DECIMAL(2, 0) NOT NULL,
DUE_DATE_INCR_DATA NVARCHAR(255),
DUE_DATE_FIXED_DATA NVARCHAR(255),
DUE_DATE_INCR_TYPE DECIMAL(1, 0) NOT NULL,
DUE_DATE_SPECIFIC_DATE NVARCHAR(255),
IS_CHANGE_STATUS_ACTIVE NCHAR(1),
NEW_STATUS_OPTION DECIMAL(2, 0) NOT NULL,
NEW_STATUS NVARCHAR(2),
IS_PRIORITY_ACTIVE NCHAR(1) NOT NULL,
PRIORITY_OPTION DECIMAL(2, 0) NOT NULL,
NEW_PRIORITY_ID DECIMAL(38,0),
NEW_PRIORITY_SCRIPT NVARCHAR(255),
IS_SUBJECT_ACTIVE NCHAR(1) NOT NULL,
SUBJECT_OPTION DECIMAL(2, 0) NOT NULL,
SUBJECT_SCRIPT NVARCHAR(255),
IS_NARRATIVE_ACTIVE NCHAR(1) NOT NULL,
NARRATIVE_OPTION DECIMAL(2, 0) NOT NULL,
NARRATIVE_SCRIPT NTEXT,
TIME_SCHEDULE_NAME NVARCHAR(64) DEFAULT '24X7',
HOLIDAY_SCHEDULE_NAME NVARCHAR(64) DEFAULT 'default US holiday',
TIMEZONE NVARCHAR(64) DEFAULT 'America/Chicago',
IS_IGNORE_EXCEPTION NCHAR(1) NOT NULL,
SUSPEND_PROCESS NCHAR(1),
IS_ACTION_OTHER_TASK NCHAR(1),
OTHER_TASK_ID NVARCHAR(64),
IS_REASSIGN_ACTIVE NCHAR(1),
REASSIGN_OPTION DECIMAL(2, 0) NOT NULL,
REASSIGN_TO NVARCHAR(255),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_TASK_EXECUTION_CONTEXT')
CREATE  TABLE LSW_TASK_EXECUTION_CONTEXT(
TASK_EXECUTION_CONTEXT_ID DECIMAL(38,0) NOT NULL,
TASK_ID DECIMAL(38,0) NOT NULL,
EXECUTION_CONTEXT IMAGE)
;


if not exists (select name from sysobjects where name = 'WL_WLSTORE')
CREATE  TABLE WL_WLSTORE(
ID DECIMAL(38,0) NOT NULL,
TYPE DECIMAL(38,0),
HANDLE DECIMAL(38,0),
RECORD IMAGE)
;


if not exists (select name from sysobjects where name = 'LSW_PRI_KEY')
CREATE  TABLE LSW_PRI_KEY(
TABLE_ID NVARCHAR(255) NOT NULL,
HIGH_KEY DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_SYSTEM')
CREATE  TABLE LSW_SYSTEM(
PROPKEY NVARCHAR(256) NOT NULL,
PROPVALUE NVARCHAR(256) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_SYSTEM_SCHEMA')
CREATE  TABLE LSW_SYSTEM_SCHEMA(
PROPNAME NVARCHAR(50) NOT NULL,
PROPVALUE NVARCHAR(50))
;


if not exists (select name from sysobjects where name = 'LSW_LEGACY_ID')
CREATE  TABLE LSW_LEGACY_ID(
LEGACY_ID DECIMAL(38,0) NOT NULL,
UUID UNIQUEIDENTIFIER NOT NULL,
PO_TYPE DECIMAL(8, 0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_LOCK')
CREATE  TABLE LSW_LOCK(
LOCK_ID NVARCHAR(128) NOT NULL,
DESCRIPTION NVARCHAR(256))
;


if not exists (select name from sysobjects where name = 'BPM_TASK_INDEX')
CREATE  TABLE BPM_TASK_INDEX(
TASK_ID DECIMAL(38,0) NOT NULL,
MAJOR_EVENT_DATETIME DATETIME,
MINOR_EVENT_DATETIME DATETIME,
TASK_DATA IMAGE,
DELETED_DATETIME DATETIME)
;


if not exists (select name from sysobjects where name = 'BPM_TASK_INDEX_JOB')
CREATE  TABLE BPM_TASK_INDEX_JOB(
INDEX_ID UNIQUEIDENTIFIER NOT NULL,
INDEX_START_TIME DATETIME NOT NULL,
INDEX_END_TIME DATETIME,
INDEX_LAST_PURGE_TIME DATETIME,
RECORDS_INDEXED DECIMAL(38,0),
RESULT_VALUE NVARCHAR(256))
;


if not exists (select name from sysobjects where name = 'LSW_INVOKE_UCA')
CREATE  TABLE LSW_INVOKE_UCA(
INVOKE_UCA_ID UNIQUEIDENTIFIER NOT NULL,
IS_UCA_ACTIVE NCHAR(1),
UCA_REF UNIQUEIDENTIFIER,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_UCA')
CREATE  TABLE LSW_UCA(
UCA_ID UNIQUEIDENTIFIER NOT NULL,
PROCESS_REF UNIQUEIDENTIFIER NOT NULL,
SCHED_TYPE DECIMAL(38,0),
SCHED_EVENT_NAME NVARCHAR(80),
QUEUE DECIMAL(38,0),
IS_ENABLED NCHAR(1),
SHARED_SYMBOL_TABLE_ID DECIMAL(38,0),
MONTH_LIST NVARCHAR(24),
FREQ_TYPE DECIMAL(38,0),
DAY_LIST NVARCHAR(78),
HOUR_LIST NVARCHAR(48),
MINUTE_LIST NVARCHAR(120),
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
UCA_EVENT_TYPE_REF DECIMAL(2, 0),
VARIABLE_REF UNIQUEIDENTIFIER,
IMPLEMENTATION_TYPE NVARCHAR(80),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_UCA_PARM')
CREATE  TABLE LSW_UCA_PARM(
UCA_PARM_ID UNIQUEIDENTIFIER NOT NULL,
UCA_ID UNIQUEIDENTIFIER NOT NULL,
SEQ DECIMAL(38,0) NOT NULL,
PARM_NAME NVARCHAR(255) NOT NULL,
PARM_VALUE NVARCHAR(1000),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_UCA_BLACKOUT')
CREATE  TABLE LSW_UCA_BLACKOUT(
BLACKOUT_ID UNIQUEIDENTIFIER NOT NULL,
FROM_DATETIME DATETIME NOT NULL,
TO_DATETIME DATETIME NOT NULL,
DATE_TYPE NCHAR(1) NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_UCA_EVENT_TYPE')
CREATE  TABLE BPM_UCA_EVENT_TYPE(
UCA_EVENT_TYPE_ID DECIMAL(2, 0) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT)
;


if not exists (select name from sysobjects where name = 'LSW_USR')
CREATE  TABLE LSW_USR(
USER_ID DECIMAL(38,0) NOT NULL,
USER_NAME NVARCHAR(50) NOT NULL,
PASSWD NVARCHAR(250) NOT NULL,
FULL_NAME NVARCHAR(50) NOT NULL,
IS_DISABLED NCHAR(1) DEFAULT 'F',
LAST_LOGIN_DATETIME DATETIME,
OLD_PASSWORDS NTEXT)
;


if not exists (select name from sysobjects where name = 'LSW_USR_XREF')
CREATE  TABLE LSW_USR_XREF(
USER_ID DECIMAL(38,0) NOT NULL,
USER_NAME NVARCHAR(64) NOT NULL,
FULL_NAME NVARCHAR(255),
PROVIDER NVARCHAR(128))
;


if not exists (select name from sysobjects where name = 'LSW_USR_GRP_XREF')
CREATE  TABLE LSW_USR_GRP_XREF(
GROUP_ID DECIMAL(38,0) NOT NULL,
GROUP_NAME NVARCHAR(256) NOT NULL,
DISPLAY_NAME NVARCHAR(256) NOT NULL,
PARENT_GROUP_ID DECIMAL(38,0),
GROUP_TYPE DECIMAL(2, 0) DEFAULT 0 NOT NULL,
DESCRIPTION NVARCHAR(255),
GROUP_STATE DECIMAL(2, 0) DEFAULT 0 NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_USR_GRP_MEM_XREF')
CREATE  TABLE LSW_USR_GRP_MEM_XREF(
USER_ID DECIMAL(38,0) NOT NULL,
GROUP_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_GRP_GRP_MEM_XREF')
CREATE  TABLE LSW_GRP_GRP_MEM_XREF(
GROUP_ID DECIMAL(38,0) NOT NULL,
CONTAINER_GROUP_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_GRP_GRP_MEM_EXPLODED_XREF')
CREATE  TABLE LSW_GRP_GRP_MEM_EXPLODED_XREF(
GROUP_ID DECIMAL(38,0) NOT NULL,
CONTAINER_GROUP_ID DECIMAL(38,0) NOT NULL,
MEM_PATH NVARCHAR(1024) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_USR_ASSUME')
CREATE  TABLE LSW_USR_ASSUME(
USR_ASSUME_ID DECIMAL(38,0) NOT NULL,
USER_ID DECIMAL(38,0) NOT NULL,
ASSUMED_USER_ID DECIMAL(38,0) NOT NULL,
START_DATETIME DATETIME,
END_DATETIME DATETIME)
;


if not exists (select name from sysobjects where name = 'LSW_ACCESS')
CREATE  TABLE LSW_ACCESS(
USER_ID DECIMAL(38,0) NOT NULL,
ASSUMED_USER_ID DECIMAL(38,0) NOT NULL,
START_DATETIME DATETIME,
END_DATETIME DATETIME)
;


if not exists (select name from sysobjects where name = 'LSW_DYNAMIC_GROUP')
CREATE  TABLE LSW_DYNAMIC_GROUP(
DYNAMIC_GROUP_ID DECIMAL(38,0) NOT NULL,
NAME NVARCHAR(128) NOT NULL,
CONSTRAINTS_SET_OPERATOR DECIMAL(38,0) NOT NULL,
SNAPSHOT_ID UNIQUEIDENTIFIER,
BRANCH_ID UNIQUEIDENTIFIER,
TIP NCHAR(1) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_DYNAMIC_GROUP_CONSTRAINT')
CREATE  TABLE LSW_DYNAMIC_GROUP_CONSTRAINT(
DYNAMIC_GROUP_CONSTRAINT_ID DECIMAL(38,0) NOT NULL,
DYNAMIC_GROUP_ID DECIMAL(38,0) NOT NULL,
MATCH_TYPE DECIMAL(38,0) NOT NULL,
CONSTRAINT_TYPE DECIMAL(38,0) NOT NULL,
LIBRARY_ELEMENT_TYPE DECIMAL(38,0),
LIBRARY_ELEMENT_REF DECIMAL(38,0),
LIBRARY_ELEMENT_ID UNIQUEIDENTIFIER,
VALUE NVARCHAR(1000))
;


if not exists (select name from sysobjects where name = 'LSW_DYNAMIC_GROUP_DEPENDENCY')
CREATE  TABLE LSW_DYNAMIC_GROUP_DEPENDENCY(
PARENT_GROUP_ID DECIMAL(38,0) NOT NULL,
CHILD_GROUP_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_USR_ATTR')
CREATE  TABLE LSW_USR_ATTR(
USER_ATTR_ID DECIMAL(38,0) NOT NULL,
USER_ID DECIMAL(38,0) NOT NULL,
ATTR_VALUE NVARCHAR(1000),
ATTR_NUMBER_VALUE DECIMAL(31, 6),
USER_ATTR_DEF_VALUE_ID UNIQUEIDENTIFIER,
USER_ATTR_DEF_ID UNIQUEIDENTIFIER NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_USER_ATTR_DEF_VALUES')
CREATE  TABLE LSW_USER_ATTR_DEF_VALUES(
USER_ATTR_DEF_VALUE_ID UNIQUEIDENTIFIER NOT NULL,
USER_ATTRIBUTE_DEF_ID UNIQUEIDENTIFIER NOT NULL,
VALUE NVARCHAR(100) NOT NULL,
SEQ DECIMAL(38,0) NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_USER_ATTRIBUTE_DEF')
CREATE  TABLE LSW_USER_ATTRIBUTE_DEF(
USER_ATTRIBUTE_ID UNIQUEIDENTIFIER NOT NULL,
CLASS_REF UNIQUEIDENTIFIER NOT NULL,
STORAGE_SOURCE DECIMAL(38,0) DEFAULT 0 NOT NULL,
STORAGE_PROVIDER DECIMAL(38,0),
STORAGE_PROVIDER_ATTRIBUTE NVARCHAR(255),
STORAGE_SERVICE DECIMAL(38,0),
VALUES_SOURCE DECIMAL(38,0),
VALUES_SERVICE DECIMAL(38,0),
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_RT_USER_ATTRIBUTE_DEF')
CREATE  TABLE LSW_RT_USER_ATTRIBUTE_DEF(
USER_ATTRIBUTE_ID UNIQUEIDENTIFIER NOT NULL,
SNAPSHOT_ID UNIQUEIDENTIFIER NOT NULL,
NAME NVARCHAR(64) NOT NULL,
LAST_MODIFIED DATETIME NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_PARTICIPANT_GROUP')
CREATE  TABLE LSW_PARTICIPANT_GROUP(
SNAPSHOT_ID UNIQUEIDENTIFIER,
BRANCH_ID UNIQUEIDENTIFIER,
TIP NCHAR(1) NOT NULL,
PARTICIPANT_ID UNIQUEIDENTIFIER NOT NULL,
CACHED_PART_VERSION_ID UNIQUEIDENTIFIER NOT NULL,
GROUP_ID DECIMAL(38,0) NOT NULL,
HIDDEN NCHAR(1) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_PARTICIPANT')
CREATE  TABLE LSW_PARTICIPANT(
PARTICIPANT_ID UNIQUEIDENTIFIER NOT NULL,
COST DECIMAL(12, 2) DEFAULT 10.0 NOT NULL,
CURRENCY_CODE NCHAR(3),
PARTICIPANT_DEFINITION NVARCHAR(1000),
SIMULATION_GROUP_SIZE DECIMAL(38,0) NOT NULL,
CAPACITY_TYPE DECIMAL(38,0),
DEFINITION_TYPE DECIMAL(38,0),
PERCENT_AVAILABLE DECIMAL(12, 2),
PERCENT_EFFICIENCY DECIMAL(12, 2),
IMAGE NVARCHAR(1024),
DATA IMAGE,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_ACL_ENTRY')
CREATE  TABLE LSW_ACL_ENTRY(
ACL_ENTRY_ID DECIMAL(38,0) NOT NULL,
USER_ID DECIMAL(38,0),
GROUP_ID DECIMAL(38,0),
PO_TYPE DECIMAL(8, 0) NOT NULL,
PO_ID UNIQUEIDENTIFIER NOT NULL,
MASK DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_FAVORITE')
CREATE  TABLE LSW_FAVORITE(
FAVORITE_ID DECIMAL(38,0) NOT NULL,
GROUP_ID DECIMAL(38,0),
NAME NVARCHAR(1000) NOT NULL,
EFFECTIVE_DATE DATETIME,
SNAPSHOT_ID UNIQUEIDENTIFIER,
TIP NCHAR(1),
BRANCH_ID UNIQUEIDENTIFIER,
ITEM_TYPE DECIMAL(38,0) NOT NULL,
ITEM_REF DECIMAL(38,0),
ITEM_ID UNIQUEIDENTIFIER,
EXPOSED_SERVICE_TYPE DECIMAL(38,0),
EXPOSED_PROCESS_TYPE DECIMAL(38,0),
CACHED_PROCESS_VERSION_ID UNIQUEIDENTIFIER,
CACHED_BPD_VERSION_ID UNIQUEIDENTIFIER,
CACHED_REPORT_VERSION_ID UNIQUEIDENTIFIER,
CACHED_SCBD_VERSION_ID UNIQUEIDENTIFIER,
CACHED_EPV_VERSION_ID UNIQUEIDENTIFIER,
CACHED_UCA_VERSION_ID UNIQUEIDENTIFIER,
CACHED_WS_VERSION_ID UNIQUEIDENTIFIER,
CACHED_SLA_VERSION_ID UNIQUEIDENTIFIER,
CACHED_EVENT_SUB_VERSION_ID UNIQUEIDENTIFIER,
EVENT_SOURCE_ID NVARCHAR(128),
ENABLED NCHAR(1) DEFAULT 'T' NOT NULL)
;


if not exists (select name from sysobjects where name = 'BPM_USR_AVATAR')
CREATE  TABLE BPM_USR_AVATAR(
USER_ID DECIMAL(38,0) NOT NULL,
USER_AVATAR_IMAGE IMAGE)
;


if not exists (select name from sysobjects where name = 'LSW_SNAPSHOT')
CREATE  TABLE LSW_SNAPSHOT(
SNAPSHOT_ID UNIQUEIDENTIFIER NOT NULL,
REPOSITORY_BRANCH_ID UNIQUEIDENTIFIER,
CREATED_BY_USER_ID DECIMAL(38,0) NOT NULL,
CREATED_ON DATETIME NOT NULL,
NAME NVARCHAR(64),
ACRONYM NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
BRANCH_ID UNIQUEIDENTIFIER NOT NULL,
PROJECT_ID UNIQUEIDENTIFIER NOT NULL,
SEQ_NUM DECIMAL(38,0) NOT NULL,
IS_ACTIVE NCHAR(1) DEFAULT 'T' NOT NULL,
IS_BLA_ACTIVE NCHAR(1) DEFAULT 'F' NOT NULL,
IS_STARTED NCHAR(1) DEFAULT 'F' NOT NULL,
IS_INSTALLED NCHAR(1) DEFAULT 'F' NOT NULL,
IS_BLA_INSTALLED NCHAR(1) DEFAULT 'F' NOT NULL,
IS_TIP_DEPLOYED NCHAR(1) DEFAULT 'F' NOT NULL,
IS_DEFAULT NCHAR(1) DEFAULT 'F' NOT NULL,
ERROR_COUNTER DECIMAL(8, 0),
CHANGE_DATA IMAGE,
TIP_DEPLOYMENT_IN_PROGRESS NCHAR(1) DEFAULT 'F' NOT NULL,
ORIG_CREATED_ON DATETIME NOT NULL,
ACTIVATED_ON DATETIME,
STATUS NVARCHAR(64) DEFAULT 'New' NOT NULL,
IS_ARCHIVED NCHAR(1) DEFAULT 'F',
ARCHIVED_ON DATETIME,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_BRANCH')
CREATE  TABLE LSW_BRANCH(
BRANCH_ID UNIQUEIDENTIFIER NOT NULL,
CREATED_BY_USER_ID DECIMAL(38,0) NOT NULL,
CREATED_ON DATETIME NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL,
IS_ARCHIVED NCHAR(1) DEFAULT 'F',
ARCHIVED_ON DATETIME,
NAME NVARCHAR(64) NOT NULL,
ACRONYM NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
TIP_SEQ_NUM DECIMAL(38,0) NOT NULL,
TIP_SNAPSHOT_ID UNIQUEIDENTIFIER,
IS_DEFAULT NCHAR(1) DEFAULT 'F' NOT NULL,
PROJECT_ID UNIQUEIDENTIFIER NOT NULL,
BASE_SNAPSHOT_ID UNIQUEIDENTIFIER)
;


if not exists (select name from sysobjects where name = 'LSW_PROJECT')
CREATE  TABLE LSW_PROJECT(
PROJECT_ID UNIQUEIDENTIFIER NOT NULL,
CREATED_BY_USER_ID DECIMAL(38,0) NOT NULL,
CREATED_ON DATETIME NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL,
IS_ARCHIVED NCHAR(1) DEFAULT 'F',
ARCHIVED_ON DATETIME,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
SHORT_NAME NVARCHAR(64) NOT NULL,
RELEASE_PROCESS_ID UNIQUEIDENTIFIER,
RELEASE_PROCESS_BRANCH_ID UNIQUEIDENTIFIER,
IS_TOOLKIT NCHAR(1) DEFAULT 'F' NOT NULL,
IS_BRANCHING_ENABLED NCHAR(1) DEFAULT 'F' NOT NULL,
IS_HIDDEN NCHAR(1) DEFAULT 'F' NOT NULL,
IS_SYSTEM NCHAR(1) DEFAULT 'F' NOT NULL,
IS_IMMUTABLE NCHAR(1) DEFAULT 'F' NOT NULL,
IS_SHARED NCHAR(1) DEFAULT 'F' NOT NULL,
SHARED_BY_USER_ID DECIMAL(38,0),
SHARED_ON DATETIME,
IS_GOVERNED NCHAR(1) DEFAULT 'F' NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_PO_VERSIONS')
CREATE  TABLE LSW_PO_VERSIONS(
VERSION_SUMMARY_ID UNIQUEIDENTIFIER NOT NULL,
START_SEQ_NUM DECIMAL(38,0) NOT NULL,
END_SEQ_NUM DECIMAL(38,0),
BRANCH_ID UNIQUEIDENTIFIER NOT NULL,
PO_TYPE DECIMAL(8, 0) NOT NULL,
PO_ID UNIQUEIDENTIFIER NOT NULL,
PO_ROOT_ID UNIQUEIDENTIFIER NOT NULL,
PO_GUID NVARCHAR(128),
PO_VERSION_ID UNIQUEIDENTIFIER NOT NULL,
PO_ORIG_VERSION_ID UNIQUEIDENTIFIER,
PO_NAME NVARCHAR(64),
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0),
LAST_MODIFIED DATETIME,
ORIG_LAST_MODIFIED_BY_USER NVARCHAR(50),
ORIG_LAST_MODIFIED DATETIME,
PO_DATA IMAGE,
VALID_STATE DECIMAL(1, 0),
VALIDATION_ERRS IMAGE)
;


if not exists (select name from sysobjects where name = 'LSW_PO_METADATA')
CREATE  TABLE LSW_PO_METADATA(
START_SEQ_NUM DECIMAL(38,0) NOT NULL,
END_SEQ_NUM DECIMAL(38,0),
BRANCH_ID UNIQUEIDENTIFIER NOT NULL,
PO_TYPE DECIMAL(8, 0) NOT NULL,
PO_ID UNIQUEIDENTIFIER NOT NULL,
META_KEY NVARCHAR(128) NOT NULL,
PO_DATA IMAGE)
;


if not exists (select name from sysobjects where name = 'LSW_PROJECT_DEPENDENCY')
CREATE  TABLE LSW_PROJECT_DEPENDENCY(
PROJECT_DEPENDENCY_ID UNIQUEIDENTIFIER NOT NULL,
TARGET_SNAPSHOT_ID UNIQUEIDENTIFIER NOT NULL,
LATEST_SNAPSHOT_SEQ_NUM DECIMAL(38,0),
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
IS_SYSTEM NCHAR(1) DEFAULT 'F' NOT NULL,
NAME NVARCHAR(64),
RANK DECIMAL(38,0),
DESCRIPTION NTEXT,
IS_ACTIVE NCHAR(1) DEFAULT 'T' NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_DEP_PATH')
CREATE  TABLE LSW_DEP_PATH(
DEP_PATH_ID DECIMAL(38,0) NOT NULL,
IDX DECIMAL(6, 0) NOT NULL,
COUNT DECIMAL(6, 0) NOT NULL,
HASH DECIMAL(38,0) NOT NULL,
DEPENDENCY_ID UNIQUEIDENTIFIER NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_PO_REFERENCE')
CREATE  TABLE LSW_PO_REFERENCE(
REFERENCE_ID UNIQUEIDENTIFIER NOT NULL,
START_SEQ_NUM DECIMAL(38,0) NOT NULL,
END_SEQ_NUM DECIMAL(38,0),
BRANCH_ID UNIQUEIDENTIFIER NOT NULL,
DEP_PATH_ID DECIMAL(38,0) NOT NULL,
TARGET_TYPE DECIMAL(8, 0) NOT NULL,
TARGET_ID UNIQUEIDENTIFIER NOT NULL,
TARGET_SUMMARY_DATA IMAGE)
;


if not exists (select name from sysobjects where name = 'LSW_PO_DEPENDENCY')
CREATE  TABLE LSW_PO_DEPENDENCY(
START_SEQ_NUM DECIMAL(38,0) NOT NULL,
END_SEQ_NUM DECIMAL(38,0),
SOURCE_TYPE DECIMAL(4, 0) NOT NULL,
BRANCH_ID UNIQUEIDENTIFIER NOT NULL,
SOURCE_ID UNIQUEIDENTIFIER NOT NULL,
SOURCE_LOCATION NVARCHAR(1024) NOT NULL,
TARGET_REF UNIQUEIDENTIFIER NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_RT_REFERENCE')
CREATE  TABLE LSW_RT_REFERENCE(
REFERENCE_ID DECIMAL(38,0) NOT NULL,
DEP_PATH_ID DECIMAL(38,0) NOT NULL,
PO_TYPE DECIMAL(8, 0) NOT NULL,
PO_ID UNIQUEIDENTIFIER NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_WEB_SERVICE')
CREATE  TABLE LSW_WEB_SERVICE(
WEB_SERVICE_ID UNIQUEIDENTIFIER NOT NULL,
IS_PROTECTED NCHAR(1),
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
TARGET_NAMESPACE_SCHEME NVARCHAR(64),
TARGET_NAMESPACE NVARCHAR(512),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSW_WEB_SERVICE_OP')
CREATE  TABLE LSW_WEB_SERVICE_OP(
WEB_SERVICE_OP_ID UNIQUEIDENTIFIER NOT NULL,
WEB_SERVICE_ID UNIQUEIDENTIFIER NOT NULL,
SEQ DECIMAL(38,0) NOT NULL,
PROCESS_REF UNIQUEIDENTIFIER NOT NULL,
IS_PROTECTED NCHAR(1),
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
;


if not exists (select name from sysobjects where name = 'LSWC_METRIC_PK' )     
ALTER TABLE LSW_METRIC ADD CONSTRAINT LSWC_METRIC_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_SLA_PK' )     
ALTER TABLE LSW_SLA ADD CONSTRAINT LSWC_SLA_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_SIM_SCEN_PK' )     
ALTER TABLE LSW_SIM_SCENARIO ADD CONSTRAINT LSWC_SIM_SCEN_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_HIST_SCEN_PK' )     
ALTER TABLE LSW_HIST_SCENARIO ADD CONSTRAINT LSWC_HIST_SCEN_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_EVENT_SUBSCRIPTION_PK' )     
ALTER TABLE BPM_EVENT_SUBSCRIPTION ADD CONSTRAINT BPM_EVENT_SUBSCRIPTION_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_BPM_EVT_SUBN_TYPE_PK' )     
ALTER TABLE BPM_EVENT_SUBSCRIPTION_TYPE ADD CONSTRAINT LSWC_BPM_EVT_SUBN_TYPE_PK
    PRIMARY KEY(EVENT_SUBSCRIPTION_TYPE_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_STAY_ON_PAGE_PK' )     
ALTER TABLE LSW_STAY_ON_PAGE ADD CONSTRAINT BPM_STAY_ON_PAGE_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_PAREF_PK' )     
ALTER TABLE BPM_PROC_ARTIFACT_REF ADD CONSTRAINT BPM_PAREF_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_CAREF_PK' )     
ALTER TABLE BPM_CLS_ARTIFACT_REF ADD CONSTRAINT BPM_CAREF_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_BAREF_PK' )     
ALTER TABLE BPM_BPD_ARTIFACT_REF ADD CONSTRAINT BPM_BAREF_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_BPD_PK' )     
ALTER TABLE LSW_BPD ADD CONSTRAINT LSWC_BPD_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_BPD_EVENT_PK' )     
ALTER TABLE LSW_BPD_EVENT ADD CONSTRAINT LSWC_BPD_EVENT_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_BPD_PARM_PK' )     
ALTER TABLE LSW_BPD_PARAMETER ADD CONSTRAINT LSWC_BPD_PARM_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_SHARED_OBJECT_PK' )     
ALTER TABLE BPM_SHARED_OBJECT ADD CONSTRAINT BPM_SHARED_OBJECT_PK
    PRIMARY KEY(DEFINITION_VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_SHARED_OBJECT_INSTANCE_PK' )     
ALTER TABLE BPM_SHARED_OBJECT_INSTANCE ADD CONSTRAINT BPM_SHARED_OBJECT_INSTANCE_PK
    PRIMARY KEY(INSTANCE_VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_SHARED_OBJECT_VALUE_PK' )     
ALTER TABLE BPM_SHARED_OBJECT_VALUE ADD CONSTRAINT BPM_SHARED_OBJECT_VALUE_PK
    PRIMARY KEY(VALUE_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_CH_VIEW_PK' )     
ALTER TABLE BPM_COACH_VIEW ADD CONSTRAINT BPM_CH_VIEW_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_VIEW_LOC_PK' )     
ALTER TABLE BPM_COACH_VIEW_LOCAL_RES ADD CONSTRAINT BPM_VIEW_LOC_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_VIEW_BIND_PK' )     
ALTER TABLE BPM_COACH_VIEW_BINDING_TYPE ADD CONSTRAINT BPM_VIEW_BIND_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_VIEW_CONFIG_PK' )     
ALTER TABLE BPM_COACH_VIEW_CONFIG_OPTION ADD CONSTRAINT BPM_VIEW_CONFIG_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_VIEW_RES_PK' )     
ALTER TABLE BPM_COACH_VIEW_RESOURCE ADD CONSTRAINT BPM_VIEW_RES_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_VIEW_SCRIPT_PK' )     
ALTER TABLE BPM_COACH_VIEW_INLINE_SCRIPT ADD CONSTRAINT BPM_VIEW_SCRIPT_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_VIEW_AMD_PK' )     
ALTER TABLE BPM_COACH_VIEW_AMD_DEP ADD CONSTRAINT BPM_VIEW_AMD_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_COACHNG_PK' )     
ALTER TABLE BPM_COACHNG ADD CONSTRAINT BPM_COACHNG_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_COACHNG_BE_PK' )     
ALTER TABLE BPM_COACHNG_BOUNDARY_EVENT ADD CONSTRAINT BPM_COACHNG_BE_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_COACH_PK' )     
ALTER TABLE LSW_COACH ADD CONSTRAINT LSWC_COACH_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_COACH_BTN_PK' )     
ALTER TABLE LSW_COACH_BUTTON ADD CONSTRAINT LSWC_COACH_BTN_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_COACH_RES_PK' )     
ALTER TABLE LSW_COACH_RESOURCE ADD CONSTRAINT LSWC_COACH_RES_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_INFOPATHF_PK' )     
ALTER TABLE LSW_INFOPATH_FORM ADD CONSTRAINT LSWC_INFOPATHF_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_EM_TASK_PK' )     
ALTER TABLE LSW_EM_TASK ADD CONSTRAINT LSWC_EM_TASK_PK
    PRIMARY KEY(TASK_ID ) 
;


if not exists (select name from sys.indexes where name = 'LSWC_EM_TASK_NUQ' )
CREATE INDEX LSWC_EM_TASK_NUQ ON LSW_EM_TASK(TASK_ID) 
;


if not exists (select name from sysobjects where name = 'LSWC_EM_KEYWORD_PK' )     
ALTER TABLE LSW_EM_TASK_KEYWORDS ADD CONSTRAINT LSWC_EM_KEYWORD_PK
    PRIMARY KEY(TASK_ID ,KEYWORD ) 
;


if not exists (select name from sysobjects where name = 'LSWC_EM_INST_PK' )     
ALTER TABLE LSW_EM_INSTANCE ADD CONSTRAINT LSWC_EM_INST_PK
    PRIMARY KEY(OWNER_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_TASK_HIST_PK' )     
ALTER TABLE LSW_EM_TASK_HISTORY ADD CONSTRAINT LSWC_TASK_HIST_PK
    PRIMARY KEY(TASK_ID ,EXECUTION_ATTEMPT ) 
;


if not exists (select name from sysobjects where name = 'LSWC_SYNCQUEUE_PK' )     
ALTER TABLE LSW_UCA_SYNC_QUEUE ADD CONSTRAINT LSWC_SYNCQUEUE_PK
    PRIMARY KEY(SYNC_QUEUE_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_ENV_VARS_PK' )     
ALTER TABLE LSW_ENV_VAR_SET ADD CONSTRAINT LSWC_ENV_VARS_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_ENV_VAR_PK' )     
ALTER TABLE LSW_ENV_VAR ADD CONSTRAINT LSWC_ENV_VAR_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_E_VAR_VAL_PK' )     
ALTER TABLE LSW_ENV_VAR_VAL ADD CONSTRAINT LSWC_E_VAR_VAL_PK
    PRIMARY KEY(ENV_VAR_VAL_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_ENV_TYPE_PK' )     
ALTER TABLE LSW_ENV_TYPE ADD CONSTRAINT LSWC_ENV_TYPE_PK
    PRIMARY KEY(ENV_TYPE_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_ENV_VART_PK' )     
ALTER TABLE LSW_ENV_VAR_TYPE ADD CONSTRAINT LSWC_ENV_VART_PK
    PRIMARY KEY(ENV_VAR_TYPE_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_ENV_DFLT_PK' )     
ALTER TABLE LSW_ENV_VAR_DEFAULT ADD CONSTRAINT LSWC_ENV_DFLT_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_EPV_PK' )     
ALTER TABLE LSW_EPV ADD CONSTRAINT LSWC_EPV_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_EPV_VAR_PK' )     
ALTER TABLE LSW_EPV_VAR ADD CONSTRAINT LSWC_EPV_VAR_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_EPV_VAL_PK' )     
ALTER TABLE LSW_EPV_VAR_VALUE ADD CONSTRAINT LSWC_EPV_VAL_PK
    PRIMARY KEY(EPV_VAR_VALUE_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_BPS_PK' )     
ALTER TABLE LSW_BLUEPRINT_SUBSCRIPTION ADD CONSTRAINT LSWC_BPS_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_EA_PARAM_PK' )     
ALTER TABLE LSW_EXTACT_PARAMETER ADD CONSTRAINT LSWC_EA_PARAM_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_EA_PROP_PK' )     
ALTER TABLE LSW_EXTACT_PROPERTY ADD CONSTRAINT LSWC_EA_PROP_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_EXT_ACT_PK' )     
ALTER TABLE LSW_EXTERNAL_ACTIVITY ADD CONSTRAINT LSWC_EXT_ACT_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_MGD_ASSET_PK' )     
ALTER TABLE LSW_MANAGED_ASSET ADD CONSTRAINT LSWC_MGD_ASSET_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_ASSET_DATA_PK' )     
ALTER TABLE LSW_MANAGED_ASSET_DATA ADD CONSTRAINT LSWC_ASSET_DATA_PK
    PRIMARY KEY(ASSET_DATA_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_NODE_PK' )     
ALTER TABLE BPM_CONTRIBUTION ADD CONSTRAINT BPM_NODE_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_CPRP_PK' )     
ALTER TABLE BPM_CTRB_PROPERTY ADD CONSTRAINT BPM_CPRP_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_CDEP_PK' )     
ALTER TABLE BPM_CTRB_DEPENDENCY ADD CONSTRAINT BPM_CDEP_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_NPRP_PK' )     
ALTER TABLE BPM_ARTIFACT ADD CONSTRAINT BPM_NPRP_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_ART_DATA_PK' )     
ALTER TABLE BPM_ARTIFACT_DATA ADD CONSTRAINT BPM_ART_DATA_PK
    PRIMARY KEY(ART_DATA_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_MMDATA_PK' )     
ALTER TABLE BPM_MON_MODEL_DATA ADD CONSTRAINT BPM_MMDATA_PK
    PRIMARY KEY(MM_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_SAV_SRCH_PK' )     
ALTER TABLE LSW_SAVED_SEARCHES ADD CONSTRAINT LSWC_SAV_SRCH_PK
    PRIMARY KEY(SEARCH_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_INSTALL_PK' )     
ALTER TABLE LSW_INSTALLATION ADD CONSTRAINT LSWC_INSTALL_PK
    PRIMARY KEY(INSTALLATION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_RELEASE_PK' )     
ALTER TABLE LSW_RELEASE ADD CONSTRAINT LSWC_RELEASE_PK
    PRIMARY KEY(RELEASE_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_USER_FAV_PK' )     
ALTER TABLE LSW_USER_FAVORITE ADD CONSTRAINT LSWC_USER_FAV_PK
    PRIMARY KEY(FAVORITE_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_SF_PK' )     
ALTER TABLE LSW_SMART_FOLDER ADD CONSTRAINT LSWC_SF_PK
    PRIMARY KEY(SMART_FOLDER_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_TEMPLATE_PK' )     
ALTER TABLE LSW_CA_TEMPLATE ADD CONSTRAINT LSWC_TEMPLATE_PK
    PRIMARY KEY(ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_LAUNCHER_PK' )     
ALTER TABLE LSW_LAUNCHER ADD CONSTRAINT LSWC_LAUNCHER_PK
    PRIMARY KEY(LAUNCHER_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_BRKPNT_PK' )     
ALTER TABLE LSW_BREAKPOINT ADD CONSTRAINT LSWC_BRKPNT_PK
    PRIMARY KEY(BREAKPOINT_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_OSLC_PROVIDER' )     
ALTER TABLE BPM_OSLC_PROVIDER ADD CONSTRAINT LSWC_OSLC_PROVIDER
    PRIMARY KEY(PROVIDER_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_CLASS_PK' )     
ALTER TABLE LSW_CLASS ADD CONSTRAINT LSWC_CLASS_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_LAYOUT_PK' )     
ALTER TABLE LSW_LAYOUT ADD CONSTRAINT LSWC_LAYOUT_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_LOUT_PRM_PK' )     
ALTER TABLE LSW_LAYOUT_PARAM ADD CONSTRAINT LSWC_LOUT_PRM_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_PRJ_DFTS_PK' )     
ALTER TABLE LSW_PROJECT_DEFAULTS ADD CONSTRAINT LSWC_PRJ_DFTS_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_RBGROUP_PK' )     
ALTER TABLE LSW_RESOURCE_BUNDLE_GROUP ADD CONSTRAINT LSWC_RBGROUP_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_RBUNDLE_PK' )     
ALTER TABLE LSW_RESOURCE_BUNDLE ADD CONSTRAINT LSWC_RBUNDLE_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_RBKEY_PK' )     
ALTER TABLE LSW_RESOURCE_BUNDLE_KEY ADD CONSTRAINT LSWC_RBKEY_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_SCRIPT_PK' )     
ALTER TABLE LSW_SCRIPT ADD CONSTRAINT LSWC_SCRIPT_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_SERVER_PK' )     
ALTER TABLE LSW_SERVER ADD CONSTRAINT LSWC_SERVER_PK
    PRIMARY KEY(SERVER_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_DEPLOYMENT_PK' )     
ALTER TABLE LSW_DEPLOYMENT ADD CONSTRAINT LSWC_DEPLOYMENT_PK
    PRIMARY KEY(DEPLOYMENT_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_SVRCAP_PK' )     
ALTER TABLE LSW_SERVER_CAPABILITY ADD CONSTRAINT LSWC_SVRCAP_PK
    PRIMARY KEY(SERVER_CAPABILITY_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_CAP_TYPE_PK' )     
ALTER TABLE LSW_CAPABILITY_TYPE ADD CONSTRAINT LSWC_CAP_TYPE_PK
    PRIMARY KEY(CAPABILITY_TYPE_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_REGISTRATION_PK' )     
ALTER TABLE BPM_REGISTRATION ADD CONSTRAINT BPM_REGISTRATION_PK
    PRIMARY KEY(REG_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_REPOSITORY_LOG_PK' )     
ALTER TABLE BPM_REPOSITORY_LOG ADD CONSTRAINT BPM_REPOSITORY_LOG_PK
    PRIMARY KEY(REPOSITORY_LOG_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_SHARED_TK_USAGES_PK' )     
ALTER TABLE BPM_SHARED_TK_USAGES ADD CONSTRAINT BPM_SHARED_TK_USAGES_PK
    PRIMARY KEY(SHARED_TK_USAGE_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_SNAPSHOT_STATUS_PK' )     
ALTER TABLE BPM_SNAPSHOT_STATUS ADD CONSTRAINT BPM_SNAPSHOT_STATUS_PK
    PRIMARY KEY(STATUS_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_PROJECT_SUBSCRIPTION_PK' )     
ALTER TABLE BPM_PROJECT_SUBSCRIPTION ADD CONSTRAINT BPM_PROJECT_SUBSCRIPTION_PK
    PRIMARY KEY(PROJECT_SUBSCRIPTION_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_PROJECT_SUBSCRIBED_PK' )     
ALTER TABLE BPM_PROJECT_SUBSCRIBED ADD CONSTRAINT BPM_PROJECT_SUBSCRIBED_PK
    PRIMARY KEY(PROJECT_SUBSCRIBED_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_PC_IDX_ACTION_PK' )     
ALTER TABLE BPM_PC_IDX_ACTION ADD CONSTRAINT BPM_PC_IDX_ACTION_PK
    PRIMARY KEY(ACTION_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_PC_INDEXER_PK' )     
ALTER TABLE BPM_PC_INDEXER ADD CONSTRAINT BPM_PC_INDEXER_PK
    PRIMARY KEY(INDEXER_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_GOVERNANCE_ASSIGNMENT_PK' )     
ALTER TABLE BPM_GOVERNANCE_ASSIGNMENT ADD CONSTRAINT BPM_GOVERNANCE_ASSIGNMENT_PK
    PRIMARY KEY(ASSIGNMENT_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_GOV_DEFAULTS_PK' )     
ALTER TABLE BPM_GOVERNANCE_EVENT ADD CONSTRAINT BPM_GOV_DEFAULTS_PK
    PRIMARY KEY(EVENT_TYPE_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_PD_TRANS_PK' )     
ALTER TABLE LSW_PERF_DATA_TRANSFER ADD CONSTRAINT LSWC_PD_TRANS_PK
    PRIMARY KEY(PERF_DATA_TRANSFER_ID ) WITH (ALLOW_PAGE_LOCKS=OFF, ALLOW_ROW_LOCKS=ON)
    
;


if not exists (select name from sysobjects where name = 'LSWC_TRCKN_GRP_PK' )     
ALTER TABLE LSW_TRACKING_GROUP ADD CONSTRAINT LSWC_TRCKN_GRP_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_TRCKD_VAR_PK' )     
ALTER TABLE LSW_TRACKED_VARIABLE ADD CONSTRAINT LSWC_TRCKD_VAR_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_TRCKN_PT_PK' )     
ALTER TABLE LSW_TRACKING_POINT ADD CONSTRAINT LSWC_TRCKN_PT_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_TRCK_VARU_PK' )     
ALTER TABLE LSW_TRACKED_VARIABLE_USE ADD CONSTRAINT LSWC_TRCK_VARU_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_TMNG_INT_PK' )     
ALTER TABLE LSW_TIMING_INTERVAL ADD CONSTRAINT LSWC_TMNG_INT_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_TMNG_INTB_PK' )     
ALTER TABLE LSW_TIMING_INTERVAL_BOUND ADD CONSTRAINT LSWC_TMNG_INTB_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'BPMC_ECNTR_PK' )     
ALTER TABLE BPM_ECM_CONNECTOR ADD CONSTRAINT BPMC_ECNTR_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_ILDT_PK' )     
ALTER TABLE LSW_ILOG_DECISION ADD CONSTRAINT LSWC_ILDT_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_SCNTR_PK' )     
ALTER TABLE LSW_SCA_CONNECTOR ADD CONSTRAINT LSWC_SCNTR_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_STEP_PK' )     
ALTER TABLE LSW_STEP ADD CONSTRAINT LSWC_STEP_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_CONNECTOR_PK' )     
ALTER TABLE LSW_CONNECTOR ADD CONSTRAINT LSWC_CONNECTOR_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_IC_PK' )     
ALTER TABLE LSW_IC ADD CONSTRAINT LSWC_IC_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_JCNTR_PK' )     
ALTER TABLE LSW_JAVA_CONNECTOR ADD CONSTRAINT LSWC_JCNTR_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_WSNTR_PK' )     
ALTER TABLE LSW_WS_CONNECTOR ADD CONSTRAINT LSWC_WSNTR_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_ILNTR_PK' )     
ALTER TABLE LSW_ILOG_CONNECTOR ADD CONSTRAINT LSWC_ILNTR_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_ICNTR_PK' )     
ALTER TABLE LSW_ICMCASE_CONNECTOR ADD CONSTRAINT LSWC_ICNTR_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_EPV_PR_LK_PK' )     
ALTER TABLE LSW_EPV_PROCESS_LINK ADD CONSTRAINT LSWC_EPV_PR_LK_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_RES_PR_LK_PK' )     
ALTER TABLE LSW_RESOURCE_PROCESS_LINK ADD CONSTRAINT LSWC_RES_PR_LK_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_EXCEPTION_PK' )     
ALTER TABLE LSW_EXCEPTION ADD CONSTRAINT LSWC_EXCEPTION_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_EXIT_POINT_PK' )     
ALTER TABLE LSW_EXIT_POINT ADD CONSTRAINT LSWC_EXIT_POINT_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_TS_FILE_PK' )     
ALTER TABLE LSW_TASK_SENDER_FILE ADD CONSTRAINT LSWC_TS_FILE_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_TS_ADDR_PK' )     
ALTER TABLE LSW_TASK_SENDER_ADDR ADD CONSTRAINT LSWC_TS_ADDR_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_PIPP_PK' )     
ALTER TABLE LSW_PROCESS_ITEM_PRE_POST ADD CONSTRAINT LSWC_PIPP_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_PROC_LINK_PK' )     
ALTER TABLE LSW_PROCESS_LINK ADD CONSTRAINT LSWC_PROC_LINK_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_FILE_PK' )     
ALTER TABLE LSW_FILE ADD CONSTRAINT LSWC_FILE_PK
    PRIMARY KEY(FILE_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_IC_INPUT_PK' )     
ALTER TABLE LSW_IC_INPUT_PROPERTY ADD CONSTRAINT LSWC_IC_INPUT_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_IC_OUTPUT_PK' )     
ALTER TABLE LSW_IC_OUTPUT_PROPERTY ADD CONSTRAINT LSWC_IC_OUTPUT_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_PARAM_MAP_PK' )     
ALTER TABLE LSW_PARAMETER_MAPPING ADD CONSTRAINT LSWC_PARAM_MAP_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_PROCESS_PK' )     
ALTER TABLE LSW_PROCESS ADD CONSTRAINT LSWC_PROCESS_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_PROC_ITEM_PK' )     
ALTER TABLE LSW_PROCESS_ITEM ADD CONSTRAINT LSWC_PROC_ITEM_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_SUBPROCESS_PK' )     
ALTER TABLE LSW_SUBPROCESS ADD CONSTRAINT LSWC_SUBPROCESS_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_PROC_LABEL_PK' )     
ALTER TABLE LSW_PROCESS_LABEL ADD CONSTRAINT LSWC_PROC_LABEL_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_PROC_VAR_PK' )     
ALTER TABLE LSW_PROCESS_VARIABLE ADD CONSTRAINT LSWC_PROC_VAR_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_PRO_PARM_PK' )     
ALTER TABLE LSW_PROCESS_PARAMETER ADD CONSTRAINT LSWC_PRO_PARM_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_SWITCH_PK' )     
ALTER TABLE LSW_SWITCH ADD CONSTRAINT LSWC_SWITCH_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_SWITCH_CON_PK' )     
ALTER TABLE LSW_SWITCH_CONDITION ADD CONSTRAINT LSWC_SWITCH_CON_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_TASK_SEND_PK' )     
ALTER TABLE LSW_TASK_SENDER ADD CONSTRAINT LSWC_TASK_SEND_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_TS_EXVAR_PK' )     
ALTER TABLE LSW_TASK_SENDER_EXVAR ADD CONSTRAINT LSWC_TS_EXVAR_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_REP_PK' )     
ALTER TABLE LSW_REPORT ADD CONSTRAINT LSWC_REP_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_REP_EPV_PK' )     
ALTER TABLE LSW_REPORT_EPV_LINK ADD CONSTRAINT LSWC_REP_EPV_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_REP_RBG_PK' )     
ALTER TABLE LSW_REPORT_RBG_LINK ADD CONSTRAINT LSWC_REP_RBG_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_REP_DS_PK' )     
ALTER TABLE LSW_REPORT_DATASOURCE ADD CONSTRAINT LSWC_REP_DS_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_REP_TG_PK' )     
ALTER TABLE LSW_REPORT_TG_LINK ADD CONSTRAINT LSWC_REP_TG_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_REP_PAGE_PK' )     
ALTER TABLE LSW_REPORT_PAGE ADD CONSTRAINT LSWC_REP_PAGE_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_REP_CHRT_PK' )     
ALTER TABLE LSW_REPORT_CHART ADD CONSTRAINT LSWC_REP_CHRT_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_REP_VAR_PK' )     
ALTER TABLE LSW_REPORT_VARIABLES ADD CONSTRAINT LSWC_REP_VAR_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_REP_DSL_PK' )     
ALTER TABLE LSW_REPORT_DATASOURCE_IC_LINK ADD CONSTRAINT LSWC_REP_DSL_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_REP_DSSL_PK' )     
ALTER TABLE LSW_REPORT_DATASOURCE_SRV_LINK ADD CONSTRAINT LSWC_REP_DSSL_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_REP_DSLL_PK' )     
ALTER TABLE LSW_REPORT_DS_LAYOUT_LINK ADD CONSTRAINT LSWC_REP_DSLL_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_SCBD_PK' )     
ALTER TABLE LSW_SCBD ADD CONSTRAINT LSWC_SCBD_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_SD_RPT_LK_PK' )     
ALTER TABLE LSW_SCBD_RPT_LINK ADD CONSTRAINT LSWC_SD_RPT_LK_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_BLACKCAL_PK' )     
ALTER TABLE LSW_BLACKOUT_CALENDAR ADD CONSTRAINT LSWC_BLACKCAL_PK
    PRIMARY KEY(CALENDAR_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_HOLIDAY_PK' )     
ALTER TABLE LSW_HOLIDAY_SCHEDULE ADD CONSTRAINT LSWC_HOLIDAY_PK
    PRIMARY KEY(HOLIDAY_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_TMPERIOD_PK' )     
ALTER TABLE LSW_TIME_PERIOD ADD CONSTRAINT LSWC_TMPERIOD_PK
    PRIMARY KEY(PERIOD_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_TMSCHEDULE_PK' )     
ALTER TABLE LSW_TIME_SCHEDULE ADD CONSTRAINT LSWC_TMSCHEDULE_PK
    PRIMARY KEY(SCHEDULE_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_SCHPER_PK' )     
ALTER TABLE LSW_TIME_SCHEDULE_PERIOD ADD CONSTRAINT LSWC_SCHPER_PK
    PRIMARY KEY(SCHEDULE_ID ,PERIOD_ID ) 
;


if not exists (select name from sysobjects where name = 'TASK_MEASURES_PK' )     
ALTER TABLE BPM_TASK_ACTIVITY_MEASURES ADD CONSTRAINT TASK_MEASURES_PK
    PRIMARY KEY(TASK_MEASURES_ID ) 
;


if not exists (select name from sysobjects where name = 'BPMC_TASK_MARKERS' )     
ALTER TABLE BPM_TASK_MARKERS ADD CONSTRAINT BPMC_TASK_MARKERS
    PRIMARY KEY(MARKER_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_BPD_DOC_PK2' )     
ALTER TABLE LSW_BPD_DOCUMENTS ADD CONSTRAINT LSWC_BPD_DOC_PK2
    PRIMARY KEY(DOC_ID ) 
;


if not exists (select name from sysobjects where name = 'BPD_INST_VARS_PK' )     
ALTER TABLE LSW_BPD_INSTANCE_VARIABLES ADD CONSTRAINT BPD_INST_VARS_PK
    PRIMARY KEY(BPD_INST_VARS_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_BPD_INST_PK' )     
ALTER TABLE LSW_BPD_INSTANCE ADD CONSTRAINT LSWC_BPD_INST_PK
    PRIMARY KEY(BPD_INSTANCE_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_BPD_NTFY_PK' )     
ALTER TABLE LSW_BPD_NOTIFICATION ADD CONSTRAINT LSWC_BPD_NTFY_PK
    PRIMARY KEY(BPD_NOTIFICATION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_BPD_CMT_PK' )     
ALTER TABLE LSW_BPD_INSTANCE_COMMENT ADD CONSTRAINT LSWC_BPD_CMT_PK
    PRIMARY KEY(COMMENT_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_BPD_DOC_PK' )     
ALTER TABLE LSW_BPD_INSTANCE_DOCUMENTS ADD CONSTRAINT LSWC_BPD_DOC_PK
    PRIMARY KEY(DOC_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_BPD_COD_PK' )     
ALTER TABLE LSW_BPD_STATUS_CODES ADD CONSTRAINT LSWC_BPD_COD_PK
    PRIMARY KEY(STATUS_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_FIL_TYP_PK' )     
ALTER TABLE LSW_FILE_TYPES ADD CONSTRAINT LSWC_FIL_TYP_PK
    PRIMARY KEY(FILETYPE_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_MSG_INCL_PK' )     
ALTER TABLE LSW_INST_MSG_INCL ADD CONSTRAINT LSWC_MSG_INCL_PK
    PRIMARY KEY(ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_MSG_EXCL_PK' )     
ALTER TABLE LSW_INST_MSG_EXCL ADD CONSTRAINT LSWC_MSG_EXCL_PK
    PRIMARY KEY(ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_ERROR_PK' )     
ALTER TABLE LSW_RUNTIME_ERROR ADD CONSTRAINT LSWC_ERROR_PK
    PRIMARY KEY(ERROR_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_STORED_SYMBOL_PK' )     
ALTER TABLE LSW_STORED_SYMBOL_TABLE ADD CONSTRAINT LSWC_STORED_SYMBOL_PK
    PRIMARY KEY(SYMBOL_TABLE_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_TASK_COD_PK' )     
ALTER TABLE LSW_TASK_STATUS_CODES ADD CONSTRAINT LSWC_TASK_COD_PK
    PRIMARY KEY(STATUS_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_TASKEXACD_PK' )     
ALTER TABLE LSW_TASK_EXTACT_DATA ADD CONSTRAINT LSWC_TASKEXACD_PK
    PRIMARY KEY(TASK_EXTACT_DATA_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_TASK_PK' )     
ALTER TABLE LSW_TASK ADD CONSTRAINT LSWC_TASK_PK
    PRIMARY KEY(TASK_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_TASKIPFD_PK' )     
ALTER TABLE LSW_TASK_IPF_DATA ADD CONSTRAINT LSWC_TASKIPFD_PK
    PRIMARY KEY(TASK_INFOPATHFORM_DATA_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_TASK_FILE_PK' )     
ALTER TABLE LSW_TASK_FILE ADD CONSTRAINT LSWC_TASK_FILE_PK
    PRIMARY KEY(TASK_ID ,SEQ ) 
;


if not exists (select name from sysobjects where name = 'LSWC_TASK_ADDR_PK' )     
ALTER TABLE LSW_TASK_ADDR ADD CONSTRAINT LSWC_TASK_ADDR_PK
    PRIMARY KEY(TASK_ADDR_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_TASK_NARR_PK' )     
ALTER TABLE LSW_TASK_NARR ADD CONSTRAINT LSWC_TASK_NARR_PK
    PRIMARY KEY(TASK_NARR_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_TASK_ACTN_PK' )     
ALTER TABLE LSW_TASK_ACTION ADD CONSTRAINT LSWC_TASK_ACTN_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_TASK_EXEC_PK' )     
ALTER TABLE LSW_TASK_EXECUTION_CONTEXT ADD CONSTRAINT LSWC_TASK_EXEC_PK
    PRIMARY KEY(TASK_EXECUTION_CONTEXT_ID ) 
;


if not exists (select name from sysobjects where name = 'WLC_WLSTORE_PK' )     
ALTER TABLE WL_WLSTORE ADD CONSTRAINT WLC_WLSTORE_PK
    PRIMARY KEY(ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_PRI_KEY_PK' )     
ALTER TABLE LSW_PRI_KEY ADD CONSTRAINT LSWC_PRI_KEY_PK
    PRIMARY KEY(TABLE_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_SYSTEM_PK' )     
ALTER TABLE LSW_SYSTEM ADD CONSTRAINT LSWC_SYSTEM_PK
    PRIMARY KEY(PROPKEY ) 
;


if not exists (select name from sysobjects where name = 'LSWC_SYSSCHEMA_PK' )     
ALTER TABLE LSW_SYSTEM_SCHEMA ADD CONSTRAINT LSWC_SYSSCHEMA_PK
    PRIMARY KEY(PROPNAME ) 
;


if not exists (select name from sysobjects where name = 'LSWC_LEGACY_ID' )     
ALTER TABLE LSW_LEGACY_ID ADD CONSTRAINT LSWC_LEGACY_ID
    PRIMARY KEY(LEGACY_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_LOCK' )     
ALTER TABLE LSW_LOCK ADD CONSTRAINT LSWC_LOCK
    PRIMARY KEY(LOCK_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_TASK_INDEX_PK' )     
ALTER TABLE BPM_TASK_INDEX ADD CONSTRAINT BPM_TASK_INDEX_PK
    PRIMARY KEY(TASK_ID ) 
;


if not exists (select name from sysobjects where name = 'BPM_TASK_INDEX_JOB_PK' )     
ALTER TABLE BPM_TASK_INDEX_JOB ADD CONSTRAINT BPM_TASK_INDEX_JOB_PK
    PRIMARY KEY(INDEX_ID ,INDEX_START_TIME ) 
;


if not exists (select name from sysobjects where name = 'LSWC_INV_UCA_PK' )     
ALTER TABLE LSW_INVOKE_UCA ADD CONSTRAINT LSWC_INV_UCA_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_UCA_PK' )     
ALTER TABLE LSW_UCA ADD CONSTRAINT LSWC_UCA_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_UCA_PARM_PK' )     
ALTER TABLE LSW_UCA_PARM ADD CONSTRAINT LSWC_UCA_PARM_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_UCA_BO_PK' )     
ALTER TABLE LSW_UCA_BLACKOUT ADD CONSTRAINT LSWC_UCA_BO_PK
    PRIMARY KEY(BLACKOUT_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_UCA_EVENT_TYPE_PK' )     
ALTER TABLE BPM_UCA_EVENT_TYPE ADD CONSTRAINT LSWC_UCA_EVENT_TYPE_PK
    PRIMARY KEY(UCA_EVENT_TYPE_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_USR_PK' )     
ALTER TABLE LSW_USR ADD CONSTRAINT LSWC_USR_PK
    PRIMARY KEY(USER_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_UXREF_PK' )     
ALTER TABLE LSW_USR_XREF ADD CONSTRAINT LSWC_UXREF_PK
    PRIMARY KEY(USER_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_GXREF_PK' )     
ALTER TABLE LSW_USR_GRP_XREF ADD CONSTRAINT LSWC_GXREF_PK
    PRIMARY KEY(GROUP_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_UGXREF_PK' )     
ALTER TABLE LSW_USR_GRP_MEM_XREF ADD CONSTRAINT LSWC_UGXREF_PK
    PRIMARY KEY(GROUP_ID ,USER_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_GGXREF_PK' )     
ALTER TABLE LSW_GRP_GRP_MEM_XREF ADD CONSTRAINT LSWC_GGXREF_PK
    PRIMARY KEY(GROUP_ID ,CONTAINER_GROUP_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_UA_PK' )     
ALTER TABLE LSW_USR_ASSUME ADD CONSTRAINT LSWC_UA_PK
    PRIMARY KEY(USR_ASSUME_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_ACCESS_PK' )     
ALTER TABLE LSW_ACCESS ADD CONSTRAINT LSWC_ACCESS_PK
    PRIMARY KEY(ASSUMED_USER_ID ,USER_ID ) 
;


if not exists (select name from sysobjects where name = 'LSW_DGRP_PK' )     
ALTER TABLE LSW_DYNAMIC_GROUP ADD CONSTRAINT LSW_DGRP_PK
    PRIMARY KEY(DYNAMIC_GROUP_ID ) 
;


if not exists (select name from sysobjects where name = 'LSW_DGRPC_PK' )     
ALTER TABLE LSW_DYNAMIC_GROUP_CONSTRAINT ADD CONSTRAINT LSW_DGRPC_PK
    PRIMARY KEY(DYNAMIC_GROUP_CONSTRAINT_ID ) 
;


if not exists (select name from sysobjects where name = 'LSW_DGDEP_PK' )     
ALTER TABLE LSW_DYNAMIC_GROUP_DEPENDENCY ADD CONSTRAINT LSW_DGDEP_PK
    PRIMARY KEY(PARENT_GROUP_ID ,CHILD_GROUP_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_USR_ATTR_PK' )     
ALTER TABLE LSW_USR_ATTR ADD CONSTRAINT LSWC_USR_ATTR_PK
    PRIMARY KEY(USER_ATTR_ID ) 
;


if not exists (select name from sysobjects where name = 'U_ATTR_DEF_VAL_PK' )     
ALTER TABLE LSW_USER_ATTR_DEF_VALUES ADD CONSTRAINT U_ATTR_DEF_VAL_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_USRATTRD_PK' )     
ALTER TABLE LSW_USER_ATTRIBUTE_DEF ADD CONSTRAINT LSWC_USRATTRD_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_PARTCP_PK' )     
ALTER TABLE LSW_PARTICIPANT ADD CONSTRAINT LSWC_PARTCP_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_ACL_ENTRY_PK' )     
ALTER TABLE LSW_ACL_ENTRY ADD CONSTRAINT LSWC_ACL_ENTRY_PK
    PRIMARY KEY(ACL_ENTRY_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_FAV_PK' )     
ALTER TABLE LSW_FAVORITE ADD CONSTRAINT LSWC_FAV_PK
    PRIMARY KEY(FAVORITE_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_USR_AVATAR_PK' )     
ALTER TABLE BPM_USR_AVATAR ADD CONSTRAINT LSWC_USR_AVATAR_PK
    PRIMARY KEY(USER_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_SNAPSHOT_PK' )     
ALTER TABLE LSW_SNAPSHOT ADD CONSTRAINT LSWC_SNAPSHOT_PK
    PRIMARY KEY(SNAPSHOT_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_BRANCH_PK' )     
ALTER TABLE LSW_BRANCH ADD CONSTRAINT LSWC_BRANCH_PK
    PRIMARY KEY(BRANCH_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_PROJECT_PK' )     
ALTER TABLE LSW_PROJECT ADD CONSTRAINT LSWC_PROJECT_PK
    PRIMARY KEY(PROJECT_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_PO_VERSIONS' )     
ALTER TABLE LSW_PO_VERSIONS ADD CONSTRAINT LSWC_PO_VERSIONS
    PRIMARY KEY(PO_VERSION_ID ,BRANCH_ID ,VERSION_SUMMARY_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_PROJ_DEP_PK' )     
ALTER TABLE LSW_PROJECT_DEPENDENCY ADD CONSTRAINT LSWC_PROJ_DEP_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_DEP_PATH' )     
ALTER TABLE LSW_DEP_PATH ADD CONSTRAINT LSWC_DEP_PATH
    PRIMARY KEY(DEP_PATH_ID ,IDX ) 
;


if not exists (select name from sysobjects where name = 'LSWC_PO_REFERENCE' )     
ALTER TABLE LSW_PO_REFERENCE ADD CONSTRAINT LSWC_PO_REFERENCE
    PRIMARY KEY(REFERENCE_ID ,BRANCH_ID ,START_SEQ_NUM ) 
;


if not exists (select name from sysobjects where name = 'LSWC_PO_DEPENDENCY' )     
ALTER TABLE LSW_PO_DEPENDENCY ADD CONSTRAINT LSWC_PO_DEPENDENCY
    PRIMARY KEY(BRANCH_ID ,START_SEQ_NUM ,SOURCE_ID ,SOURCE_LOCATION ) 
;


if not exists (select name from sysobjects where name = 'LSWC_RT_REFERENCE' )     
ALTER TABLE LSW_RT_REFERENCE ADD CONSTRAINT LSWC_RT_REFERENCE
    PRIMARY KEY(REFERENCE_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_WEB_SRV_PK' )     
ALTER TABLE LSW_WEB_SERVICE ADD CONSTRAINT LSWC_WEB_SRV_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sysobjects where name = 'LSWC_WEBSRV_OP_PK' )     
ALTER TABLE LSW_WEB_SERVICE_OP ADD CONSTRAINT LSWC_WEBSRV_OP_PK
    PRIMARY KEY(VERSION_ID ) 
;


if not exists (select name from sys.indexes where name = 'LSWC_METRIC_PK3' )
CREATE INDEX LSWC_METRIC_PK3 ON LSW_METRIC(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_METRIC' )
CREATE INDEX IDX_METRIC ON LSW_METRIC(METRIC_ID) 
;


if not exists (select name from sys.indexes where name = 'IDX_METRIC2' )
CREATE INDEX IDX_METRIC2 ON LSW_METRIC(NAME) 
;


if not exists (select name from sys.indexes where name = 'LSWC_SLA_PK3' )
CREATE INDEX LSWC_SLA_PK3 ON LSW_SLA(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_SIM_SCEN_PK3' )
CREATE INDEX LSWC_SIM_SCEN_PK3 ON LSW_SIM_SCENARIO(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_HIST_SCEN_PK3' )
CREATE INDEX LSWC_HIST_SCEN_PK3 ON LSW_HIST_SCENARIO(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_HISTSC1' )
CREATE INDEX IDX_HISTSC1 ON LSW_HIST_SCENARIO(NAME) 
;


if not exists (select name from sys.indexes where name = 'IDX_HISTSC2' )
CREATE INDEX IDX_HISTSC2 ON LSW_HIST_SCENARIO(SCENARIO_ID) 
;


if not exists (select name from sys.indexes where name = 'BPM_EVENT_SUBSCRIPTION_PK3' )
CREATE INDEX BPM_EVENT_SUBSCRIPTION_PK3 ON BPM_EVENT_SUBSCRIPTION(GUID) 
;


if not exists (select name from sys.indexes where name = 'BPM_EVENT_SUBSCRIPTION_IDX1' )
CREATE INDEX BPM_EVENT_SUBSCRIPTION_IDX1 ON BPM_EVENT_SUBSCRIPTION(EVENT_SUBSCRIPTION_TYPE_ID,EVENT_TYPE,OBJECT_TYPE_ID,INCLUDE_SUB_TYPE) 
;


if not exists (select name from sys.indexes where name = 'BPM_STAY_ON_PAGE_PK3' )
CREATE INDEX BPM_STAY_ON_PAGE_PK3 ON LSW_STAY_ON_PAGE(GUID) 
;


if not exists (select name from sys.indexes where name = 'BPM_PAREF_PK2' )
CREATE INDEX BPM_PAREF_PK2 ON BPM_PROC_ARTIFACT_REF(PROCESS_ID) 
;


if not exists (select name from sys.indexes where name = 'BPM_PAREF_PK3' )
CREATE INDEX BPM_PAREF_PK3 ON BPM_PROC_ARTIFACT_REF(GUID) 
;


if not exists (select name from sys.indexes where name = 'BPM_PAREF_NUQ' )
CREATE INDEX BPM_PAREF_NUQ ON BPM_PROC_ARTIFACT_REF(PROCESS_ID,ARTIFACT_ID,VERSION_ID) 
;


if not exists (select name from sys.indexes where name = 'BPM_CAREF_PK2' )
CREATE INDEX BPM_CAREF_PK2 ON BPM_CLS_ARTIFACT_REF(CLASS_ID) 
;


if not exists (select name from sys.indexes where name = 'BPM_CAREF_PK3' )
CREATE INDEX BPM_CAREF_PK3 ON BPM_CLS_ARTIFACT_REF(GUID) 
;


if not exists (select name from sys.indexes where name = 'BPM_CAREF_NUQ' )
CREATE INDEX BPM_CAREF_NUQ ON BPM_CLS_ARTIFACT_REF(CLASS_ID,ARTIFACT_ID,VERSION_ID) 
;


if not exists (select name from sys.indexes where name = 'BPM_BAREF_PK2' )
CREATE INDEX BPM_BAREF_PK2 ON BPM_BPD_ARTIFACT_REF(BPD_ID) 
;


if not exists (select name from sys.indexes where name = 'BPM_BAREF_PK3' )
CREATE INDEX BPM_BAREF_PK3 ON BPM_BPD_ARTIFACT_REF(GUID) 
;


if not exists (select name from sys.indexes where name = 'BPM_BAREF_NUQ' )
CREATE INDEX BPM_BAREF_NUQ ON BPM_BPD_ARTIFACT_REF(BPD_ID,ARTIFACT_ID,VERSION_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_BPD_PK3' )
CREATE INDEX LSWC_BPD_PK3 ON LSW_BPD(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_BPD_EVNT_NUQ2' )
CREATE INDEX LSWC_BPD_EVNT_NUQ2 ON LSW_BPD_EVENT(BPD_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_BPD_EVNT_NUQ3' )
CREATE INDEX LSWC_BPD_EVNT_NUQ3 ON LSW_BPD_EVENT(CORRELATION_PARAMETER_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_BPD_EVNT_NUQ4' )
CREATE INDEX LSWC_BPD_EVNT_NUQ4 ON LSW_BPD_EVENT(BPD_EVENT_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_BPD_EVNT_NUQ5' )
CREATE INDEX LSWC_BPD_EVNT_NUQ5 ON LSW_BPD_EVENT(BPD_FLOW_OBJECT_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_BPD_EVNT_NUQ6' )
CREATE INDEX LSWC_BPD_EVNT_NUQ6 ON LSW_BPD_EVENT(BPD_OBJECT_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_BPD_PARM_PK3' )
CREATE INDEX LSWC_BPD_PARM_PK3 ON LSW_BPD_PARAMETER(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_BPD_PARM' )
CREATE INDEX IDX_BPD_PARM ON LSW_BPD_PARAMETER(BPD_ID,SEQ) 
;


if not exists (select name from sys.indexes where name = 'IDX2_BPD_PARM' )
CREATE INDEX IDX2_BPD_PARM ON LSW_BPD_PARAMETER(SEQ,VERSION_ID) 
;


if not exists (select name from sys.indexes where name = 'IDX3_BPD_PARM' )
CREATE INDEX IDX3_BPD_PARM ON LSW_BPD_PARAMETER(BPD_PARAMETER_ID) 
;


if not exists (select name from sysobjects where name = 'BPM_SHARED_OBJECT_FK' )
ALTER TABLE BPM_SHARED_OBJECT ADD CONSTRAINT BPM_SHARED_OBJECT_FK
	FOREIGN KEY(CLASS_VERSION_ID)
	REFERENCES LSW_CLASS(VERSION_ID)
	
;


if not exists (select name from sysobjects where name = 'BPM_SHARED_OBJ_TO_INSTANCE' )
ALTER TABLE BPM_SHARED_OBJECT ADD CONSTRAINT BPM_SHARED_OBJ_TO_INSTANCE
	FOREIGN KEY(BPD_INSTANCE_ID)
	REFERENCES LSW_BPD_INSTANCE(BPD_INSTANCE_ID)
	ON DELETE CASCADE
;


if not exists (select name from sysobjects where name = 'BPM_SHARED_OBJ_TO_TASK' )
ALTER TABLE BPM_SHARED_OBJECT ADD CONSTRAINT BPM_SHARED_OBJ_TO_TASK
	FOREIGN KEY(TASK_ID)
	REFERENCES LSW_TASK(TASK_ID)
	ON DELETE CASCADE
;


if not exists (select name from sys.indexes where name = 'BPM_SHARED_OBJECT_UQ' )
CREATE UNIQUE INDEX BPM_SHARED_OBJECT_UQ ON BPM_SHARED_OBJECT(OBJECT_ID,DEFINITION_VERSION)

;


if not exists (select name from sys.indexes where name = 'BPM_SHARED_OBJECT_IDX1' )
CREATE INDEX BPM_SHARED_OBJECT_IDX1 ON BPM_SHARED_OBJECT(TASK_ID) 
;


if not exists (select name from sys.indexes where name = 'BPM_SHARED_OBJECT_INSTANCE_PK2' )
CREATE INDEX BPM_SHARED_OBJECT_INSTANCE_PK2 ON BPM_SHARED_OBJECT_INSTANCE(DEFINITION_VERSION_ID) 
;


if not exists (select name from sysobjects where name = 'BPM_SHARED_OBJECT_INSTANCE_FK' )
ALTER TABLE BPM_SHARED_OBJECT_INSTANCE ADD CONSTRAINT BPM_SHARED_OBJECT_INSTANCE_FK
	FOREIGN KEY(DEFINITION_VERSION_ID)
	REFERENCES BPM_SHARED_OBJECT(DEFINITION_VERSION_ID)
	ON DELETE CASCADE
;


if not exists (select name from sys.indexes where name = 'BPM_SHARED_OBJECT_INSTANCE_UQ' )
CREATE UNIQUE INDEX BPM_SHARED_OBJECT_INSTANCE_UQ ON BPM_SHARED_OBJECT_INSTANCE(DEFINITION_VERSION_ID,INSTANCE_VERSION)

;


if not exists (select name from sys.indexes where name = 'BPM_SHARED_OBJECT_VALUE_PK2' )
CREATE INDEX BPM_SHARED_OBJECT_VALUE_PK2 ON BPM_SHARED_OBJECT_VALUE(INSTANCE_VERSION_ID) 
;


if not exists (select name from sysobjects where name = 'BPM_SHARED_OBJECT_VALUE_FK' )
ALTER TABLE BPM_SHARED_OBJECT_VALUE ADD CONSTRAINT BPM_SHARED_OBJECT_VALUE_FK
	FOREIGN KEY(INSTANCE_VERSION_ID)
	REFERENCES BPM_SHARED_OBJECT_INSTANCE(INSTANCE_VERSION_ID)
	ON DELETE CASCADE
;


if not exists (select name from sys.indexes where name = 'BPM_CH_VIEW_PK3' )
CREATE INDEX BPM_CH_VIEW_PK3 ON BPM_COACH_VIEW(GUID) 
;


if not exists (select name from sys.indexes where name = 'BPM_VIEW_LOC_PK2' )
CREATE INDEX BPM_VIEW_LOC_PK2 ON BPM_COACH_VIEW_LOCAL_RES(COACH_VIEW_ID) 
;


if not exists (select name from sys.indexes where name = 'BPM_VIEW_LOC_PK3' )
CREATE INDEX BPM_VIEW_LOC_PK3 ON BPM_COACH_VIEW_LOCAL_RES(GUID) 
;


if not exists (select name from sys.indexes where name = 'BPM_VIEW_BIND_PK2' )
CREATE INDEX BPM_VIEW_BIND_PK2 ON BPM_COACH_VIEW_BINDING_TYPE(COACH_VIEW_ID) 
;


if not exists (select name from sys.indexes where name = 'BPM_VIEW_BIND_PK3' )
CREATE INDEX BPM_VIEW_BIND_PK3 ON BPM_COACH_VIEW_BINDING_TYPE(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_VIEW_BIND' )
CREATE INDEX IDX_VIEW_BIND ON BPM_COACH_VIEW_BINDING_TYPE(SEQ) 
;


if not exists (select name from sys.indexes where name = 'BPM_VIEW_CONFIG_PK2' )
CREATE INDEX BPM_VIEW_CONFIG_PK2 ON BPM_COACH_VIEW_CONFIG_OPTION(COACH_VIEW_ID) 
;


if not exists (select name from sys.indexes where name = 'BPM_VIEW_CONFIG_PK3' )
CREATE INDEX BPM_VIEW_CONFIG_PK3 ON BPM_COACH_VIEW_CONFIG_OPTION(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_VIEW_CONFIG' )
CREATE INDEX IDX_VIEW_CONFIG ON BPM_COACH_VIEW_CONFIG_OPTION(SEQ) 
;


if not exists (select name from sys.indexes where name = 'BPM_VIEW_RES_PK2' )
CREATE INDEX BPM_VIEW_RES_PK2 ON BPM_COACH_VIEW_RESOURCE(COACH_VIEW_ID) 
;


if not exists (select name from sys.indexes where name = 'BPM_VIEW_RES_PK3' )
CREATE INDEX BPM_VIEW_RES_PK3 ON BPM_COACH_VIEW_RESOURCE(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_VIEW_RES' )
CREATE INDEX IDX_VIEW_RES ON BPM_COACH_VIEW_RESOURCE(SEQ) 
;


if not exists (select name from sys.indexes where name = 'BPM_VIEW_SCRIPT_PK2' )
CREATE INDEX BPM_VIEW_SCRIPT_PK2 ON BPM_COACH_VIEW_INLINE_SCRIPT(COACH_VIEW_ID) 
;


if not exists (select name from sys.indexes where name = 'BPM_VIEW_SCRIPT_PK3' )
CREATE INDEX BPM_VIEW_SCRIPT_PK3 ON BPM_COACH_VIEW_INLINE_SCRIPT(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_VIEW_SCRIPT' )
CREATE INDEX IDX_VIEW_SCRIPT ON BPM_COACH_VIEW_INLINE_SCRIPT(SEQ) 
;


if not exists (select name from sys.indexes where name = 'BPM_VIEW_AMD_PK2' )
CREATE INDEX BPM_VIEW_AMD_PK2 ON BPM_COACH_VIEW_AMD_DEP(COACH_VIEW_ID) 
;


if not exists (select name from sys.indexes where name = 'BPM_VIEW_AMD_PK3' )
CREATE INDEX BPM_VIEW_AMD_PK3 ON BPM_COACH_VIEW_AMD_DEP(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_VIEW_AMD' )
CREATE INDEX IDX_VIEW_AMD ON BPM_COACH_VIEW_AMD_DEP(SEQ) 
;


if not exists (select name from sys.indexes where name = 'BPM_COACHNG_PK3' )
CREATE INDEX BPM_COACHNG_PK3 ON BPM_COACHNG(GUID) 
;


if not exists (select name from sys.indexes where name = 'BPM_COACHNG_BE_PK3' )
CREATE INDEX BPM_COACHNG_BE_PK3 ON BPM_COACHNG_BOUNDARY_EVENT(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_COACHNG_BE' )
CREATE INDEX IDX_COACHNG_BE ON BPM_COACHNG_BOUNDARY_EVENT(COACHNG_ID,SEQ) 
;


if not exists (select name from sys.indexes where name = 'LSWC_COACH_PK3' )
CREATE INDEX LSWC_COACH_PK3 ON LSW_COACH(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_COACH_BTN_PK3' )
CREATE INDEX LSWC_COACH_BTN_PK3 ON LSW_COACH_BUTTON(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_COACH_BTN' )
CREATE INDEX IDX_COACH_BTN ON LSW_COACH_BUTTON(COACH_ID,SEQ) 
;


if not exists (select name from sys.indexes where name = 'LSWC_COACH_RES_PK3' )
CREATE INDEX LSWC_COACH_RES_PK3 ON LSW_COACH_RESOURCE(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_COACH_RES' )
CREATE INDEX IDX_COACH_RES ON LSW_COACH_RESOURCE(COACH_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_INFOPATHF_PK3' )
CREATE INDEX LSWC_INFOPATHF_PK3 ON LSW_INFOPATH_FORM(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_INFOPATHF' )
CREATE INDEX IDX_INFOPATHF ON LSW_INFOPATH_FORM(NAME) 
;


if not exists (select name from sys.indexes where name = 'LSWC_EM_TASK_LOAD' )
CREATE UNIQUE INDEX LSWC_EM_TASK_LOAD ON LSW_EM_TASK(TASK_ID,QUEUE_ID,SCHEDULED_TIME,DISCRIMINATOR)

;


if not exists (select name from sys.indexes where name = 'LSWC_EM_KEYWORDS' )
CREATE UNIQUE INDEX LSWC_EM_KEYWORDS ON LSW_EM_TASK_KEYWORDS(KEYWORD,TASK_ID)

;


if not exists (select name from sys.indexes where name = 'LSWC_EM_INST_UQ' )
CREATE UNIQUE INDEX LSWC_EM_INST_UQ ON LSW_EM_INSTANCE(NAME)

;


if not exists (select name from sys.indexes where name = 'LSWC_SYNCQUEUE_UQ' )
CREATE UNIQUE INDEX LSWC_SYNCQUEUE_UQ ON LSW_UCA_SYNC_QUEUE(DESCRIPTION)

;


if not exists (select name from sys.indexes where name = 'IDX_SYNCQUEUE' )
CREATE INDEX IDX_SYNCQUEUE ON LSW_UCA_SYNC_QUEUE(QUEUE_OWNER) 
;


if not exists (select name from sys.indexes where name = 'LSWC_ENV_VARS_PK3' )
CREATE INDEX LSWC_ENV_VARS_PK3 ON LSW_ENV_VAR_SET(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_ENV_VARS' )
CREATE INDEX IDX_ENV_VARS ON LSW_ENV_VAR_SET(ENV_VAR_SET_ID) 
;


if not exists (select name from sys.indexes where name = 'IDX2_ENV_VARS' )
CREATE INDEX IDX2_ENV_VARS ON LSW_ENV_VAR_SET(NAME) 
;


if not exists (select name from sys.indexes where name = 'LSWC_ENV_VAR_PK2' )
CREATE INDEX LSWC_ENV_VAR_PK2 ON LSW_ENV_VAR(ENV_VAR_SET_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_ENV_VAR_PK3' )
CREATE INDEX LSWC_ENV_VAR_PK3 ON LSW_ENV_VAR(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_ENV_VAR' )
CREATE INDEX IDX_ENV_VAR ON LSW_ENV_VAR(ENV_VAR_ID) 
;


if not exists (select name from sysobjects where name = 'LSWC_E_VAR_VAL_FK' )
ALTER TABLE LSW_ENV_VAR_VAL ADD CONSTRAINT LSWC_E_VAR_VAL_FK
	FOREIGN KEY(SNAPSHOT_ID)
	REFERENCES LSW_SNAPSHOT(SNAPSHOT_ID)
	ON DELETE CASCADE
;


if not exists (select name from sys.indexes where name = 'IDX_EVV_SNAP' )
CREATE INDEX IDX_EVV_SNAP ON LSW_ENV_VAR_VAL(SNAPSHOT_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_ENV_DFLT_PK2' )
CREATE INDEX LSWC_ENV_DFLT_PK2 ON LSW_ENV_VAR_DEFAULT(ENV_VAR_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_ENV_DFLT_PK3' )
CREATE INDEX LSWC_ENV_DFLT_PK3 ON LSW_ENV_VAR_DEFAULT(GUID) 
;


if not exists (select name from sysobjects where name = 'LSWC_ENV_DFLT_FK' )
ALTER TABLE LSW_ENV_VAR_DEFAULT ADD CONSTRAINT LSWC_ENV_DFLT_FK
	FOREIGN KEY(ENV_TYPE_ID)
	REFERENCES LSW_ENV_TYPE(ENV_TYPE_ID)
	
;


if not exists (select name from sys.indexes where name = 'IDX_ENVVARDEF' )
CREATE INDEX IDX_ENVVARDEF ON LSW_ENV_VAR_DEFAULT(ENV_VAR_ID,ENV_TYPE_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_EPV_PK3' )
CREATE INDEX LSWC_EPV_PK3 ON LSW_EPV(GUID) 
;


if not exists (select name from sysobjects where name = 'LSWC_EPV_FK1' )
ALTER TABLE LSW_EPV ADD CONSTRAINT LSWC_EPV_FK1
	FOREIGN KEY(LAST_MODIFIED_BY_USER_ID)
	REFERENCES LSW_USR_XREF(USER_ID)
	
;


if not exists (select name from sys.indexes where name = 'LSWC_EPV_VAR_PK3' )
CREATE INDEX LSWC_EPV_VAR_PK3 ON LSW_EPV_VAR(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_EPVV_SNAP' )
CREATE INDEX IDX_EPVV_SNAP ON LSW_EPV_VAR_VALUE(SNAPSHOT_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_BPS_PK3' )
CREATE INDEX LSWC_BPS_PK3 ON LSW_BLUEPRINT_SUBSCRIPTION(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_EA_PARAM_PK3' )
CREATE INDEX LSWC_EA_PARAM_PK3 ON LSW_EXTACT_PARAMETER(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_EA_PROP_PK3' )
CREATE INDEX LSWC_EA_PROP_PK3 ON LSW_EXTACT_PROPERTY(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_EXT_ACT_PK3' )
CREATE INDEX LSWC_EXT_ACT_PK3 ON LSW_EXTERNAL_ACTIVITY(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_EXT_ACT' )
CREATE INDEX IDX_EXT_ACT ON LSW_EXTERNAL_ACTIVITY(NAME) 
;


if not exists (select name from sys.indexes where name = 'LSWC_MGD_ASSET_PK3' )
CREATE INDEX LSWC_MGD_ASSET_PK3 ON LSW_MANAGED_ASSET(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX1_MGDASSET' )
CREATE INDEX IDX1_MGDASSET ON LSW_MANAGED_ASSET(NAME) 
;


if not exists (select name from sys.indexes where name = 'BPM_NODE_PK3' )
CREATE INDEX BPM_NODE_PK3 ON BPM_CONTRIBUTION(GUID) 
;


if not exists (select name from sys.indexes where name = 'BPM_IDX_NODE' )
CREATE INDEX BPM_IDX_NODE ON BPM_CONTRIBUTION(CONTRIBUTION_ID) 
;


if not exists (select name from sys.indexes where name = 'BPM_IDX2_NODE' )
CREATE INDEX BPM_IDX2_NODE ON BPM_CONTRIBUTION(NAME) 
;


if not exists (select name from sys.indexes where name = 'BPM_IDX3_NODE' )
CREATE INDEX BPM_IDX3_NODE ON BPM_CONTRIBUTION(FILENAME) 
;


if not exists (select name from sys.indexes where name = 'BPM_CPRP_PK2' )
CREATE INDEX BPM_CPRP_PK2 ON BPM_CTRB_PROPERTY(CONTRIBUTION_ID) 
;


if not exists (select name from sys.indexes where name = 'BPM_CPRP_PK3' )
CREATE INDEX BPM_CPRP_PK3 ON BPM_CTRB_PROPERTY(GUID) 
;


if not exists (select name from sys.indexes where name = 'BPM_CPRP_NUQ' )
CREATE INDEX BPM_CPRP_NUQ ON BPM_CTRB_PROPERTY(CONTRIBUTION_ID,VERSION_ID) 
;


if not exists (select name from sys.indexes where name = 'BPM_IDX_CPRP' )
CREATE INDEX BPM_IDX_CPRP ON BPM_CTRB_PROPERTY(NAME) 
;


if not exists (select name from sys.indexes where name = 'BPM_CDEP_PK2' )
CREATE INDEX BPM_CDEP_PK2 ON BPM_CTRB_DEPENDENCY(CONTRIBUTION_ID) 
;


if not exists (select name from sys.indexes where name = 'BPM_CDEP_PK3' )
CREATE INDEX BPM_CDEP_PK3 ON BPM_CTRB_DEPENDENCY(GUID) 
;


if not exists (select name from sys.indexes where name = 'BPM_CDEP_NUQ' )
CREATE INDEX BPM_CDEP_NUQ ON BPM_CTRB_DEPENDENCY(CONTRIBUTION_ID,VERSION_ID) 
;


if not exists (select name from sys.indexes where name = 'BPM_NPRP_PK3' )
CREATE INDEX BPM_NPRP_PK3 ON BPM_ARTIFACT(GUID) 
;


if not exists (select name from sys.indexes where name = 'BPM_IDX_ART' )
CREATE INDEX BPM_IDX_ART ON BPM_ARTIFACT(ARTIFACT_ID) 
;


if not exists (select name from sys.indexes where name = 'BPM_IDX2_ART' )
CREATE INDEX BPM_IDX2_ART ON BPM_ARTIFACT(NAME) 
;


if not exists (select name from sys.indexes where name = 'BPM_IDX3_ART' )
CREATE INDEX BPM_IDX3_ART ON BPM_ARTIFACT(FULL_PATH) 
;


if not exists (select name from sys.indexes where name = 'BPM_MMDATA_UQ' )
CREATE UNIQUE INDEX BPM_MMDATA_UQ ON BPM_MON_MODEL_DATA(NAME)

;


if not exists (select name from sys.indexes where name = 'IDX_USER_FAV' )
CREATE UNIQUE INDEX IDX_USER_FAV ON LSW_USER_FAVORITE(USER_ID,PO_ID)

;


if not exists (select name from sys.indexes where name = 'IDX_USERFAV1' )
CREATE INDEX IDX_USERFAV1 ON LSW_USER_FAVORITE(PO_ID) 
;


if not exists (select name from sysobjects where name = 'LSWC_SF_SS_FK' )
ALTER TABLE LSW_SMART_FOLDER ADD CONSTRAINT LSWC_SF_SS_FK
	FOREIGN KEY(SNAPSHOT_ID)
	REFERENCES LSW_SNAPSHOT(SNAPSHOT_ID)
	ON DELETE CASCADE
;


if not exists (select name from sys.indexes where name = 'LSWC_SF_NAME' )
CREATE INDEX LSWC_SF_NAME ON LSW_SMART_FOLDER(NAME) 
;


if not exists (select name from sysobjects where name = 'LSWC_TEMPLATE_FK' )
ALTER TABLE LSW_CA_TEMPLATE_DATA ADD CONSTRAINT LSWC_TEMPLATE_FK
	FOREIGN KEY(ID)
	REFERENCES LSW_CA_TEMPLATE(ID)
	
;


if not exists (select name from sysobjects where name = 'LSWC_LAUNCHER_FK' )
ALTER TABLE LSW_LAUNCHER ADD CONSTRAINT LSWC_LAUNCHER_FK
	FOREIGN KEY(USER_ID)
	REFERENCES LSW_USR_XREF(USER_ID)
	
;


if not exists (select name from sys.indexes where name = 'LSWC_NAME_UQ' )
CREATE UNIQUE INDEX LSWC_NAME_UQ ON LSW_LAUNCHER(NAME)

;


if not exists (select name from sys.indexes where name = 'LSWC_NAME_NUQ' )
CREATE INDEX LSWC_NAME_NUQ ON LSW_LAUNCHER(USER_ID) 
;


if not exists (select name from sysobjects where name = 'LSWC_BRKPNT_FK3' )
ALTER TABLE LSW_BREAKPOINT ADD CONSTRAINT LSWC_BRKPNT_FK3
	FOREIGN KEY(USER_ID)
	REFERENCES LSW_USR_XREF(USER_ID)
	
;


if not exists (select name from sys.indexes where name = 'LSWC_CLASS_PK3' )
CREATE INDEX LSWC_CLASS_PK3 ON LSW_CLASS(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSW_IDX_CLASS' )
CREATE INDEX LSW_IDX_CLASS ON LSW_CLASS(CLASS_ID) 
;


if not exists (select name from sys.indexes where name = 'LSW_IDX2_CLASS' )
CREATE INDEX LSW_IDX2_CLASS ON LSW_CLASS(NAME) 
;


if not exists (select name from sys.indexes where name = 'LSWC_LAYOUT_PK3' )
CREATE INDEX LSWC_LAYOUT_PK3 ON LSW_LAYOUT(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSW_IDX_LAYOUT' )
CREATE INDEX LSW_IDX_LAYOUT ON LSW_LAYOUT(LAYOUT_ID) 
;


if not exists (select name from sys.indexes where name = 'LSW_IDX2_LAYOUT' )
CREATE INDEX LSW_IDX2_LAYOUT ON LSW_LAYOUT(DOCUMENT_TYPE) 
;


if not exists (select name from sys.indexes where name = 'LSWC_LOUT_PRM_PK3' )
CREATE INDEX LSWC_LOUT_PRM_PK3 ON LSW_LAYOUT_PARAM(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_LYTPM' )
CREATE INDEX IDX_LYTPM ON LSW_LAYOUT_PARAM(LAYOUT_PARAM_ID) 
;


if not exists (select name from sys.indexes where name = 'IDX2_LYTPM' )
CREATE INDEX IDX2_LYTPM ON LSW_LAYOUT_PARAM(VERSION_ID,SEQ) 
;


if not exists (select name from sys.indexes where name = 'LSWC_PRJ_DFTS_PK3' )
CREATE INDEX LSWC_PRJ_DFTS_PK3 ON LSW_PROJECT_DEFAULTS(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_RBGROUP_PK3' )
CREATE INDEX LSWC_RBGROUP_PK3 ON LSW_RESOURCE_BUNDLE_GROUP(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_RBUNDLE_PK2' )
CREATE INDEX LSWC_RBUNDLE_PK2 ON LSW_RESOURCE_BUNDLE(RESOURCE_BUNDLE_GROUP_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_RBUNDLE_PK3' )
CREATE INDEX LSWC_RBUNDLE_PK3 ON LSW_RESOURCE_BUNDLE(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_RBKEY_PK2' )
CREATE INDEX LSWC_RBKEY_PK2 ON LSW_RESOURCE_BUNDLE_KEY(RESOURCE_BUNDLE_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_RBKEY_PK3' )
CREATE INDEX LSWC_RBKEY_PK3 ON LSW_RESOURCE_BUNDLE_KEY(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_SCRIPT_PK3' )
CREATE INDEX LSWC_SCRIPT_PK3 ON LSW_SCRIPT(GUID) 
;


if not exists (select name from sysobjects where name = 'LSWC_INSTL_GRP_FK' )
ALTER TABLE LSW_SERVER ADD CONSTRAINT LSWC_INSTL_GRP_FK
	FOREIGN KEY(INSTALLER_GROUP_ID)
	REFERENCES LSW_USR_GRP_XREF(GROUP_ID)
	
;


if not exists (select name from sysobjects where name = 'LSWC_DEP_SS_FK' )
ALTER TABLE LSW_DEPLOYMENT ADD CONSTRAINT LSWC_DEP_SS_FK
	FOREIGN KEY(SNAPSHOT_ID)
	REFERENCES LSW_SNAPSHOT(SNAPSHOT_ID)
	ON DELETE CASCADE
;


if not exists (select name from sys.indexes where name = 'IDX_DPL1' )
CREATE INDEX IDX_DPL1 ON LSW_DEPLOYMENT(SNAPSHOT_ID) 
;


if not exists (select name from sys.indexes where name = 'IDX_DPL2' )
CREATE INDEX IDX_DPL2 ON LSW_DEPLOYMENT(SERVER_ID) 
;


if not exists (select name from sysobjects where name = 'LSWC_SVRCAP_FK1' )
ALTER TABLE LSW_SERVER_CAPABILITY ADD CONSTRAINT LSWC_SVRCAP_FK1
	FOREIGN KEY(SERVER_ID)
	REFERENCES LSW_SERVER(SERVER_ID)
	
;


if not exists (select name from sys.indexes where name = 'IDX_CAPCFG_ID' )
CREATE INDEX IDX_CAPCFG_ID ON LSW_CAPABILITY_TYPE(CAPABILITY_CONFIG_ID) 
;


if not exists (select name from sysobjects where name = 'LSWC_DPLPKG_FK1' )
ALTER TABLE LSW_DEPLOYMENT_PACKAGE ADD CONSTRAINT LSWC_DPLPKG_FK1
	FOREIGN KEY(SNAPSHOT_ID)
	REFERENCES LSW_SNAPSHOT(SNAPSHOT_ID)
	ON DELETE CASCADE
;


if not exists (select name from sysobjects where name = 'LSWC_DPLPKG_FK2' )
ALTER TABLE LSW_DEPLOYMENT_PACKAGE ADD CONSTRAINT LSWC_DPLPKG_FK2
	FOREIGN KEY(SERVER_ID)
	REFERENCES LSW_SERVER(SERVER_ID)
	
;


if not exists (select name from sys.indexes where name = 'LSWC_DPLPKG_UQ' )
CREATE UNIQUE INDEX LSWC_DPLPKG_UQ ON LSW_DEPLOYMENT_PACKAGE(SNAPSHOT_ID,SERVER_ID)

;


if not exists (select name from sys.indexes where name = 'PROJECT_ID_UQ' )
CREATE UNIQUE INDEX PROJECT_ID_UQ ON BPM_PROJECT_SUBSCRIPTION(PROJECT_ID)

;


if not exists (select name from sys.indexes where name = 'BPM_PC_INDEXER_UC' )
CREATE UNIQUE INDEX BPM_PC_INDEXER_UC ON BPM_PC_INDEXER(NAME)

;


if not exists (select name from sysobjects where name = 'BPM_GOVERNANCE_ASSIGNMENT_FK1' )
ALTER TABLE BPM_GOVERNANCE_ASSIGNMENT ADD CONSTRAINT BPM_GOVERNANCE_ASSIGNMENT_FK1
	FOREIGN KEY(PROJECT_ID)
	REFERENCES LSW_PROJECT(PROJECT_ID)
	ON DELETE CASCADE
;


if not exists (select name from sys.indexes where name = 'LSWC_PXFER_OWNER' )
CREATE INDEX LSWC_PXFER_OWNER ON LSW_PERF_DATA_TRANSFER(CLAIMED_BY) WITH (ALLOW_PAGE_LOCKS=OFF, ALLOW_ROW_LOCKS=ON)
    
;


if not exists (select name from sys.indexes where name = 'LSWC_PXFER_TIME' )
CREATE INDEX LSWC_PXFER_TIME ON LSW_PERF_DATA_TRANSFER(TIME_CLAIMED) WITH (ALLOW_PAGE_LOCKS=OFF, ALLOW_ROW_LOCKS=ON)
    
;


if not exists (select name from sys.indexes where name = 'LSWC_TRCKN_GRP_PK3' )
CREATE INDEX LSWC_TRCKN_GRP_PK3 ON LSW_TRACKING_GROUP(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_TRKGROUP' )
CREATE INDEX IDX_TRKGROUP ON LSW_TRACKING_GROUP(TRACKING_GROUP_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_TRCKD_VAR_PK3' )
CREATE INDEX LSWC_TRCKD_VAR_PK3 ON LSW_TRACKED_VARIABLE(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSW_TRKED_VAR_IDX1' )
CREATE INDEX LSW_TRKED_VAR_IDX1 ON LSW_TRACKED_VARIABLE(TRACKING_GROUP_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_TRCKN_PT_PK3' )
CREATE INDEX LSWC_TRCKN_PT_PK3 ON LSW_TRACKING_POINT(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_TRCK_VARU_PK3' )
CREATE INDEX LSWC_TRCK_VARU_PK3 ON LSW_TRACKED_VARIABLE_USE(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_TRCK_VARU' )
CREATE INDEX IDX_TRCK_VARU ON LSW_TRACKED_VARIABLE_USE(TRACKING_POINT_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_TMNG_INT_PK3' )
CREATE INDEX LSWC_TMNG_INT_PK3 ON LSW_TIMING_INTERVAL(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_TMNG_INTB_PK3' )
CREATE INDEX LSWC_TMNG_INTB_PK3 ON LSW_TIMING_INTERVAL_BOUND(GUID) 
;


if not exists (select name from sys.indexes where name = 'BPMC_ECNTR_PK3' )
CREATE INDEX BPMC_ECNTR_PK3 ON BPM_ECM_CONNECTOR(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_ILDT_PK3' )
CREATE INDEX LSWC_ILDT_PK3 ON LSW_ILOG_DECISION(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_SCNTR_PK3' )
CREATE INDEX LSWC_SCNTR_PK3 ON LSW_SCA_CONNECTOR(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_STEP_PK3' )
CREATE INDEX LSWC_STEP_PK3 ON LSW_STEP(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_CONNECTOR_PK3' )
CREATE INDEX LSWC_CONNECTOR_PK3 ON LSW_CONNECTOR(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSW_IDX_CONNECTOR' )
CREATE INDEX LSW_IDX_CONNECTOR ON LSW_CONNECTOR(CONNECTOR_ID) 
;


if not exists (select name from sys.indexes where name = 'LSW_IDX2_CONNECTOR' )
CREATE INDEX LSW_IDX2_CONNECTOR ON LSW_CONNECTOR(NAME) 
;


if not exists (select name from sys.indexes where name = 'LSWC_IC_PK3' )
CREATE INDEX LSWC_IC_PK3 ON LSW_IC(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_IC1' )
CREATE INDEX IDX_IC1 ON LSW_IC(NAME) 
;


if not exists (select name from sys.indexes where name = 'LSWC_JCNTR_PK3' )
CREATE INDEX LSWC_JCNTR_PK3 ON LSW_JAVA_CONNECTOR(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_WSNTR_PK3' )
CREATE INDEX LSWC_WSNTR_PK3 ON LSW_WS_CONNECTOR(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_ILNTR_PK3' )
CREATE INDEX LSWC_ILNTR_PK3 ON LSW_ILOG_CONNECTOR(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_ICNTR_PK3' )
CREATE INDEX LSWC_ICNTR_PK3 ON LSW_ICMCASE_CONNECTOR(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_EPV_PR_LK_PK2' )
CREATE INDEX LSWC_EPV_PR_LK_PK2 ON LSW_EPV_PROCESS_LINK(PROCESS_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_EPV_PR_LK_PK3' )
CREATE INDEX LSWC_EPV_PR_LK_PK3 ON LSW_EPV_PROCESS_LINK(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_EPV_PR_LK_NQ0' )
CREATE INDEX LSWC_EPV_PR_LK_NQ0 ON LSW_EPV_PROCESS_LINK(EPV_ID,VERSION_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_EPV_PR_LK_NQ1' )
CREATE INDEX LSWC_EPV_PR_LK_NQ1 ON LSW_EPV_PROCESS_LINK(PROCESS_ID,EPV_PROCESS_LINK_ID,VERSION_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_RES_PR_LK_PK2' )
CREATE INDEX LSWC_RES_PR_LK_PK2 ON LSW_RESOURCE_PROCESS_LINK(PROCESS_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_RES_PR_LK_PK3' )
CREATE INDEX LSWC_RES_PR_LK_PK3 ON LSW_RESOURCE_PROCESS_LINK(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_EXCEPTION_PK3' )
CREATE INDEX LSWC_EXCEPTION_PK3 ON LSW_EXCEPTION(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_EXIT_POINT_PK3' )
CREATE INDEX LSWC_EXIT_POINT_PK3 ON LSW_EXIT_POINT(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_TS_FILE_PK2' )
CREATE INDEX LSWC_TS_FILE_PK2 ON LSW_TASK_SENDER_FILE(TASK_SENDER_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_TS_FILE_PK3' )
CREATE INDEX LSWC_TS_FILE_PK3 ON LSW_TASK_SENDER_FILE(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_TS_ADDR_PK2' )
CREATE INDEX LSWC_TS_ADDR_PK2 ON LSW_TASK_SENDER_ADDR(TASK_SENDER_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_TS_ADDR_PK3' )
CREATE INDEX LSWC_TS_ADDR_PK3 ON LSW_TASK_SENDER_ADDR(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_PIPP_PK2' )
CREATE INDEX LSWC_PIPP_PK2 ON LSW_PROCESS_ITEM_PRE_POST(PROCESS_ITEM_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_PIPP_PK3' )
CREATE INDEX LSWC_PIPP_PK3 ON LSW_PROCESS_ITEM_PRE_POST(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_PROC_LINK_PK2' )
CREATE INDEX LSWC_PROC_LINK_PK2 ON LSW_PROCESS_LINK(PROCESS_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_PROC_LINK_PK3' )
CREATE INDEX LSWC_PROC_LINK_PK3 ON LSW_PROCESS_LINK(GUID) 
;


if not exists (select name from sysobjects where name = 'LSWC_FILE_FK1' )
ALTER TABLE LSW_FILE ADD CONSTRAINT LSWC_FILE_FK1
	FOREIGN KEY(CREATED_BY)
	REFERENCES LSW_USR_XREF(USER_ID)
	
;


if not exists (select name from sys.indexes where name = 'LSWC_IC_INPUT_PK3' )
CREATE INDEX LSWC_IC_INPUT_PK3 ON LSW_IC_INPUT_PROPERTY(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSW_IDX_IC_INPUT' )
CREATE INDEX LSW_IDX_IC_INPUT ON LSW_IC_INPUT_PROPERTY(IC_ID,SEQ) 
;


if not exists (select name from sys.indexes where name = 'LSWC_IC_OUTPUT_PK3' )
CREATE INDEX LSWC_IC_OUTPUT_PK3 ON LSW_IC_OUTPUT_PROPERTY(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSW_IDX_IC_OUTPUT' )
CREATE INDEX LSW_IDX_IC_OUTPUT ON LSW_IC_OUTPUT_PROPERTY(IC_ID,SEQ) 
;


if not exists (select name from sys.indexes where name = 'LSWC_PARAM_MAP_PK3' )
CREATE INDEX LSWC_PARAM_MAP_PK3 ON LSW_PARAMETER_MAPPING(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_PARAM_MAP_NQ' )
CREATE INDEX LSWC_PARAM_MAP_NQ ON LSW_PARAMETER_MAPPING(PARENT_ID,PARENT_TYPE) 
;


if not exists (select name from sys.indexes where name = 'LSWC_PARAM_MAP_NQ2' )
CREATE INDEX LSWC_PARAM_MAP_NQ2 ON LSW_PARAMETER_MAPPING(PARENT_TYPE) 
;


if not exists (select name from sys.indexes where name = 'LSW_IDX_PRIORITY' )
CREATE INDEX LSW_IDX_PRIORITY ON LSW_PRIORITY(PRIORITY_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_PROCESS_PK3' )
CREATE INDEX LSWC_PROCESS_PK3 ON LSW_PROCESS(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSW_IDX_PROCESS' )
CREATE INDEX LSW_IDX_PROCESS ON LSW_PROCESS(PROCESS_ID) 
;


if not exists (select name from sys.indexes where name = 'LSW_IDX2_PROCESS' )
CREATE INDEX LSW_IDX2_PROCESS ON LSW_PROCESS(NAME) 
;


if not exists (select name from sys.indexes where name = 'LSWC_PROC_ITEM_PK2' )
CREATE INDEX LSWC_PROC_ITEM_PK2 ON LSW_PROCESS_ITEM(PROCESS_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_PROC_ITEM_PK3' )
CREATE INDEX LSWC_PROC_ITEM_PK3 ON LSW_PROCESS_ITEM(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_PROC_ITEM_ID' )
CREATE UNIQUE INDEX IDX_PROC_ITEM_ID ON LSW_PROCESS_ITEM(PROCESS_ITEM_ID,VERSION_ID)

;


if not exists (select name from sys.indexes where name = 'LSWC_SUBPROCESS_PK3' )
CREATE INDEX LSWC_SUBPROCESS_PK3 ON LSW_SUBPROCESS(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_PROC_LABEL_PK2' )
CREATE INDEX LSWC_PROC_LABEL_PK2 ON LSW_PROCESS_LABEL(PROCESS_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_PROC_LABEL_PK3' )
CREATE INDEX LSWC_PROC_LABEL_PK3 ON LSW_PROCESS_LABEL(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_PROC_VAR_PK2' )
CREATE INDEX LSWC_PROC_VAR_PK2 ON LSW_PROCESS_VARIABLE(PROCESS_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_PROC_VAR_PK3' )
CREATE INDEX LSWC_PROC_VAR_PK3 ON LSW_PROCESS_VARIABLE(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_PROC_VAR' )
CREATE UNIQUE INDEX IDX_PROC_VAR ON LSW_PROCESS_VARIABLE(PROCESS_ID,SEQ,VERSION_ID)

;


if not exists (select name from sys.indexes where name = 'LSWC_PRO_PARM_PK2' )
CREATE INDEX LSWC_PRO_PARM_PK2 ON LSW_PROCESS_PARAMETER(PROCESS_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_PRO_PARM_PK3' )
CREATE INDEX LSWC_PRO_PARM_PK3 ON LSW_PROCESS_PARAMETER(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_PROPAR_NUQ' )
CREATE INDEX LSWC_PROPAR_NUQ ON LSW_PROCESS_PARAMETER(PROCESS_ID,SEQ,VERSION_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_SWITCH_PK3' )
CREATE INDEX LSWC_SWITCH_PK3 ON LSW_SWITCH(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_SWITCH_CON_PK2' )
CREATE INDEX LSWC_SWITCH_CON_PK2 ON LSW_SWITCH_CONDITION(SWITCH_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_SWITCH_CON_PK3' )
CREATE INDEX LSWC_SWITCH_CON_PK3 ON LSW_SWITCH_CONDITION(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_TASK_SEND_PK3' )
CREATE INDEX LSWC_TASK_SEND_PK3 ON LSW_TASK_SENDER(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_TASKSEND_NUQ' )
CREATE INDEX LSWC_TASKSEND_NUQ ON LSW_TASK_SENDER(PRIORITY,VERSION_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_TS_EXVAR_PK2' )
CREATE INDEX LSWC_TS_EXVAR_PK2 ON LSW_TASK_SENDER_EXVAR(TASK_SENDER_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_TS_EXVAR_PK3' )
CREATE INDEX LSWC_TS_EXVAR_PK3 ON LSW_TASK_SENDER_EXVAR(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_REP_PK3' )
CREATE INDEX LSWC_REP_PK3 ON LSW_REPORT(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_REP_EPV_PK3' )
CREATE INDEX LSWC_REP_EPV_PK3 ON LSW_REPORT_EPV_LINK(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_REP_RBG_PK3' )
CREATE INDEX LSWC_REP_RBG_PK3 ON LSW_REPORT_RBG_LINK(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_REP_DS_PK3' )
CREATE INDEX LSWC_REP_DS_PK3 ON LSW_REPORT_DATASOURCE(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_REP_TG_PK3' )
CREATE INDEX LSWC_REP_TG_PK3 ON LSW_REPORT_TG_LINK(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_REP_PAGE_PK3' )
CREATE INDEX LSWC_REP_PAGE_PK3 ON LSW_REPORT_PAGE(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_REP_CHRT_PK3' )
CREATE INDEX LSWC_REP_CHRT_PK3 ON LSW_REPORT_CHART(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_REP_VAR_PK3' )
CREATE INDEX LSWC_REP_VAR_PK3 ON LSW_REPORT_VARIABLES(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_REP_DSL_PK3' )
CREATE INDEX LSWC_REP_DSL_PK3 ON LSW_REPORT_DATASOURCE_IC_LINK(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_REP_DSL' )
CREATE INDEX IDX_REP_DSL ON LSW_REPORT_DATASOURCE_IC_LINK(POS) 
;


if not exists (select name from sys.indexes where name = 'LSWC_REP_DSSL_PK3' )
CREATE INDEX LSWC_REP_DSSL_PK3 ON LSW_REPORT_DATASOURCE_SRV_LINK(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_REP_DSSL' )
CREATE INDEX IDX_REP_DSSL ON LSW_REPORT_DATASOURCE_SRV_LINK(POS) 
;


if not exists (select name from sys.indexes where name = 'LSWC_REP_DSLL_PK3' )
CREATE INDEX LSWC_REP_DSLL_PK3 ON LSW_REPORT_DS_LAYOUT_LINK(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_SCBD_PK3' )
CREATE INDEX LSWC_SCBD_PK3 ON LSW_SCBD(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_SD_RPT_LK_PK3' )
CREATE INDEX LSWC_SD_RPT_LK_PK3 ON LSW_SCBD_RPT_LINK(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_HOLIDAY_UQ' )
CREATE UNIQUE INDEX LSWC_HOLIDAY_UQ ON LSW_HOLIDAY_SCHEDULE(NAME)

;


if not exists (select name from sys.indexes where name = 'LSWC_TMSCHEDULE_UQ' )
CREATE UNIQUE INDEX LSWC_TMSCHEDULE_UQ ON LSW_TIME_SCHEDULE(NAME)

;


if not exists (select name from sysobjects where name = 'LSWC_SCHPER_FK1' )
ALTER TABLE LSW_TIME_SCHEDULE_PERIOD ADD CONSTRAINT LSWC_SCHPER_FK1
	FOREIGN KEY(SCHEDULE_ID)
	REFERENCES LSW_TIME_SCHEDULE(SCHEDULE_ID)
	
;


if not exists (select name from sysobjects where name = 'LSWC_SCHPER_FK2' )
ALTER TABLE LSW_TIME_SCHEDULE_PERIOD ADD CONSTRAINT LSWC_SCHPER_FK2
	FOREIGN KEY(PERIOD_ID)
	REFERENCES LSW_TIME_PERIOD(PERIOD_ID)
	
;


if not exists (select name from sys.indexes where name = 'LSWC_SCHPER_UQ' )
CREATE UNIQUE INDEX LSWC_SCHPER_UQ ON LSW_TIME_SCHEDULE_PERIOD(PERIOD_ID,SCHEDULE_ID)

;


if not exists (select name from sysobjects where name = 'BPMC_BPD_SOAP_FK0' )
ALTER TABLE BPM_BPD_SOAPHEADER ADD CONSTRAINT BPMC_BPD_SOAP_FK0
	FOREIGN KEY(BPD_INSTANCE_ID)
	REFERENCES LSW_BPD_INSTANCE(BPD_INSTANCE_ID)
	ON DELETE CASCADE
;


if not exists (select name from sys.indexes where name = 'BPMC_BPD_SOAP_UQ' )
CREATE UNIQUE INDEX BPMC_BPD_SOAP_UQ ON BPM_BPD_SOAPHEADER(BPD_INSTANCE_ID)

;


if not exists (select name from sys.indexes where name = 'TASK_MEASURES_UC' )
CREATE UNIQUE INDEX TASK_MEASURES_UC ON BPM_TASK_ACTIVITY_MEASURES(CREATED_BY_BPD_FLOW_OBJECT_ID,USER_ID)

;


if not exists (select name from sysobjects where name = 'BPMC_MARKER_TO_TASK_ID_FK' )
ALTER TABLE BPM_TASK_MARKERS ADD CONSTRAINT BPMC_MARKER_TO_TASK_ID_FK
	FOREIGN KEY(TASK_ID)
	REFERENCES LSW_TASK(TASK_ID)
	ON DELETE CASCADE
;


if not exists (select name from sysobjects where name = 'BPMC_MARKER_TO_BPD_ID_FK' )
ALTER TABLE BPM_TASK_MARKERS ADD CONSTRAINT BPMC_MARKER_TO_BPD_ID_FK
	FOREIGN KEY(BPD_INSTANCE_ID)
	REFERENCES LSW_BPD_INSTANCE(BPD_INSTANCE_ID)
	ON DELETE CASCADE
;


if not exists (select name from sys.indexes where name = 'IDX1_BPM_TASK_MARKERS' )
CREATE INDEX IDX1_BPM_TASK_MARKERS ON BPM_TASK_MARKERS(TARGET_USER,MARKER_TYPE) 
;


if not exists (select name from sys.indexes where name = 'IDX2_BPM_TASK_MARKERS' )
CREATE INDEX IDX2_BPM_TASK_MARKERS ON BPM_TASK_MARKERS(TASK_ID) 
;


if not exists (select name from sysobjects where name = 'LSW_BPD_INST_FK' )
ALTER TABLE LSW_BPD_INSTANCE_VARIABLES ADD CONSTRAINT LSW_BPD_INST_FK
	FOREIGN KEY(BPD_INSTANCE_ID)
	REFERENCES LSW_BPD_INSTANCE(BPD_INSTANCE_ID)
	
;


if not exists (select name from sys.indexes where name = 'LSWIDX_INST_ALS' )
CREATE INDEX LSWIDX_INST_ALS ON LSW_BPD_INSTANCE_VARIABLES(BPD_INSTANCE_ID,ALIAS) 
;


if not exists (select name from sysobjects where name = 'LSWC_BPD_INST_FK1' )
ALTER TABLE LSW_BPD_INSTANCE ADD CONSTRAINT LSWC_BPD_INST_FK1
	FOREIGN KEY(CACHED_BPD_VERSION_ID)
	REFERENCES LSW_BPD(VERSION_ID)
	
;


if not exists (select name from sys.indexes where name = 'LSWC_TIP_NUQ' )
CREATE INDEX LSWC_TIP_NUQ ON LSW_BPD_INSTANCE(TIP) 
;


if not exists (select name from sys.indexes where name = 'INDEX1_LSW_BPD_INST' )
CREATE INDEX INDEX1_LSW_BPD_INST ON LSW_BPD_INSTANCE(SNAPSHOT_ID,BPD_INSTANCE_ID) 
;


if not exists (select name from sys.indexes where name = 'INDEX2_LSW_BPD_INST' )
CREATE INDEX INDEX2_LSW_BPD_INST ON LSW_BPD_INSTANCE(EXECUTION_STATUS,BPD_INSTANCE_ID) 
;


if not exists (select name from sys.indexes where name = 'INDEX3_LSW_BPD_INST' )
CREATE INDEX INDEX3_LSW_BPD_INST ON LSW_BPD_INSTANCE(BPD_INSTANCE_ID,EXECUTION_STATUS,CACHED_BPD_VERSION_ID) 
;


if not exists (select name from sysobjects where name = 'LSWC_BPD_INS_D_FK0' )
ALTER TABLE LSW_BPD_INSTANCE_DATA ADD CONSTRAINT LSWC_BPD_INS_D_FK0
	FOREIGN KEY(BPD_INSTANCE_ID)
	REFERENCES LSW_BPD_INSTANCE(BPD_INSTANCE_ID)
	
;


if not exists (select name from sys.indexes where name = 'LSWC_BPD_INS_D_UQ' )
CREATE UNIQUE INDEX LSWC_BPD_INS_D_UQ ON LSW_BPD_INSTANCE_DATA(BPD_INSTANCE_ID)

;


if not exists (select name from sys.indexes where name = 'IDX1_BPDNOT' )
CREATE INDEX IDX1_BPDNOT ON LSW_BPD_NOTIFICATION(BPD_INSTANCE_ID) 
;


if not exists (select name from sysobjects where name = 'LSWC_DOC_ID_FK' )
ALTER TABLE LSW_BPD_INSTANCE_DOC_PROPS ADD CONSTRAINT LSWC_DOC_ID_FK
	FOREIGN KEY(DOC_ID)
	REFERENCES LSW_BPD_INSTANCE_DOCUMENTS(DOC_ID)
	
;


if not exists (select name from sys.indexes where name = 'LSWC_DMR_NUQ1' )
CREATE INDEX LSWC_DMR_NUQ1 ON LSW_DUR_MSG_RECEIVED(UCA_ID,CORRELATION_TYPE,CORRELATION_KEY) 
;


if not exists (select name from sys.indexes where name = 'LSWC_MSG_INCL_NUQ1' )
CREATE INDEX LSWC_MSG_INCL_NUQ1 ON LSW_INST_MSG_INCL(CORRELATION_KEY,UCA_ID,BPD_INSTANCE_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_MSG_INCL_NUQ2' )
CREATE INDEX LSWC_MSG_INCL_NUQ2 ON LSW_INST_MSG_INCL(BPD_INSTANCE_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_MSG_EXCL_NUQ1' )
CREATE INDEX LSWC_MSG_EXCL_NUQ1 ON LSW_INST_MSG_EXCL(BPD_INSTANCE_ID,EVENT_ID,SUB_EVENT_ID,MSG_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_MSG_EXCL_NUQ2' )
CREATE INDEX LSWC_MSG_EXCL_NUQ2 ON LSW_INST_MSG_EXCL(BPD_INSTANCE_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_SLA_PROC_UQ' )
CREATE UNIQUE INDEX LSWC_SLA_PROC_UQ ON LSW_SLA_PROCESSING(SLA_GUID)

;


if not exists (select name from sysobjects where name = 'LSWC_T_SYM_FK' )
ALTER TABLE LSW_STORED_SYMBOL_TABLE ADD CONSTRAINT LSWC_T_SYM_FK
	FOREIGN KEY(TASK_ID)
	REFERENCES LSW_TASK(TASK_ID)
	ON DELETE CASCADE
;


if not exists (select name from sys.indexes where name = 'LSWC_T_SYM_TASK' )
CREATE UNIQUE INDEX LSWC_T_SYM_TASK ON LSW_STORED_SYMBOL_TABLE(TASK_ID)

;


if not exists (select name from sys.indexes where name = 'LSWC_TASK_STATUS_INDEX1' )
CREATE INDEX LSWC_TASK_STATUS_INDEX1 ON LSW_TASK_STATUS_CODES(NAME) 
;


if not exists (select name from sys.indexes where name = 'LSWC_TASK_STATUS_INDEX2' )
CREATE INDEX LSWC_TASK_STATUS_INDEX2 ON LSW_TASK_STATUS_CODES(STATUS_VALUE) 
;


if not exists (select name from sys.indexes where name = 'LSWC_TASKEXACD_UK' )
CREATE UNIQUE INDEX LSWC_TASKEXACD_UK ON LSW_TASK_EXTACT_DATA(TASK_ID)

;


if not exists (select name from sysobjects where name = 'LSWC_TASK_P_FK3' )
ALTER TABLE LSW_TASK ADD CONSTRAINT LSWC_TASK_P_FK3
	FOREIGN KEY(RCVD_FROM)
	REFERENCES LSW_USR_XREF(USER_ID)
	
;


if not exists (select name from sysobjects where name = 'LSWC_TASK_P_FK4' )
ALTER TABLE LSW_TASK ADD CONSTRAINT LSWC_TASK_P_FK4
	FOREIGN KEY(CLOSE_BY)
	REFERENCES LSW_USR_XREF(USER_ID)
	
;


if not exists (select name from sys.indexes where name = 'LSWC_TASK_BPDI' )
CREATE INDEX LSWC_TASK_BPDI ON LSW_TASK(BPD_INSTANCE_ID,CREATED_BY_BPD_FLOW_OBJECT_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_TASK_NUQ_U' )
CREATE INDEX LSWC_TASK_NUQ_U ON LSW_TASK(USER_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_TASK_NUQ_G' )
CREATE INDEX LSWC_TASK_NUQ_G ON LSW_TASK(GROUP_ID) 
;


if not exists (select name from sys.indexes where name = 'IDX5_LSW_TASK' )
CREATE INDEX IDX5_LSW_TASK ON LSW_TASK(STATUS) 
;


if not exists (select name from sys.indexes where name = 'IDX6_LSW_TASK' )
CREATE INDEX IDX6_LSW_TASK ON LSW_TASK(ORIG_TASK_ID) 
;


if not exists (select name from sys.indexes where name = 'IDX7_LSW_TASK' )
CREATE INDEX IDX7_LSW_TASK ON LSW_TASK(EXECUTION_STATUS) 
;


if not exists (select name from sys.indexes where name = 'IDX8_LSW_TASK' )
CREATE INDEX IDX8_LSW_TASK ON LSW_TASK(BPD_INSTANCE_ID,STATUS,PRIORITY_ID,GROUP_ID,USER_ID) 
;


if not exists (select name from sys.indexes where name = 'IDX9_LSW_TASK' )
CREATE INDEX IDX9_LSW_TASK ON LSW_TASK(BPD_INSTANCE_ID,TASK_ID,CREATED_BY_BPD_FLOW_OBJECT_ID,STATUS) 
;


if not exists (select name from sys.indexes where name = 'LSWC_TASKIPFD_UK' )
CREATE UNIQUE INDEX LSWC_TASKIPFD_UK ON LSW_TASK_IPF_DATA(TASK_ID)

;


if not exists (select name from sysobjects where name = 'LSWC_T_FILE_FK' )
ALTER TABLE LSW_TASK_FILE ADD CONSTRAINT LSWC_T_FILE_FK
	FOREIGN KEY(TASK_ID)
	REFERENCES LSW_TASK(TASK_ID)
	
;


if not exists (select name from sys.indexes where name = 'IDX_TASKFILE1' )
CREATE INDEX IDX_TASKFILE1 ON LSW_TASK_FILE(FILE_ID) 
;


if not exists (select name from sysobjects where name = 'LSWC_T_ADDR_FK' )
ALTER TABLE LSW_TASK_ADDR ADD CONSTRAINT LSWC_T_ADDR_FK
	FOREIGN KEY(TASK_ID)
	REFERENCES LSW_TASK(TASK_ID)
	
;


if not exists (select name from sys.indexes where name = 'LSW_TASK_ADDR_UQ' )
CREATE UNIQUE INDEX LSW_TASK_ADDR_UQ ON LSW_TASK_ADDR(TASK_ID,SEQ)

;


if not exists (select name from sysobjects where name = 'LSWC_T_NARR_FK' )
ALTER TABLE LSW_TASK_NARR ADD CONSTRAINT LSWC_T_NARR_FK
	FOREIGN KEY(TASK_ID)
	REFERENCES LSW_TASK(TASK_ID)
	
;


if not exists (select name from sys.indexes where name = 'LSW_TASK_NARR_UQ' )
CREATE UNIQUE INDEX LSW_TASK_NARR_UQ ON LSW_TASK_NARR(TASK_ID,SEQ)

;


if not exists (select name from sys.indexes where name = 'LSWC_TASK_ACTN_PK3' )
CREATE INDEX LSWC_TASK_ACTN_PK3 ON LSW_TASK_ACTION(GUID) 
;


if not exists (select name from sysobjects where name = 'LSWC_T_EXEC_FK' )
ALTER TABLE LSW_TASK_EXECUTION_CONTEXT ADD CONSTRAINT LSWC_T_EXEC_FK
	FOREIGN KEY(TASK_ID)
	REFERENCES LSW_TASK(TASK_ID)
	
;


if not exists (select name from sys.indexes where name = 'LSWC_T_EXEC_UK' )
CREATE UNIQUE INDEX LSWC_T_EXEC_UK ON LSW_TASK_EXECUTION_CONTEXT(TASK_ID)

;


if not exists (select name from sys.indexes where name = 'IDX_LEGACY_ID' )
CREATE UNIQUE INDEX IDX_LEGACY_ID ON LSW_LEGACY_ID(PO_TYPE,UUID)

;


if not exists (select name from sys.indexes where name = 'BPM_TASK_INDEX_IDX' )
CREATE INDEX BPM_TASK_INDEX_IDX ON BPM_TASK_INDEX(MAJOR_EVENT_DATETIME,TASK_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_INV_UCA_PK3' )
CREATE INDEX LSWC_INV_UCA_PK3 ON LSW_INVOKE_UCA(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_UCA_PK3' )
CREATE INDEX LSWC_UCA_PK3 ON LSW_UCA(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_UCA_NUQ3' )
CREATE INDEX LSWC_UCA_NUQ3 ON LSW_UCA(SCHED_EVENT_NAME,VERSION_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_UCA_NUQ4' )
CREATE INDEX LSWC_UCA_NUQ4 ON LSW_UCA(UCA_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_UCA_PARM_PK3' )
CREATE INDEX LSWC_UCA_PARM_PK3 ON LSW_UCA_PARM(GUID) 
;


if not exists (select name from sys.indexes where name = 'UQ_USR_NAME' )
CREATE UNIQUE INDEX UQ_USR_NAME ON LSW_USR(USER_NAME)

;


if not exists (select name from sys.indexes where name = 'LSWC_UXREF_UQ' )
CREATE UNIQUE INDEX LSWC_UXREF_UQ ON LSW_USR_XREF(USER_NAME,PROVIDER)

;


if not exists (select name from sys.indexes where name = 'LSWC_UXREF_UQ2' )
CREATE UNIQUE INDEX LSWC_UXREF_UQ2 ON LSW_USR_XREF(USER_ID,USER_NAME)

;


if not exists (select name from sys.indexes where name = 'LSWC_GXREF_UQ' )
CREATE UNIQUE INDEX LSWC_GXREF_UQ ON LSW_USR_GRP_XREF(GROUP_NAME)

;


if not exists (select name from sys.indexes where name = 'LSWC_GXREF_NU' )
CREATE INDEX LSWC_GXREF_NU ON LSW_USR_GRP_XREF(GROUP_TYPE) 
;


if not exists (select name from sysobjects where name = 'LSWC_UGXREF_FK1' )
ALTER TABLE LSW_USR_GRP_MEM_XREF ADD CONSTRAINT LSWC_UGXREF_FK1
	FOREIGN KEY(USER_ID)
	REFERENCES LSW_USR_XREF(USER_ID)
	
;


if not exists (select name from sysobjects where name = 'LSWC_UGXREF_FK2' )
ALTER TABLE LSW_USR_GRP_MEM_XREF ADD CONSTRAINT LSWC_UGXREF_FK2
	FOREIGN KEY(GROUP_ID)
	REFERENCES LSW_USR_GRP_XREF(GROUP_ID)
	
;


if not exists (select name from sys.indexes where name = 'LSWC_UGXREF_UQ' )
CREATE UNIQUE INDEX LSWC_UGXREF_UQ ON LSW_USR_GRP_MEM_XREF(USER_ID,GROUP_ID)

;


if not exists (select name from sysobjects where name = 'LSWC_GGXREF_FK1' )
ALTER TABLE LSW_GRP_GRP_MEM_XREF ADD CONSTRAINT LSWC_GGXREF_FK1
	FOREIGN KEY(GROUP_ID)
	REFERENCES LSW_USR_GRP_XREF(GROUP_ID)
	
;


if not exists (select name from sysobjects where name = 'LSWC_GGXREF_FK2' )
ALTER TABLE LSW_GRP_GRP_MEM_XREF ADD CONSTRAINT LSWC_GGXREF_FK2
	FOREIGN KEY(CONTAINER_GROUP_ID)
	REFERENCES LSW_USR_GRP_XREF(GROUP_ID)
	
;


if not exists (select name from sys.indexes where name = 'LSWC_GGMXREF_NU1' )
CREATE INDEX LSWC_GGMXREF_NU1 ON LSW_GRP_GRP_MEM_XREF(CONTAINER_GROUP_ID) 
;


if not exists (select name from sysobjects where name = 'LSWC_GGXXREF_FK1' )
ALTER TABLE LSW_GRP_GRP_MEM_EXPLODED_XREF ADD CONSTRAINT LSWC_GGXXREF_FK1
	FOREIGN KEY(GROUP_ID)
	REFERENCES LSW_USR_GRP_XREF(GROUP_ID)
	
;


if not exists (select name from sysobjects where name = 'LSWC_GGXXREF_FK2' )
ALTER TABLE LSW_GRP_GRP_MEM_EXPLODED_XREF ADD CONSTRAINT LSWC_GGXXREF_FK2
	FOREIGN KEY(CONTAINER_GROUP_ID)
	REFERENCES LSW_USR_GRP_XREF(GROUP_ID)
	
;


if not exists (select name from sys.indexes where name = 'LSWC_GGXXREF_NU1' )
CREATE INDEX LSWC_GGXXREF_NU1 ON LSW_GRP_GRP_MEM_EXPLODED_XREF(GROUP_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_GGXXREF_NU2' )
CREATE INDEX LSWC_GGXXREF_NU2 ON LSW_GRP_GRP_MEM_EXPLODED_XREF(CONTAINER_GROUP_ID) 
;


if not exists (select name from sysobjects where name = 'LSWC_UA_FK1' )
ALTER TABLE LSW_USR_ASSUME ADD CONSTRAINT LSWC_UA_FK1
	FOREIGN KEY(USER_ID)
	REFERENCES LSW_USR_XREF(USER_ID)
	
;


if not exists (select name from sysobjects where name = 'LSWC_UA_FK2' )
ALTER TABLE LSW_USR_ASSUME ADD CONSTRAINT LSWC_UA_FK2
	FOREIGN KEY(ASSUMED_USER_ID)
	REFERENCES LSW_USR_XREF(USER_ID)
	
;


if not exists (select name from sys.indexes where name = 'LSWC_UA_UK' )
CREATE UNIQUE INDEX LSWC_UA_UK ON LSW_USR_ASSUME(ASSUMED_USER_ID,USER_ID)

;


if not exists (select name from sysobjects where name = 'LSWC_UA_CK' )
ALTER TABLE LSW_USR_ASSUME ADD CONSTRAINT LSWC_UA_CK
	CHECK(USER_ID <> ASSUMED_USER_ID)

;


if not exists (select name from sys.indexes where name = 'LSWC_UA_NUQ' )
CREATE INDEX LSWC_UA_NUQ ON LSW_USR_ASSUME(USER_ID) 
;


if not exists (select name from sysobjects where name = 'LSWC_ACCESS_FK1' )
ALTER TABLE LSW_ACCESS ADD CONSTRAINT LSWC_ACCESS_FK1
	FOREIGN KEY(USER_ID)
	REFERENCES LSW_USR_XREF(USER_ID)
	
;


if not exists (select name from sysobjects where name = 'LSWC_ACCESS_FK2' )
ALTER TABLE LSW_ACCESS ADD CONSTRAINT LSWC_ACCESS_FK2
	FOREIGN KEY(ASSUMED_USER_ID)
	REFERENCES LSW_USR_XREF(USER_ID)
	
;


if not exists (select name from sysobjects where name = 'LSWC_ACCESS_CK' )
ALTER TABLE LSW_ACCESS ADD CONSTRAINT LSWC_ACCESS_CK
	CHECK(USER_ID <> ASSUMED_USER_ID)

;


if not exists (select name from sys.indexes where name = 'LSWC_ACCESS_NUQ' )
CREATE INDEX LSWC_ACCESS_NUQ ON LSW_ACCESS(USER_ID) 
;


if not exists (select name from sysobjects where name = 'LSWC_DGRP_TRK_FK' )
ALTER TABLE LSW_DYNAMIC_GROUP ADD CONSTRAINT LSWC_DGRP_TRK_FK
	FOREIGN KEY(BRANCH_ID)
	REFERENCES LSW_BRANCH(BRANCH_ID)
	ON DELETE CASCADE
;


if not exists (select name from sys.indexes where name = 'LSW_DGRP_UQ' )
CREATE UNIQUE INDEX LSW_DGRP_UQ ON LSW_DYNAMIC_GROUP(NAME)

;


if not exists (select name from sysobjects where name = 'LSW_DGRPC_FK' )
ALTER TABLE LSW_DYNAMIC_GROUP_CONSTRAINT ADD CONSTRAINT LSW_DGRPC_FK
	FOREIGN KEY(DYNAMIC_GROUP_ID)
	REFERENCES LSW_DYNAMIC_GROUP(DYNAMIC_GROUP_ID)
	ON DELETE CASCADE
;


if not exists (select name from sys.indexes where name = 'LSWC_DGRPC_UQ' )
CREATE UNIQUE INDEX LSWC_DGRPC_UQ ON LSW_DYNAMIC_GROUP_CONSTRAINT(DYNAMIC_GROUP_CONSTRAINT_ID,DYNAMIC_GROUP_ID,MATCH_TYPE,CONSTRAINT_TYPE,LIBRARY_ELEMENT_ID)

;


if not exists (select name from sysobjects where name = 'LSWC_DGRP_DEP_FK' )
ALTER TABLE LSW_DYNAMIC_GROUP_DEPENDENCY ADD CONSTRAINT LSWC_DGRP_DEP_FK
	FOREIGN KEY(PARENT_GROUP_ID)
	REFERENCES LSW_DYNAMIC_GROUP(DYNAMIC_GROUP_ID)
	ON DELETE CASCADE
;


if not exists (select name from sysobjects where name = 'LSWC_USR_ATTR_FK' )
ALTER TABLE LSW_USR_ATTR ADD CONSTRAINT LSWC_USR_ATTR_FK
	FOREIGN KEY(USER_ID)
	REFERENCES LSW_USR_XREF(USER_ID)
	
;


if not exists (select name from sys.indexes where name = 'U_ATTR_DEF_VAL_PK3' )
CREATE INDEX U_ATTR_DEF_VAL_PK3 ON LSW_USER_ATTR_DEF_VALUES(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_USRATTRD_PK3' )
CREATE INDEX LSWC_USRATTRD_PK3 ON LSW_USER_ATTRIBUTE_DEF(GUID) 
;


if not exists (select name from sysobjects where name = 'LSWC_RT_UAD_FK' )
ALTER TABLE LSW_RT_USER_ATTRIBUTE_DEF ADD CONSTRAINT LSWC_RT_UAD_FK
	FOREIGN KEY(SNAPSHOT_ID)
	REFERENCES LSW_SNAPSHOT(SNAPSHOT_ID)
	ON DELETE CASCADE
;


if not exists (select name from sys.indexes where name = 'LSWC_RT_UAD_UQ' )
CREATE UNIQUE INDEX LSWC_RT_UAD_UQ ON LSW_RT_USER_ATTRIBUTE_DEF(USER_ATTRIBUTE_ID,SNAPSHOT_ID)

;


if not exists (select name from sysobjects where name = 'LSWC_PART_GRP_FK' )
ALTER TABLE LSW_PARTICIPANT_GROUP ADD CONSTRAINT LSWC_PART_GRP_FK
	FOREIGN KEY(GROUP_ID)
	REFERENCES LSW_USR_GRP_XREF(GROUP_ID)
	
;


if not exists (select name from sys.indexes where name = 'LSWC_PART_GRP_UQ1' )
CREATE UNIQUE INDEX LSWC_PART_GRP_UQ1 ON LSW_PARTICIPANT_GROUP(PARTICIPANT_ID,SNAPSHOT_ID,BRANCH_ID,TIP,GROUP_ID)

;


if not exists (select name from sys.indexes where name = 'LSWC_PART_GRP_UQ2' )
CREATE UNIQUE INDEX LSWC_PART_GRP_UQ2 ON LSW_PARTICIPANT_GROUP(GROUP_ID)

;


if not exists (select name from sys.indexes where name = 'LSWC_PARTCP_PK3' )
CREATE INDEX LSWC_PARTCP_PK3 ON LSW_PARTICIPANT(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSW_IDX_PARTCP2' )
CREATE INDEX LSW_IDX_PARTCP2 ON LSW_PARTICIPANT(NAME) 
;


if not exists (select name from sys.indexes where name = 'LSWC_ACL_ENTRY_UQ' )
CREATE UNIQUE INDEX LSWC_ACL_ENTRY_UQ ON LSW_ACL_ENTRY(USER_ID,GROUP_ID,PO_TYPE,PO_ID)

;


if not exists (select name from sys.indexes where name = 'LSWC_ACL_ENTRY_USR' )
CREATE INDEX LSWC_ACL_ENTRY_USR ON LSW_ACL_ENTRY(USER_ID,PO_TYPE,PO_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_ACL_ENTRY_GRP' )
CREATE INDEX LSWC_ACL_ENTRY_GRP ON LSW_ACL_ENTRY(GROUP_ID,PO_TYPE,PO_ID) 
;


if not exists (select name from sysobjects where name = 'LSWC_FAV_GRP_FK' )
ALTER TABLE LSW_FAVORITE ADD CONSTRAINT LSWC_FAV_GRP_FK
	FOREIGN KEY(GROUP_ID)
	REFERENCES LSW_USR_GRP_XREF(GROUP_ID)
	
;


if not exists (select name from sysobjects where name = 'LSWC_FAV_TRK_FK' )
ALTER TABLE LSW_FAVORITE ADD CONSTRAINT LSWC_FAV_TRK_FK
	FOREIGN KEY(BRANCH_ID)
	REFERENCES LSW_BRANCH(BRANCH_ID)
	ON DELETE CASCADE
;


if not exists (select name from sys.indexes where name = 'LSWC_FAV_NUQ1' )
CREATE INDEX LSWC_FAV_NUQ1 ON LSW_FAVORITE(GROUP_ID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_FAV_NUQ2' )
CREATE INDEX LSWC_FAV_NUQ2 ON LSW_FAVORITE(SNAPSHOT_ID) 
;


if not exists (select name from sysobjects where name = 'LSWC_USR_AVATAR_FK' )
ALTER TABLE BPM_USR_AVATAR ADD CONSTRAINT LSWC_USR_AVATAR_FK
	FOREIGN KEY(USER_ID)
	REFERENCES LSW_USR_XREF(USER_ID)
	
;


if not exists (select name from sys.indexes where name = 'IDX5_SNAPSHOT' )
CREATE UNIQUE INDEX IDX5_SNAPSHOT ON LSW_SNAPSHOT(PROJECT_ID,ACRONYM)

;


if not exists (select name from sys.indexes where name = 'IDX_SNAPSHOT' )
CREATE INDEX IDX_SNAPSHOT ON LSW_SNAPSHOT(SEQ_NUM,NAME) 
;


if not exists (select name from sys.indexes where name = 'IDX2_SNAPSHOT' )
CREATE INDEX IDX2_SNAPSHOT ON LSW_SNAPSHOT(BRANCH_ID,SEQ_NUM) 
;


if not exists (select name from sys.indexes where name = 'IDX3_SNAPSHOT' )
CREATE INDEX IDX3_SNAPSHOT ON LSW_SNAPSHOT(IS_ARCHIVED) 
;


if not exists (select name from sys.indexes where name = 'IDX4_SNAPSHOT' )
CREATE INDEX IDX4_SNAPSHOT ON LSW_SNAPSHOT(CREATED_ON) 
;


if not exists (select name from sys.indexes where name = 'IDX6_SNAPSHOT' )
CREATE INDEX IDX6_SNAPSHOT ON LSW_SNAPSHOT(BRANCH_ID,IS_ARCHIVED,CREATED_ON) 
;


if not exists (select name from sys.indexes where name = 'IDX3_BRANCH' )
CREATE UNIQUE INDEX IDX3_BRANCH ON LSW_BRANCH(PROJECT_ID,ACRONYM)

;


if not exists (select name from sys.indexes where name = 'IDX_BRANCH' )
CREATE INDEX IDX_BRANCH ON LSW_BRANCH(PROJECT_ID) 
;


if not exists (select name from sys.indexes where name = 'IDX2_BRANCH' )
CREATE INDEX IDX2_BRANCH ON LSW_BRANCH(NAME) 
;


if not exists (select name from sys.indexes where name = 'IDX_SHORT_NAME' )
CREATE UNIQUE INDEX IDX_SHORT_NAME ON LSW_PROJECT(SHORT_NAME)

;


if not exists (select name from sys.indexes where name = 'IDX_PRJ1' )
CREATE INDEX IDX_PRJ1 ON LSW_PROJECT(CREATED_ON) 
;


if not exists (select name from sys.indexes where name = 'IDX_PO_VERSIONS' )
CREATE INDEX IDX_PO_VERSIONS ON LSW_PO_VERSIONS(PO_TYPE,BRANCH_ID,START_SEQ_NUM,END_SEQ_NUM,PO_VERSION_ID) 
;


if not exists (select name from sys.indexes where name = 'IDX2_PO_VERSIONS' )
CREATE INDEX IDX2_PO_VERSIONS ON LSW_PO_VERSIONS(BRANCH_ID,END_SEQ_NUM) 
;


if not exists (select name from sys.indexes where name = 'IDX3_PO_VERSIONS' )
CREATE INDEX IDX3_PO_VERSIONS ON LSW_PO_VERSIONS(START_SEQ_NUM,PO_ROOT_ID,PO_TYPE,BRANCH_ID,END_SEQ_NUM,PO_VERSION_ID) 
;


if not exists (select name from sys.indexes where name = 'IDX_PO_METADATA' )
CREATE INDEX IDX_PO_METADATA ON LSW_PO_METADATA(BRANCH_ID,END_SEQ_NUM,START_SEQ_NUM) 
;


if not exists (select name from sys.indexes where name = 'IDX2_PO_METADATA' )
CREATE INDEX IDX2_PO_METADATA ON LSW_PO_METADATA(END_SEQ_NUM,BRANCH_ID,PO_TYPE,PO_ID,META_KEY) 
;


if not exists (select name from sys.indexes where name = 'IDX3_PO_METADATA' )
CREATE INDEX IDX3_PO_METADATA ON LSW_PO_METADATA(START_SEQ_NUM) 
;


if not exists (select name from sys.indexes where name = 'IDX4_PO_METADATA' )
CREATE INDEX IDX4_PO_METADATA ON LSW_PO_METADATA(PO_TYPE) 
;


if not exists (select name from sys.indexes where name = 'IDX5_PO_METADATA' )
CREATE INDEX IDX5_PO_METADATA ON LSW_PO_METADATA(PO_ID) 
;


if not exists (select name from sys.indexes where name = 'IDX6_PO_METADATA' )
CREATE INDEX IDX6_PO_METADATA ON LSW_PO_METADATA(META_KEY) 
;


if not exists (select name from sys.indexes where name = 'IDX0_PROJ_DEP' )
CREATE INDEX IDX0_PROJ_DEP ON LSW_PROJECT_DEPENDENCY(VERSION_ID,IS_ACTIVE) 
;


if not exists (select name from sys.indexes where name = 'IDX_DEP_PATH' )
CREATE INDEX IDX_DEP_PATH ON LSW_DEP_PATH(HASH) 
;


if not exists (select name from sys.indexes where name = 'IDX2_DEP_PATH' )
CREATE INDEX IDX2_DEP_PATH ON LSW_DEP_PATH(COUNT) 
;


if not exists (select name from sys.indexes where name = 'IDX_PO_REFERENCE' )
CREATE INDEX IDX_PO_REFERENCE ON LSW_PO_REFERENCE(BRANCH_ID,END_SEQ_NUM,START_SEQ_NUM,TARGET_TYPE) 
;


if not exists (select name from sys.indexes where name = 'IDX2_PO_REFERENCE' )
CREATE INDEX IDX2_PO_REFERENCE ON LSW_PO_REFERENCE(START_SEQ_NUM) 
;


if not exists (select name from sys.indexes where name = 'IDX3_PO_REFERENCE' )
CREATE INDEX IDX3_PO_REFERENCE ON LSW_PO_REFERENCE(END_SEQ_NUM) 
;


if not exists (select name from sys.indexes where name = 'IDX2_PO_DEPENDENCY' )
CREATE INDEX IDX2_PO_DEPENDENCY ON LSW_PO_DEPENDENCY(START_SEQ_NUM) 
;


if not exists (select name from sys.indexes where name = 'IDX3_PO_DEPENDENCY' )
CREATE INDEX IDX3_PO_DEPENDENCY ON LSW_PO_DEPENDENCY(END_SEQ_NUM) 
;


if not exists (select name from sys.indexes where name = 'IDX4_PO_DEPENDENCY' )
CREATE INDEX IDX4_PO_DEPENDENCY ON LSW_PO_DEPENDENCY(SOURCE_ID) 
;


if not exists (select name from sys.indexes where name = 'IDX5_PO_DEPENDENCY' )
CREATE INDEX IDX5_PO_DEPENDENCY ON LSW_PO_DEPENDENCY(SOURCE_LOCATION) 
;


if not exists (select name from sys.indexes where name = 'IDX_RT_REFERENCE' )
CREATE INDEX IDX_RT_REFERENCE ON LSW_RT_REFERENCE(PO_TYPE) 
;


if not exists (select name from sys.indexes where name = 'LSWC_WEB_SRV_PK3' )
CREATE INDEX LSWC_WEB_SRV_PK3 ON LSW_WEB_SERVICE(GUID) 
;


if not exists (select name from sys.indexes where name = 'LSWC_WEBSRV_OP_PK3' )
CREATE INDEX LSWC_WEBSRV_OP_PK3 ON LSW_WEB_SERVICE_OP(GUID) 
;


if not exists (select name from sys.indexes where name = 'IDX_WEBSRV_OP' )
CREATE INDEX IDX_WEBSRV_OP ON LSW_WEB_SERVICE_OP(WEB_SERVICE_ID,SEQ) 
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PRI_KEY WHERE TABLE_ID = 'LSW_USR'))
      INSERT INTO LSW_PRI_KEY(TABLE_ID,
 HIGH_KEY) 
VALUES ('LSW_USR',
 1000)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PRI_KEY WHERE TABLE_ID = 'LSW_USR_XREF'))
      INSERT INTO LSW_PRI_KEY(TABLE_ID,
 HIGH_KEY) 
VALUES ('LSW_USR_XREF',
 1000)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PRI_KEY WHERE TABLE_ID = 'LSW_USR_GRP_XREF'))
      INSERT INTO LSW_PRI_KEY(TABLE_ID,
 HIGH_KEY) 
VALUES ('LSW_USR_GRP_XREF',
 1000)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PRI_KEY WHERE TABLE_ID = 'EXECUTION_CONTEXT_ID'))
      INSERT INTO LSW_PRI_KEY(TABLE_ID,
 HIGH_KEY) 
VALUES ('EXECUTION_CONTEXT_ID',
 1)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PRI_KEY WHERE TABLE_ID = 'LSW_UCA_SYNC_QUEUE'))
      INSERT INTO LSW_PRI_KEY(TABLE_ID,
 HIGH_KEY) 
VALUES ('LSW_UCA_SYNC_QUEUE',
 1000)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PRI_KEY WHERE TABLE_ID = 'LSW_EM_INSTANCE'))
      INSERT INTO LSW_PRI_KEY(TABLE_ID,
 HIGH_KEY) 
VALUES ('LSW_EM_INSTANCE',
 1000)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PRI_KEY WHERE TABLE_ID = 'LSW_EM_TASK'))
      INSERT INTO LSW_PRI_KEY(TABLE_ID,
 HIGH_KEY) 
VALUES ('LSW_EM_TASK',
 1000)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PRI_KEY WHERE TABLE_ID = 'LSW_SAVED_SEARCHES'))
      INSERT INTO LSW_PRI_KEY(TABLE_ID,
 HIGH_KEY) 
VALUES ('LSW_SAVED_SEARCHES',
 1000)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PRI_KEY WHERE TABLE_ID = 'LSW_TIME_PERIOD'))
      INSERT INTO LSW_PRI_KEY(TABLE_ID,
 HIGH_KEY) 
VALUES ('LSW_TIME_PERIOD',
 1000)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PRI_KEY WHERE TABLE_ID = 'LSW_TIME_SCHEDULE'))
      INSERT INTO LSW_PRI_KEY(TABLE_ID,
 HIGH_KEY) 
VALUES ('LSW_TIME_SCHEDULE',
 1000)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PRI_KEY WHERE TABLE_ID = 'LSW_HOLIDAY_SCHEDULE'))
      INSERT INTO LSW_PRI_KEY(TABLE_ID,
 HIGH_KEY) 
VALUES ('LSW_HOLIDAY_SCHEDULE',
 1000)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PRI_KEY WHERE TABLE_ID = 'LSW_ACL_ENTRY'))
      INSERT INTO LSW_PRI_KEY(TABLE_ID,
 HIGH_KEY) 
VALUES ('LSW_ACL_ENTRY',
 1000)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PRI_KEY WHERE TABLE_ID = 'LSW_PRIORITY'))
      INSERT INTO LSW_PRI_KEY(TABLE_ID,
 HIGH_KEY) 
VALUES ('LSW_PRIORITY',
 1000)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PRI_KEY WHERE TABLE_ID = 'LSW_CA_TEMPLATE'))
      INSERT INTO LSW_PRI_KEY(TABLE_ID,
 HIGH_KEY) 
VALUES ('LSW_CA_TEMPLATE',
 1)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_USR_GRP_XREF WHERE GROUP_ID = 2))
      INSERT INTO LSW_USR_GRP_XREF(GROUP_ID,
 GROUP_NAME,
 DISPLAY_NAME,
 GROUP_TYPE,
 DESCRIPTION,
 GROUP_STATE) 
VALUES (2,
 'Debug',
 'Debug',
 3,
 'Group for people with access to debug feature.',
 0)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_USR_GRP_XREF WHERE GROUP_ID = 3))
      INSERT INTO LSW_USR_GRP_XREF(GROUP_ID,
 GROUP_NAME,
 DISPLAY_NAME,
 GROUP_TYPE,
 DESCRIPTION,
 GROUP_STATE) 
VALUES (3,
 'tw_admins',
 'tw_admins',
 3,
 'Group for people with full access to Teamworks.',
 0)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_USR_GRP_XREF WHERE GROUP_ID = 4))
      INSERT INTO LSW_USR_GRP_XREF(GROUP_ID,
 GROUP_NAME,
 DISPLAY_NAME,
 GROUP_TYPE,
 DESCRIPTION,
 GROUP_STATE) 
VALUES (4,
 'tw_authors',
 'tw_authors',
 3,
 'Group for people with Authoring access to Teamworks.',
 0)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_USR_GRP_XREF WHERE GROUP_ID = 6))
      INSERT INTO LSW_USR_GRP_XREF(GROUP_ID,
 GROUP_NAME,
 DISPLAY_NAME,
 GROUP_TYPE,
 DESCRIPTION,
 GROUP_STATE) 
VALUES (6,
 'twem',
 'twem',
 3,
 'Group for people with Event Manager access.',
 0)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_USR_GRP_XREF WHERE GROUP_ID = 11))
      INSERT INTO LSW_USR_GRP_XREF(GROUP_ID,
 GROUP_NAME,
 DISPLAY_NAME,
 GROUP_TYPE,
 DESCRIPTION,
 GROUP_STATE) 
VALUES (11,
 'tw_portal_admins',
 'tw_portal_admins',
 3,
 'Group for people with full access to Teamworks Portal.',
 0)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_USR_GRP_XREF WHERE GROUP_ID = 15))
      INSERT INTO LSW_USR_GRP_XREF(GROUP_ID,
 GROUP_NAME,
 DISPLAY_NAME,
 GROUP_TYPE,
 DESCRIPTION,
 GROUP_STATE) 
VALUES (15,
 'tw_process_owners',
 'tw_process_owners',
 3,
 'Group for people with full access to critical path',
 0)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_USR_GRP_XREF WHERE GROUP_ID = 16))
      INSERT INTO LSW_USR_GRP_XREF(GROUP_ID,
 GROUP_NAME,
 DISPLAY_NAME,
 GROUP_TYPE,
 DESCRIPTION,
 GROUP_STATE) 
VALUES (16,
 'tw_allusers',
 'tw_allusers',
 3,
 'Group for all people.',
 0)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_USR WHERE USER_ID = @TW_ADMIN_USER_ID@))
      INSERT INTO LSW_USR(USER_ID,
 USER_NAME,
 PASSWD,
 FULL_NAME,
 IS_DISABLED,
 LAST_LOGIN_DATETIME,
 OLD_PASSWORDS) 
VALUES (@TW_ADMIN_USER_ID@,
 @TW_ADMIN_USER_NAME@,
 @TW_ADMIN_USER_PASSWD@,
 'Internal TW Admin user',
 'F',
 '',
 @TW_ADMIN_USER_PASSWD@)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_USR WHERE USER_ID = @TW_AUTHOR_USER_ID@))
      INSERT INTO LSW_USR(USER_ID,
 USER_NAME,
 PASSWD,
 FULL_NAME,
 IS_DISABLED,
 LAST_LOGIN_DATETIME,
 OLD_PASSWORDS) 
VALUES (@TW_AUTHOR_USER_ID@,
 @TW_AUTHOR_USER_NAME@,
 @TW_AUTHOR_USER_PASSWD@,
 'Internal TW Author user',
 'F',
 '',
 @TW_AUTHOR_USER_PASSWD@)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_USR WHERE USER_ID = @TW_USER_USER_ID@))
      INSERT INTO LSW_USR(USER_ID,
 USER_NAME,
 PASSWD,
 FULL_NAME,
 IS_DISABLED,
 LAST_LOGIN_DATETIME,
 OLD_PASSWORDS) 
VALUES (@TW_USER_USER_ID@,
 @TW_USER_USER_NAME@,
 @TW_USER_USER_PASSWD@,
 'Internal TW User',
 'F',
 '',
 @TW_USER_USER_PASSWD@)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_USR WHERE USER_ID = @TW_WEBSERVICE_USER_ID@))
      INSERT INTO LSW_USR(USER_ID,
 USER_NAME,
 PASSWD,
 FULL_NAME,
 IS_DISABLED,
 LAST_LOGIN_DATETIME,
 OLD_PASSWORDS) 
VALUES (@TW_WEBSERVICE_USER_ID@,
 @TW_WEBSERVICE_USER_NAME@,
 @TW_WEBSERVICE_USER_PASSWD@,
 'Anonymous WebService User',
 'F',
 '',
 @TW_WEBSERVICE_USER_PASSWD@)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_USR WHERE USER_ID = @TW_PORTAL_ADMIN_USER_ID@))
      INSERT INTO LSW_USR(USER_ID,
 USER_NAME,
 PASSWD,
 FULL_NAME,
 IS_DISABLED,
 LAST_LOGIN_DATETIME,
 OLD_PASSWORDS) 
VALUES (@TW_PORTAL_ADMIN_USER_ID@,
 @TW_PORTAL_ADMIN_USER_NAME@,
 @TW_PORTAL_ADMIN_USER_PASSWD@,
 'Internal TW Portal Admin user',
 'F',
 '',
 @TW_PORTAL_ADMIN_USER_PASSWD@)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_USR WHERE USER_ID = @TW_RUNTIME_SERVER_USER_ID@))
      INSERT INTO LSW_USR(USER_ID,
 USER_NAME,
 PASSWD,
 FULL_NAME,
 IS_DISABLED,
 LAST_LOGIN_DATETIME,
 OLD_PASSWORDS) 
VALUES (@TW_RUNTIME_SERVER_USER_ID@,
 @TW_RUNTIME_SERVER_USER_NAME@,
 @TW_RUNTIME_SERVER_USER_PASSWD@,
 'Internal Runtime user',
 'F',
 '',
 @TW_RUNTIME_SERVER_USER_PASSWD@)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_USR WHERE USER_ID = @BPM_AUTHOR_USER_ID@))
      INSERT INTO LSW_USR(USER_ID,
 USER_NAME,
 PASSWD,
 FULL_NAME,
 IS_DISABLED,
 LAST_LOGIN_DATETIME,
 OLD_PASSWORDS) 
VALUES (@BPM_AUTHOR_USER_ID@,
 @BPM_AUTHOR_USER_NAME@,
 @BPM_AUTHOR_USER_PASSWD@,
 'Internal Author user',
 'F',
 '',
 @BPM_AUTHOR_USER_PASSWD@)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_USR_XREF WHERE USER_ID = @TW_ADMIN_USER_ID@))
      INSERT INTO LSW_USR_XREF(USER_ID,
 USER_NAME,
 FULL_NAME) 
VALUES (@TW_ADMIN_USER_ID@,
 @TW_ADMIN_USER_NAME@,
 'Internal TW Admin user')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_USR_XREF WHERE USER_ID = @TW_AUTHOR_USER_ID@))
      INSERT INTO LSW_USR_XREF(USER_ID,
 USER_NAME,
 FULL_NAME) 
VALUES (@TW_AUTHOR_USER_ID@,
 @TW_AUTHOR_USER_NAME@,
 'Internal TW Author user')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_USR_XREF WHERE USER_ID = @TW_USER_USER_ID@))
      INSERT INTO LSW_USR_XREF(USER_ID,
 USER_NAME,
 FULL_NAME) 
VALUES (@TW_USER_USER_ID@,
 @TW_USER_USER_NAME@,
 'Internal TW User')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_USR_XREF WHERE USER_ID = @TW_WEBSERVICE_USER_ID@))
      INSERT INTO LSW_USR_XREF(USER_ID,
 USER_NAME,
 FULL_NAME) 
VALUES (@TW_WEBSERVICE_USER_ID@,
 @TW_WEBSERVICE_USER_NAME@,
 'Anonymous WebService User')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_USR_XREF WHERE USER_ID = @TW_PORTAL_ADMIN_USER_ID@))
      INSERT INTO LSW_USR_XREF(USER_ID,
 USER_NAME,
 FULL_NAME) 
VALUES (@TW_PORTAL_ADMIN_USER_ID@,
 @TW_PORTAL_ADMIN_USER_NAME@,
 'Internal TW Portal Admin user')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_USR_XREF WHERE USER_ID = @TW_RUNTIME_SERVER_USER_ID@))
      INSERT INTO LSW_USR_XREF(USER_ID,
 USER_NAME,
 FULL_NAME) 
VALUES (@TW_RUNTIME_SERVER_USER_ID@,
 @TW_RUNTIME_SERVER_USER_NAME@,
 'Internal Runtime user')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_USR_XREF WHERE USER_ID = @BPM_AUTHOR_USER_ID@))
      INSERT INTO LSW_USR_XREF(USER_ID,
 USER_NAME,
 FULL_NAME) 
VALUES (@BPM_AUTHOR_USER_ID@,
 @BPM_AUTHOR_USER_NAME@,
 'Internal Author user')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PRIORITY WHERE PRIORITY_ID = 10))
      INSERT INTO LSW_PRIORITY(PRIORITY_ID,
 NAME,
 DESCRIPTION,
 LEGACY_GUID,
 RANKING,
 IS_DEFAULT) 
VALUES (10,
 'Highest',
 'Highest',
 'guid:0dfd96132cfb3049:57f3e3:f914ea0b73:-7fff',
 10,
 'F')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PRIORITY WHERE PRIORITY_ID = 20))
      INSERT INTO LSW_PRIORITY(PRIORITY_ID,
 NAME,
 DESCRIPTION,
 LEGACY_GUID,
 RANKING,
 IS_DEFAULT) 
VALUES (20,
 'High',
 'High',
 'guid:0dfd96132cfb3049:57f3e3:f914ea0b73:-7ffe',
 20,
 'F')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PRIORITY WHERE PRIORITY_ID = 30))
      INSERT INTO LSW_PRIORITY(PRIORITY_ID,
 NAME,
 DESCRIPTION,
 LEGACY_GUID,
 RANKING,
 IS_DEFAULT) 
VALUES (30,
 'Normal',
 'Normal',
 'guid:0dfd96132cfb3049:57f3e3:f914ea0b73:-7ff7',
 30,
 'T')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PRIORITY WHERE PRIORITY_ID = 40))
      INSERT INTO LSW_PRIORITY(PRIORITY_ID,
 NAME,
 DESCRIPTION,
 LEGACY_GUID,
 RANKING,
 IS_DEFAULT) 
VALUES (40,
 'Low',
 'Low',
 'guid:0dfd96132cfb3049:57f3e3:f914ea0b73:-7ffd',
 40,
 'F')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PRIORITY WHERE PRIORITY_ID = 50))
      INSERT INTO LSW_PRIORITY(PRIORITY_ID,
 NAME,
 DESCRIPTION,
 LEGACY_GUID,
 RANKING,
 IS_DEFAULT) 
VALUES (50,
 'Lowest',
 'Lowest',
 'guid:0dfd96132cfb3049:57f3e3:f914ea0b73:-7ffc',
 50,
 'F')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_UCA_SYNC_QUEUE WHERE SYNC_QUEUE_ID = 1))
      INSERT INTO LSW_UCA_SYNC_QUEUE(SYNC_QUEUE_ID,
 DESCRIPTION) 
VALUES (1,
 'SYNC_QUEUE_1')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_UCA_SYNC_QUEUE WHERE SYNC_QUEUE_ID = 2))
      INSERT INTO LSW_UCA_SYNC_QUEUE(SYNC_QUEUE_ID,
 DESCRIPTION) 
VALUES (2,
 'SYNC_QUEUE_2')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_UCA_SYNC_QUEUE WHERE SYNC_QUEUE_ID = 3))
      INSERT INTO LSW_UCA_SYNC_QUEUE(SYNC_QUEUE_ID,
 DESCRIPTION) 
VALUES (3,
 'SYNC_QUEUE_3')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_BLACKOUT_CALENDAR WHERE CALENDAR_ID = 1))
      INSERT INTO LSW_BLACKOUT_CALENDAR(CALENDAR_ID,
 IS_BLACKED_OUT) 
VALUES (1,
 0)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_SAVED_SEARCHES WHERE SEARCH_ID = 1))
      INSERT INTO LSW_SAVED_SEARCHES(SEARCH_ID,
 SEARCH_NAME,
 QUERY) 
VALUES (1,
 'portal.savedsearch.inbox',
 '<?xml version="1.0" encoding="UTF-8"?><query organization="byInstance"> <constraints><constraint column="taskStatus" operator="Equals" value="New_or_Received"/></constraints> <instance-results> <column name="instanceName"/> <column name="bpdName"/> <column name="instanceDueDate"/> </instance-results> <task-results> <column name="taskSubject"/> <column name="taskPriority"/> <column name="taskDueDate"/> </task-results> <business-data-results/> </query>')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_SAVED_SEARCHES WHERE SEARCH_ID = 2))
      INSERT INTO LSW_SAVED_SEARCHES(SEARCH_ID,
 SEARCH_NAME,
 QUERY) 
VALUES (2,
 'portal.savedsearch.history',
 '<?xml version="1.0" encoding="UTF-8"?><query organization="byInstance"> <constraints> <constraint column="taskStatus"  operator="Equals" value="Closed"/> </constraints> <instance-results> <column name="instanceName"/> <column name="bpdName"/> <column name="instanceStatus"/> </instance-results> <task-results> <column name="taskSubject"/> <column name="taskPriority"/> <column name="taskDueDate"/> </task-results> <business-data-results/> </query>')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_SAVED_SEARCHES WHERE SEARCH_ID = 3))
      INSERT INTO LSW_SAVED_SEARCHES(SEARCH_ID,
 SEARCH_NAME,
 QUERY) 
VALUES (3,
 'portal.savedsearch.help_reqs',
 '<?xml version="1.0" encoding="UTF-8"?><query organization="byInstance"  first-sort="" second-sort=""><constraints><constraint column="taskStatus" operator="Equals"  value="Help_Request"/></constraints><instance-results> <column name="instanceName"/> <column name="bpdName"/> <column name="instanceDueDate"/> </instance-results> <task-results> <column name="taskSubject"/> <column name="taskPriority"/> <column name="taskDueDate"/> </task-results> <business-data-results/></query>')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_SAVED_SEARCHES WHERE SEARCH_ID = 4))
      INSERT INTO LSW_SAVED_SEARCHES(SEARCH_ID,
 SEARCH_NAME,
 QUERY) 
VALUES (4,
 'portal.savedsearch.alerts',
 '<?xml version="1.0" encoding="UTF-8"?><query organization="byTask"  first-sort="" second-sort=""><constraints><constraint column="taskStatus" operator="Equals" value="Alert"/></constraints><instance-results> <column name="instanceName"/> <column name="bpdName"/> <column name="instanceDueDate"/> </instance-results> <task-results> <column name="taskSubject"/> <column name="taskPriority"/> <column name="taskDueDate"/> </task-results> <business-data-results/></query>')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_SAVED_SEARCHES WHERE SEARCH_ID = 5))
      INSERT INTO LSW_SAVED_SEARCHES(SEARCH_ID,
 SEARCH_NAME,
 QUERY) 
VALUES (5,
 'IBM.DEFAULTALLTASKSLIST_75',
 '<?xml version="1.0" encoding="UTF-8"?><query organization="byTask"  first-sort="" second-sort=""> <constraints /> <results> <column name="taskSubject" column-type="task"/> <column name="taskNarrative" column-type="task"/> <column name="taskDueDate" column-type="task"/> <column name="taskReceivedDate" column-type="task"/> <column name="taskPriority" column-type="task"/> <column name="taskStatus" column-type="task"/> <column name="taskReceivedFrom" column-type="task"/> <column name="taskClosedDate" column-type="task"/> <column name="assignedToUser" column-type="task"/> <column name="assignedToRoleDisplayName" column-type="task"/> <column name="taskActivityName" column-type="task"/> <column name="taskId" column-type="task"/> <column name="taskAtRiskTime" column-type="task"/> <column name="taskIsAtRisk" column-type="task"/> <column name="instanceId" column-type="instance"/> <column name="instanceName" column-type="instance"/> <column name="bpdId" column-type="instance"/> <column name="instanceProcessApp" column-type="instance"/> <column name="instanceSnapshot" column-type="instance"/> <column name="instanceSnapshotId" column-type="instance"/> </results> </query>')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_SAVED_SEARCHES WHERE SEARCH_ID = 6))
      INSERT INTO LSW_SAVED_SEARCHES(SEARCH_ID,
 SEARCH_NAME,
 QUERY) 
VALUES (6,
 'IBM.DEFAULTALLPROCESSLIST_75',
 '<?xml version="1.0" encoding="UTF-8"?><query organization="byInstance"  first-sort="" second-sort=""> <constraints /> <results> <column name="instanceName" column-type="instance"/> <column name="instanceStatus" column-type="instance"/> <column name="bpdName" column-type="instance"/> <column name="instanceId" column-type="instance"/> <column name="bpdId" column-type="instance"/> <column name="instanceProcessApp" column-type="instance"/> <column name="instanceSnapshot" column-type="instance"/> <column name="instanceSnapshotId" column-type="instance"/> </results> </query>')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TASK_STATUS_CODES WHERE STATUS_ID = 1))
      INSERT INTO LSW_TASK_STATUS_CODES(STATUS_ID,
 NAME,
 STATUS_VALUE) 
VALUES (1,
 'New',
 '11')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TASK_STATUS_CODES WHERE STATUS_ID = 2))
      INSERT INTO LSW_TASK_STATUS_CODES(STATUS_ID,
 NAME,
 STATUS_VALUE) 
VALUES (2,
 'Received',
 '12')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TASK_STATUS_CODES WHERE STATUS_ID = 3))
      INSERT INTO LSW_TASK_STATUS_CODES(STATUS_ID,
 NAME,
 STATUS_VALUE) 
VALUES (3,
 'Replied',
 '13')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TASK_STATUS_CODES WHERE STATUS_ID = 4))
      INSERT INTO LSW_TASK_STATUS_CODES(STATUS_ID,
 NAME,
 STATUS_VALUE) 
VALUES (4,
 'Forwarded',
 '14')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TASK_STATUS_CODES WHERE STATUS_ID = 5))
      INSERT INTO LSW_TASK_STATUS_CODES(STATUS_ID,
 NAME,
 STATUS_VALUE) 
VALUES (5,
 'Sent',
 '21')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TASK_STATUS_CODES WHERE STATUS_ID = 6))
      INSERT INTO LSW_TASK_STATUS_CODES(STATUS_ID,
 NAME,
 STATUS_VALUE) 
VALUES (6,
 'Actioned',
 '31')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TASK_STATUS_CODES WHERE STATUS_ID = 7))
      INSERT INTO LSW_TASK_STATUS_CODES(STATUS_ID,
 NAME,
 STATUS_VALUE) 
VALUES (7,
 'Closed',
 '32')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TASK_STATUS_CODES WHERE STATUS_ID = 8))
      INSERT INTO LSW_TASK_STATUS_CODES(STATUS_ID,
 NAME,
 STATUS_VALUE) 
VALUES (8,
 'Special',
 '41')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TASK_STATUS_CODES WHERE STATUS_ID = 9))
      INSERT INTO LSW_TASK_STATUS_CODES(STATUS_ID,
 NAME,
 STATUS_VALUE) 
VALUES (9,
 'Deleted',
 '91')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TASK_STATUS_CODES WHERE STATUS_ID = 10))
      INSERT INTO LSW_TASK_STATUS_CODES(STATUS_ID,
 NAME,
 STATUS_VALUE) 
VALUES (10,
 'Alert',
 '61')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TASK_STATUS_CODES WHERE STATUS_ID = 11))
      INSERT INTO LSW_TASK_STATUS_CODES(STATUS_ID,
 NAME,
 STATUS_VALUE) 
VALUES (11,
 'Help_Request',
 '62')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TASK_STATUS_CODES WHERE STATUS_ID = 12))
      INSERT INTO LSW_TASK_STATUS_CODES(STATUS_ID,
 NAME,
 STATUS_VALUE) 
VALUES (12,
 'Comment',
 '63')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TASK_STATUS_CODES WHERE STATUS_ID = 13))
      INSERT INTO LSW_TASK_STATUS_CODES(STATUS_ID,
 NAME,
 STATUS_VALUE) 
VALUES (13,
 'Answered_Help_Request',
 '65')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TASK_STATUS_CODES WHERE STATUS_ID = 14))
      INSERT INTO LSW_TASK_STATUS_CODES(STATUS_ID,
 NAME,
 STATUS_VALUE) 
VALUES (14,
 'Ignored_Help_Request',
 '66')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TASK_STATUS_CODES WHERE STATUS_ID = 15))
      INSERT INTO LSW_TASK_STATUS_CODES(STATUS_ID,
 NAME,
 STATUS_VALUE) 
VALUES (15,
 'Followed',
 '70')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TASK_STATUS_CODES WHERE STATUS_ID = 16))
      INSERT INTO LSW_TASK_STATUS_CODES(STATUS_ID,
 NAME,
 STATUS_VALUE) 
VALUES (16,
 'Tagged',
 '71')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TASK_STATUS_CODES WHERE STATUS_ID = 17))
      INSERT INTO LSW_TASK_STATUS_CODES(STATUS_ID,
 NAME,
 STATUS_VALUE) 
VALUES (17,
 'Collaboration',
 '72')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_BPD_STATUS_CODES WHERE STATUS_ID = 1))
      INSERT INTO LSW_BPD_STATUS_CODES(STATUS_ID,
 NAME,
 CONST_VALUE) 
VALUES (1,
 'Active',
 'EXECUTION_STATUS_ACTIVE')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_BPD_STATUS_CODES WHERE STATUS_ID = 2))
      INSERT INTO LSW_BPD_STATUS_CODES(STATUS_ID,
 NAME,
 CONST_VALUE) 
VALUES (2,
 'Completed',
 'EXECUTION_STATUS_COMPLETED')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_BPD_STATUS_CODES WHERE STATUS_ID = 3))
      INSERT INTO LSW_BPD_STATUS_CODES(STATUS_ID,
 NAME,
 CONST_VALUE) 
VALUES (3,
 'Failed',
 'EXECUTION_STATUS_FAILED')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_BPD_STATUS_CODES WHERE STATUS_ID = 4))
      INSERT INTO LSW_BPD_STATUS_CODES(STATUS_ID,
 NAME,
 CONST_VALUE) 
VALUES (4,
 'Terminated',
 'EXECUTION_STATUS_TERMINATED')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_BPD_STATUS_CODES WHERE STATUS_ID = 5))
      INSERT INTO LSW_BPD_STATUS_CODES(STATUS_ID,
 NAME,
 CONST_VALUE) 
VALUES (5,
 'Did_not_Start',
 'EXECUTION_STATUS_DID_NOT_START')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_BPD_STATUS_CODES WHERE STATUS_ID = 6))
      INSERT INTO LSW_BPD_STATUS_CODES(STATUS_ID,
 NAME,
 CONST_VALUE) 
VALUES (6,
 'Suspended',
 'EXECUTION_STATUS_SUSPENDED')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_FILE_TYPES WHERE FILETYPE_ID = 1))
      INSERT INTO LSW_FILE_TYPES(FILETYPE_ID,
 EXT,
 FILETYPE) 
VALUES (1,
 'DOC',
 'Word Document')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_FILE_TYPES WHERE FILETYPE_ID = 2))
      INSERT INTO LSW_FILE_TYPES(FILETYPE_ID,
 EXT,
 FILETYPE) 
VALUES (2,
 'XLS',
 'Excel Workbook')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_FILE_TYPES WHERE FILETYPE_ID = 3))
      INSERT INTO LSW_FILE_TYPES(FILETYPE_ID,
 EXT,
 FILETYPE) 
VALUES (3,
 'PPT',
 'Power Point Presentation')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_FILE_TYPES WHERE FILETYPE_ID = 4))
      INSERT INTO LSW_FILE_TYPES(FILETYPE_ID,
 EXT,
 FILETYPE) 
VALUES (4,
 'JPG',
 'JPEG Image')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_FILE_TYPES WHERE FILETYPE_ID = 5))
      INSERT INTO LSW_FILE_TYPES(FILETYPE_ID,
 EXT,
 FILETYPE) 
VALUES (5,
 'GIF',
 'GIF Image')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_FILE_TYPES WHERE FILETYPE_ID = 6))
      INSERT INTO LSW_FILE_TYPES(FILETYPE_ID,
 EXT,
 FILETYPE) 
VALUES (6,
 'PNG',
 'PNG Image')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_FILE_TYPES WHERE FILETYPE_ID = 7))
      INSERT INTO LSW_FILE_TYPES(FILETYPE_ID,
 EXT,
 FILETYPE) 
VALUES (7,
 'TXT',
 'Text')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_FILE_TYPES WHERE FILETYPE_ID = 8))
      INSERT INTO LSW_FILE_TYPES(FILETYPE_ID,
 EXT,
 FILETYPE) 
VALUES (8,
 'HTML',
 'HTML File')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_SYSTEM WHERE PROPKEY = 'InstallationGUID'))
      INSERT INTO LSW_SYSTEM(PROPKEY,
 PROPVALUE) 
VALUES ('InstallationGUID',
 @INSTALLATION_GUIDE@)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_SYSTEM WHERE PROPKEY = 'IsRepository'))
      INSERT INTO LSW_SYSTEM(PROPKEY,
 PROPVALUE) 
VALUES ('IsRepository',
 @APPSERVER_REPOSITORY_ENABLE@)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_SYSTEM_SCHEMA WHERE PROPNAME = 'DatabaseSchemaVersion'))
      INSERT INTO LSW_SYSTEM_SCHEMA(PROPNAME,
 PROPVALUE) 
VALUES ('DatabaseSchemaVersion',
 '8.0.1')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PROJECT WHERE PROJECT_ID = '1b351583-e5cb-43b7-baee-340a63130ea7'))
      INSERT INTO LSW_PROJECT(PROJECT_ID,
 CREATED_BY_USER_ID,
 CREATED_ON,
 LAST_MODIFIED,
 LAST_MODIFIED_BY_USER_ID,
 NAME,
 DESCRIPTION,
 SHORT_NAME,
 IS_TOOLKIT,
 IS_BRANCHING_ENABLED,
 IS_HIDDEN) 
VALUES ('1b351583-e5cb-43b7-baee-340a63130ea7',
 1,
 '01/01/1969 17:00:00',
 '01/01/1969 17:00:00',
 1,
 'System Data',
 'Teamworks System Data',
 'TWSYS',
 'T',
 'F',
 'F')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PROJECT WHERE PROJECT_ID = 'dbecd816-afed-47b0-ba92-c13256fcb566'))
      INSERT INTO LSW_PROJECT(PROJECT_ID,
 CREATED_BY_USER_ID,
 CREATED_ON,
 LAST_MODIFIED,
 LAST_MODIFIED_BY_USER_ID,
 NAME,
 DESCRIPTION,
 SHORT_NAME,
 IS_TOOLKIT,
 IS_BRANCHING_ENABLED,
 IS_HIDDEN) 
VALUES ('dbecd816-afed-47b0-ba92-c13256fcb566',
 1,
 '01/01/1969 17:00:00',
 '01/01/1969 17:00:00',
 1,
 'System Governance',
 'IBM BPM Governance Data and Services',
 'TWSYSG',
 'T',
 'F',
 'F')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PROJECT WHERE PROJECT_ID = 'b691179d-e7a4-4a27-b89b-f2263d0280e7'))
      INSERT INTO LSW_PROJECT(PROJECT_ID,
 CREATED_BY_USER_ID,
 CREATED_ON,
 LAST_MODIFIED,
 LAST_MODIFIED_BY_USER_ID,
 NAME,
 DESCRIPTION,
 SHORT_NAME,
 IS_TOOLKIT,
 IS_BRANCHING_ENABLED,
 IS_HIDDEN) 
VALUES ('b691179d-e7a4-4a27-b89b-f2263d0280e7',
 1,
 '01/01/1969 17:00:00',
 '01/01/1969 17:00:00',
 1,
 'Coaches',
 'IBM BPM System Coaches',
 'SYSC',
 'T',
 'F',
 'F')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PROJECT WHERE PROJECT_ID = '4b3882d9-e886-4f08-9d0c-078ebda719b9'))
      INSERT INTO LSW_PROJECT(PROJECT_ID,
 CREATED_BY_USER_ID,
 CREATED_ON,
 LAST_MODIFIED,
 LAST_MODIFIED_BY_USER_ID,
 NAME,
 DESCRIPTION,
 SHORT_NAME,
 IS_TOOLKIT,
 IS_BRANCHING_ENABLED,
 IS_HIDDEN) 
VALUES ('4b3882d9-e886-4f08-9d0c-078ebda719b9',
 1,
 '01/01/1969 17:00:00',
 '01/01/1969 17:00:00',
 1,
 'Content Management',
 'IBM BPM Content Management Data, Services and Coach views.',
 'SYSCM',
 'T',
 'F',
 'F')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_PROJECT WHERE PROJECT_ID = 'bdf91468-0d01-4ae2-bb53-054b3b591f94'))
      INSERT INTO LSW_PROJECT(PROJECT_ID,
 CREATED_BY_USER_ID,
 CREATED_ON,
 LAST_MODIFIED,
 LAST_MODIFIED_BY_USER_ID,
 NAME,
 DESCRIPTION,
 SHORT_NAME,
 IS_TOOLKIT,
 IS_BRANCHING_ENABLED,
 IS_HIDDEN) 
VALUES ('bdf91468-0d01-4ae2-bb53-054b3b591f94',
 1,
 '01/01/1969 17:00:00',
 '01/01/1969 17:00:00',
 1,
 'Ad-hoc Reports',
 'Teamworks Ad-hoc Reports',
 'ADHOC',
 'F',
 'F',
 'T')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_BRANCH WHERE BRANCH_ID = '0798815e-0346-4ef4-8946-ab4301c9f340'))
      INSERT INTO LSW_BRANCH(BRANCH_ID,
 CREATED_BY_USER_ID,
 CREATED_ON,
 LAST_MODIFIED,
 LAST_MODIFIED_BY_USER_ID,
 NAME,
 ACRONYM,
 DESCRIPTION,
 TIP_SNAPSHOT_ID,
 TIP_SEQ_NUM,
 PROJECT_ID,
 IS_DEFAULT) 
VALUES ('0798815e-0346-4ef4-8946-ab4301c9f340',
 1,
 '01/01/1969 17:00:00',
 '01/01/1969 17:00:00',
 1,
 'Main',
 'Main',
 'The main branch of the TWSYS project',
 'd14c71c9-454c-4576-b108-b441c5877c7f',
 256,
 '1b351583-e5cb-43b7-baee-340a63130ea7',
 'T')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_BRANCH WHERE BRANCH_ID = 'f757be35-ebca-4e58-a85c-6b34f3c15149'))
      INSERT INTO LSW_BRANCH(BRANCH_ID,
 CREATED_BY_USER_ID,
 CREATED_ON,
 LAST_MODIFIED,
 LAST_MODIFIED_BY_USER_ID,
 NAME,
 ACRONYM,
 DESCRIPTION,
 TIP_SNAPSHOT_ID,
 TIP_SEQ_NUM,
 PROJECT_ID,
 IS_DEFAULT) 
VALUES ('f757be35-ebca-4e58-a85c-6b34f3c15149',
 1,
 '01/01/1969 17:00:00',
 '01/01/1969 17:00:00',
 1,
 'Main',
 'Main',
 'The main branch of the TWSYSG project',
 '8b0bdb20-6dd1-4357-945a-4cdf0cbd020d',
 256,
 'dbecd816-afed-47b0-ba92-c13256fcb566',
 'T')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_BRANCH WHERE BRANCH_ID = '50f91713-f1c4-4859-897f-89720db5dc3e'))
      INSERT INTO LSW_BRANCH(BRANCH_ID,
 CREATED_BY_USER_ID,
 CREATED_ON,
 LAST_MODIFIED,
 LAST_MODIFIED_BY_USER_ID,
 NAME,
 ACRONYM,
 DESCRIPTION,
 TIP_SNAPSHOT_ID,
 TIP_SEQ_NUM,
 PROJECT_ID,
 IS_DEFAULT) 
VALUES ('50f91713-f1c4-4859-897f-89720db5dc3e',
 1,
 '01/01/1969 17:00:00',
 '01/01/1969 17:00:00',
 1,
 'Main',
 'Main',
 'The main branch of the SYSC project',
 'e01d46a5-6dc9-4545-9940-7e843777321d',
 256,
 'b691179d-e7a4-4a27-b89b-f2263d0280e7',
 'T')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_BRANCH WHERE BRANCH_ID = '4961c615-3524-4196-90da-93c49d237009'))
      INSERT INTO LSW_BRANCH(BRANCH_ID,
 CREATED_BY_USER_ID,
 CREATED_ON,
 LAST_MODIFIED,
 LAST_MODIFIED_BY_USER_ID,
 NAME,
 ACRONYM,
 DESCRIPTION,
 TIP_SNAPSHOT_ID,
 TIP_SEQ_NUM,
 PROJECT_ID,
 IS_DEFAULT) 
VALUES ('4961c615-3524-4196-90da-93c49d237009',
 1,
 '01/01/1969 17:00:00',
 '01/01/1969 17:00:00',
 1,
 'Main',
 'Main',
 'The main branch of the SYSCM project',
 '29dbc7ff-aace-481a-ba72-be56c0180448',
 256,
 '4b3882d9-e886-4f08-9d0c-078ebda719b9',
 'T')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_BRANCH WHERE BRANCH_ID = '32b9b971-a5b4-46ff-81a4-b0a75925e811'))
      INSERT INTO LSW_BRANCH(BRANCH_ID,
 CREATED_BY_USER_ID,
 CREATED_ON,
 LAST_MODIFIED,
 LAST_MODIFIED_BY_USER_ID,
 NAME,
 ACRONYM,
 DESCRIPTION,
 TIP_SNAPSHOT_ID,
 TIP_SEQ_NUM,
 PROJECT_ID,
 IS_DEFAULT) 
VALUES ('32b9b971-a5b4-46ff-81a4-b0a75925e811',
 1,
 '01/01/1969 17:00:00',
 '01/01/1969 17:00:00',
 1,
 'Main',
 'Main',
 'The main branch of the ADHOC project',
 '17903f18-237b-45c2-8897-235e99ae7989',
 256,
 'bdf91468-0d01-4ae2-bb53-054b3b591f94',
 'T')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_SNAPSHOT WHERE SNAPSHOT_ID = 'd14c71c9-454c-4576-b108-b441c5877c7f'))
      INSERT INTO LSW_SNAPSHOT(SNAPSHOT_ID,
 CREATED_BY_USER_ID,
 CREATED_ON,
 ACRONYM,
 BRANCH_ID,
 PROJECT_ID,
 SEQ_NUM,
 ORIG_CREATED_ON,
 LAST_MODIFIED,
 LAST_MODIFIED_BY_USER_ID) 
VALUES ('d14c71c9-454c-4576-b108-b441c5877c7f',
 1,
 '01/01/1969 17:00:00',
 'd14c71c9-454c-4576-b108-b441c5877c7f',
 '0798815e-0346-4ef4-8946-ab4301c9f340',
 '1b351583-e5cb-43b7-baee-340a63130ea7',
 256,
 '01/01/1969 17:00:00',
 '01/01/1969 17:00:00',
 1)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_SNAPSHOT WHERE SNAPSHOT_ID = 'e01d46a5-6dc9-4545-9940-7e843777321d'))
      INSERT INTO LSW_SNAPSHOT(SNAPSHOT_ID,
 CREATED_BY_USER_ID,
 CREATED_ON,
 ACRONYM,
 BRANCH_ID,
 PROJECT_ID,
 SEQ_NUM,
 ORIG_CREATED_ON,
 LAST_MODIFIED,
 LAST_MODIFIED_BY_USER_ID) 
VALUES ('e01d46a5-6dc9-4545-9940-7e843777321d',
 1,
 '01/01/1969 17:00:00',
 'e01d46a5-6dc9-4545-9940-7e843777321d',
 '50f91713-f1c4-4859-897f-89720db5dc3e',
 'b691179d-e7a4-4a27-b89b-f2263d0280e7',
 256,
 '01/01/1969 17:00:00',
 '01/01/1969 17:00:00',
 1)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_SNAPSHOT WHERE SNAPSHOT_ID = '29dbc7ff-aace-481a-ba72-be56c0180448'))
      INSERT INTO LSW_SNAPSHOT(SNAPSHOT_ID,
 CREATED_BY_USER_ID,
 CREATED_ON,
 ACRONYM,
 BRANCH_ID,
 PROJECT_ID,
 SEQ_NUM,
 ORIG_CREATED_ON,
 LAST_MODIFIED,
 LAST_MODIFIED_BY_USER_ID) 
VALUES ('29dbc7ff-aace-481a-ba72-be56c0180448',
 1,
 '01/01/1969 17:00:00',
 '29dbc7ff-aace-481a-ba72-be56c0180448',
 '4961c615-3524-4196-90da-93c49d237009',
 '4b3882d9-e886-4f08-9d0c-078ebda719b9',
 256,
 '01/01/1969 17:00:00',
 '01/01/1969 17:00:00',
 1)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_SNAPSHOT WHERE SNAPSHOT_ID = '17903f18-237b-45c2-8897-235e99ae7989'))
      INSERT INTO LSW_SNAPSHOT(SNAPSHOT_ID,
 CREATED_BY_USER_ID,
 CREATED_ON,
 ACRONYM,
 BRANCH_ID,
 PROJECT_ID,
 SEQ_NUM,
 ORIG_CREATED_ON,
 LAST_MODIFIED,
 LAST_MODIFIED_BY_USER_ID) 
VALUES ('17903f18-237b-45c2-8897-235e99ae7989',
 1,
 '01/01/1969 17:00:00',
 '17903f18-237b-45c2-8897-235e99ae7989',
 '32b9b971-a5b4-46ff-81a4-b0a75925e811',
 'bdf91468-0d01-4ae2-bb53-054b3b591f94',
 256,
 '01/01/1969 17:00:00',
 '01/01/1969 17:00:00',
 1)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ENV_TYPE WHERE ENV_TYPE_ID = 0))
      INSERT INTO LSW_ENV_TYPE(ENV_TYPE_ID,
 NAME,
 DESCRIPTION) 
VALUES (0,
 '0',
 'Development')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ENV_TYPE WHERE ENV_TYPE_ID = 1))
      INSERT INTO LSW_ENV_TYPE(ENV_TYPE_ID,
 NAME,
 DESCRIPTION) 
VALUES (1,
 '1',
 'Test')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ENV_TYPE WHERE ENV_TYPE_ID = 2))
      INSERT INTO LSW_ENV_TYPE(ENV_TYPE_ID,
 NAME,
 DESCRIPTION) 
VALUES (2,
 '2',
 'Staging')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ENV_TYPE WHERE ENV_TYPE_ID = 3))
      INSERT INTO LSW_ENV_TYPE(ENV_TYPE_ID,
 NAME,
 DESCRIPTION) 
VALUES (3,
 '3',
 'Production')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ENV_VAR_TYPE WHERE ENV_VAR_TYPE_ID = 0))
      INSERT INTO LSW_ENV_VAR_TYPE(ENV_VAR_TYPE_ID,
 NAME,
 DESCRIPTION) 
VALUES (0,
 '0',
 'General')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ENV_VAR_TYPE WHERE ENV_VAR_TYPE_ID = 1))
      INSERT INTO LSW_ENV_VAR_TYPE(ENV_VAR_TYPE_ID,
 NAME,
 DESCRIPTION) 
VALUES (1,
 '1',
 'ILOG Rules Server')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ENV_VAR_TYPE WHERE ENV_VAR_TYPE_ID = 2))
      INSERT INTO LSW_ENV_VAR_TYPE(ENV_VAR_TYPE_ID,
 NAME,
 DESCRIPTION) 
VALUES (2,
 '2',
 'ICI Web Service URL')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ENV_VAR_TYPE WHERE ENV_VAR_TYPE_ID = 3))
      INSERT INTO LSW_ENV_VAR_TYPE(ENV_VAR_TYPE_ID,
 NAME,
 DESCRIPTION) 
VALUES (3,
 '3',
 'ICI Connector Name')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ENV_VAR_TYPE WHERE ENV_VAR_TYPE_ID = 4))
      INSERT INTO LSW_ENV_VAR_TYPE(ENV_VAR_TYPE_ID,
 NAME,
 DESCRIPTION) 
VALUES (4,
 '4',
 'ICM Server')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ENV_VAR_TYPE WHERE ENV_VAR_TYPE_ID = 5))
      INSERT INTO LSW_ENV_VAR_TYPE(ENV_VAR_TYPE_ID,
 NAME,
 DESCRIPTION) 
VALUES (5,
 '5',
 'Server Property')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ENV_VAR_TYPE WHERE ENV_VAR_TYPE_ID = 6))
      INSERT INTO LSW_ENV_VAR_TYPE(ENV_VAR_TYPE_ID,
 NAME,
 DESCRIPTION) 
VALUES (6,
 '6',
 'ECM Server')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ENV_VAR_TYPE WHERE ENV_VAR_TYPE_ID = 7))
      INSERT INTO LSW_ENV_VAR_TYPE(ENV_VAR_TYPE_ID,
 NAME,
 DESCRIPTION) 
VALUES (7,
 '7',
 'Sametime Server')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ENV_VAR_TYPE WHERE ENV_VAR_TYPE_ID = 8))
      INSERT INTO LSW_ENV_VAR_TYPE(ENV_VAR_TYPE_ID,
 NAME,
 DESCRIPTION) 
VALUES (8,
 '8',
 'Connections Server')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TIME_PERIOD WHERE PERIOD_ID = 0))
      INSERT INTO LSW_TIME_PERIOD(PERIOD_ID,
 NAME,
 START_TIME,
 END_TIME,
 EFFECTIVE_DAYS) 
VALUES (0,
 '24X7',
 '0000',
 '2359',
 'mon,tue,wed,thu,fri,sat,sun')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TIME_PERIOD WHERE PERIOD_ID = 1))
      INSERT INTO LSW_TIME_PERIOD(PERIOD_ID,
 NAME,
 START_TIME,
 END_TIME,
 EFFECTIVE_DAYS) 
VALUES (1,
 '7AM-7PM M-F',
 '0700',
 '1900',
 'mon,tue,wed,thu,fri')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TIME_PERIOD WHERE PERIOD_ID = 2))
      INSERT INTO LSW_TIME_PERIOD(PERIOD_ID,
 NAME,
 START_TIME,
 END_TIME,
 EFFECTIVE_DAYS) 
VALUES (2,
 '7AM-7PM Every Day',
 '0700',
 '1900',
 'mon,tue,wed,thu,fri,sat,sun')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TIME_PERIOD WHERE PERIOD_ID = 3))
      INSERT INTO LSW_TIME_PERIOD(PERIOD_ID,
 NAME,
 START_TIME,
 END_TIME,
 EFFECTIVE_DAYS) 
VALUES (3,
 '9AM-5PM M-F',
 '0900',
 '1700',
 'mon,tue,wed,thu,fri')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TIME_PERIOD WHERE PERIOD_ID = 4))
      INSERT INTO LSW_TIME_PERIOD(PERIOD_ID,
 NAME,
 START_TIME,
 END_TIME,
 EFFECTIVE_DAYS) 
VALUES (4,
 '9AM-1PM Sat',
 '0900',
 '1300',
 'sat')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TIME_SCHEDULE WHERE SCHEDULE_ID = 0))
      INSERT INTO LSW_TIME_SCHEDULE(SCHEDULE_ID,
 NAME,
 EXCLUDE_HOLIDAY) 
VALUES (0,
 '24X7',
 'F')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TIME_SCHEDULE WHERE SCHEDULE_ID = 1))
      INSERT INTO LSW_TIME_SCHEDULE(SCHEDULE_ID,
 NAME,
 EXCLUDE_HOLIDAY) 
VALUES (1,
 '7AM-7PM M-F',
 'T')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TIME_SCHEDULE WHERE SCHEDULE_ID = 2))
      INSERT INTO LSW_TIME_SCHEDULE(SCHEDULE_ID,
 NAME,
 EXCLUDE_HOLIDAY) 
VALUES (2,
 '7AM-7PM Every Day',
 'F')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TIME_SCHEDULE WHERE SCHEDULE_ID = 3))
      INSERT INTO LSW_TIME_SCHEDULE(SCHEDULE_ID,
 NAME,
 EXCLUDE_HOLIDAY) 
VALUES (3,
 '9AM-5PM M-F',
 'T')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TIME_SCHEDULE WHERE SCHEDULE_ID = 4))
      INSERT INTO LSW_TIME_SCHEDULE(SCHEDULE_ID,
 NAME,
 EXCLUDE_HOLIDAY) 
VALUES (4,
 '9AM-5PM M-F , 9AM-1PM Sat',
 'T')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TIME_SCHEDULE_PERIOD WHERE SCHEDULE_ID = 0 AND PERIOD_ID = 0))
      INSERT INTO LSW_TIME_SCHEDULE_PERIOD(SCHEDULE_ID,
 PERIOD_ID) 
VALUES (0,
 0)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TIME_SCHEDULE_PERIOD WHERE SCHEDULE_ID = 1 AND PERIOD_ID = 1))
      INSERT INTO LSW_TIME_SCHEDULE_PERIOD(SCHEDULE_ID,
 PERIOD_ID) 
VALUES (1,
 1)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TIME_SCHEDULE_PERIOD WHERE SCHEDULE_ID = 2 AND PERIOD_ID = 2))
      INSERT INTO LSW_TIME_SCHEDULE_PERIOD(SCHEDULE_ID,
 PERIOD_ID) 
VALUES (2,
 2)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TIME_SCHEDULE_PERIOD WHERE SCHEDULE_ID = 3 AND PERIOD_ID = 3))
      INSERT INTO LSW_TIME_SCHEDULE_PERIOD(SCHEDULE_ID,
 PERIOD_ID) 
VALUES (3,
 3)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TIME_SCHEDULE_PERIOD WHERE SCHEDULE_ID = 4 AND PERIOD_ID = 3))
      INSERT INTO LSW_TIME_SCHEDULE_PERIOD(SCHEDULE_ID,
 PERIOD_ID) 
VALUES (4,
 3)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_TIME_SCHEDULE_PERIOD WHERE SCHEDULE_ID = 4 AND PERIOD_ID = 4))
      INSERT INTO LSW_TIME_SCHEDULE_PERIOD(SCHEDULE_ID,
 PERIOD_ID) 
VALUES (4,
 4)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_HOLIDAY_SCHEDULE WHERE HOLIDAY_ID = 0))
      INSERT INTO LSW_HOLIDAY_SCHEDULE(HOLIDAY_ID,
 NAME,
 HOLIDAY_LIST) 
VALUES (0,
 'empty holiday',
 '')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_LOCK WHERE LOCK_ID = 'IMPORT_LOCK_TWX_KEY'))
      INSERT INTO LSW_LOCK(LOCK_ID,
 DESCRIPTION) 
VALUES ('IMPORT_LOCK_TWX_KEY',
 'Lock required importing twx file ')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_LOCK WHERE LOCK_ID = 'DEPLOYMENT_PKG_LOCK_KEY'))
      INSERT INTO LSW_LOCK(LOCK_ID,
 DESCRIPTION) 
VALUES ('DEPLOYMENT_PKG_LOCK_KEY',
 'Lock required for add a deployment package to lsw_deployment_package ')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_LOCK WHERE LOCK_ID = 'LOG_ADD_LOCK_KEY'))
      INSERT INTO LSW_LOCK(LOCK_ID,
 DESCRIPTION) 
VALUES ('LOG_ADD_LOCK_KEY',
 'Lock required for adding logs to bpm_repository_log and updating timestamp in bpm_project_subscription')
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ACL_ENTRY WHERE ACL_ENTRY_ID = 1))
      INSERT INTO LSW_ACL_ENTRY(ACL_ENTRY_ID,
 GROUP_ID,
 PO_TYPE,
 PO_ID,
 MASK) 
VALUES (1,
 3,
 5000,
 @INSTALLATION_GUIDE@,
 127)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ACL_ENTRY WHERE ACL_ENTRY_ID = 2))
      INSERT INTO LSW_ACL_ENTRY(ACL_ENTRY_ID,
 GROUP_ID,
 PO_TYPE,
 PO_ID,
 MASK) 
VALUES (2,
 4,
 5000,
 @INSTALLATION_GUIDE@,
 63)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ACL_ENTRY WHERE ACL_ENTRY_ID = 3))
      INSERT INTO LSW_ACL_ENTRY(ACL_ENTRY_ID,
 GROUP_ID,
 PO_TYPE,
 PO_ID,
 MASK) 
VALUES (3,
 3,
 2066,
 '1b351583-e5cb-43b7-baee-340a63130ea7',
 63)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ACL_ENTRY WHERE ACL_ENTRY_ID = 4))
      INSERT INTO LSW_ACL_ENTRY(ACL_ENTRY_ID,
 GROUP_ID,
 PO_TYPE,
 PO_ID,
 MASK) 
VALUES (4,
 4,
 2066,
 '1b351583-e5cb-43b7-baee-340a63130ea7',
 63)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ACL_ENTRY WHERE ACL_ENTRY_ID = 5))
      INSERT INTO LSW_ACL_ENTRY(ACL_ENTRY_ID,
 GROUP_ID,
 PO_TYPE,
 PO_ID,
 MASK) 
VALUES (5,
 3,
 2066,
 'bdf91468-0d01-4ae2-bb53-054b3b591f94',
 127)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ACL_ENTRY WHERE ACL_ENTRY_ID = 6))
      INSERT INTO LSW_ACL_ENTRY(ACL_ENTRY_ID,
 GROUP_ID,
 PO_TYPE,
 PO_ID,
 MASK) 
VALUES (6,
 4,
 2066,
 'bdf91468-0d01-4ae2-bb53-054b3b591f94',
 127)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ACL_ENTRY WHERE ACL_ENTRY_ID = 7))
      INSERT INTO LSW_ACL_ENTRY(ACL_ENTRY_ID,
 GROUP_ID,
 PO_TYPE,
 PO_ID,
 MASK) 
VALUES (7,
 3,
 2066,
 'dbecd816-afed-47b0-ba92-c13256fcb566',
 127)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ACL_ENTRY WHERE ACL_ENTRY_ID = 8))
      INSERT INTO LSW_ACL_ENTRY(ACL_ENTRY_ID,
 GROUP_ID,
 PO_TYPE,
 PO_ID,
 MASK) 
VALUES (8,
 3,
 2066,
 'b691179d-e7a4-4a27-b89b-f2263d0280e7',
 63)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ACL_ENTRY WHERE ACL_ENTRY_ID = 9))
      INSERT INTO LSW_ACL_ENTRY(ACL_ENTRY_ID,
 GROUP_ID,
 PO_TYPE,
 PO_ID,
 MASK) 
VALUES (9,
 4,
 2066,
 'b691179d-e7a4-4a27-b89b-f2263d0280e7',
 63)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ACL_ENTRY WHERE ACL_ENTRY_ID = 10))
      INSERT INTO LSW_ACL_ENTRY(ACL_ENTRY_ID,
 GROUP_ID,
 PO_TYPE,
 PO_ID,
 MASK) 
VALUES (10,
 3,
 2066,
 '4b3882d9-e886-4f08-9d0c-078ebda719b9',
 63)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ACL_ENTRY WHERE ACL_ENTRY_ID = 11))
      INSERT INTO LSW_ACL_ENTRY(ACL_ENTRY_ID,
 GROUP_ID,
 PO_TYPE,
 PO_ID,
 MASK) 
VALUES (11,
 4,
 2066,
 '4b3882d9-e886-4f08-9d0c-078ebda719b9',
 63)
;

    
IF (NOT EXISTS ( SELECT 1 FROM LSW_ACL_ENTRY WHERE ACL_ENTRY_ID = 12))
      INSERT INTO LSW_ACL_ENTRY(ACL_ENTRY_ID,
 GROUP_ID,
 PO_TYPE,
 PO_ID,
 MASK) 
VALUES (12,
 4,
 2066,
 'dbecd816-afed-47b0-ba92-c13256fcb566',
 5)
;

    
IF (NOT EXISTS ( SELECT 1 FROM BPM_SNAPSHOT_STATUS WHERE STATUS_ID = '1b351583-e5cb-43b7-baee-340a63130ea1'))
      INSERT INTO BPM_SNAPSHOT_STATUS(STATUS_ID,
 STATUS,
 IS_SYSTEM) 
VALUES ('1b351583-e5cb-43b7-baee-340a63130ea1',
 'New',
 'T')
;

    
IF (NOT EXISTS ( SELECT 1 FROM BPM_SNAPSHOT_STATUS WHERE STATUS_ID = '1b351583-e5cb-43b7-baee-340a63130ea2'))
      INSERT INTO BPM_SNAPSHOT_STATUS(STATUS_ID,
 STATUS,
 IS_SYSTEM) 
VALUES ('1b351583-e5cb-43b7-baee-340a63130ea2',
 'Rejected',
 'T')
;

    
IF (NOT EXISTS ( SELECT 1 FROM BPM_SNAPSHOT_STATUS WHERE STATUS_ID = '1b351583-e5cb-43b7-baee-340a63130ea3'))
      INSERT INTO BPM_SNAPSHOT_STATUS(STATUS_ID,
 STATUS,
 IS_SYSTEM) 
VALUES ('1b351583-e5cb-43b7-baee-340a63130ea3',
 'Validated',
 'T')
;

    
IF (NOT EXISTS ( SELECT 1 FROM BPM_SNAPSHOT_STATUS WHERE STATUS_ID = '1b351583-e5cb-43b7-baee-340a63130ea7'))
      INSERT INTO BPM_SNAPSHOT_STATUS(STATUS_ID,
 STATUS,
 IS_SYSTEM) 
VALUES ('1b351583-e5cb-43b7-baee-340a63130ea7',
 'Released',
 'T')
;

    
IF (NOT EXISTS ( SELECT 1 FROM BPM_EVENT_SUBSCRIPTION_TYPE WHERE EVENT_SUBSCRIPTION_TYPE_ID = 0))
      INSERT INTO BPM_EVENT_SUBSCRIPTION_TYPE(EVENT_SUBSCRIPTION_TYPE_ID,
 NAME,
 DESCRIPTION) 
VALUES (0,
 '0',
 'ECM')
;

    
IF (NOT EXISTS ( SELECT 1 FROM BPM_UCA_EVENT_TYPE WHERE UCA_EVENT_TYPE_ID = 0))
      INSERT INTO BPM_UCA_EVENT_TYPE(UCA_EVENT_TYPE_ID,
 NAME,
 DESCRIPTION) 
VALUES (0,
 '0',
 'Timer')
;

    
IF (NOT EXISTS ( SELECT 1 FROM BPM_UCA_EVENT_TYPE WHERE UCA_EVENT_TYPE_ID = 1))
      INSERT INTO BPM_UCA_EVENT_TYPE(UCA_EVENT_TYPE_ID,
 NAME,
 DESCRIPTION) 
VALUES (1,
 '1',
 'Message')
;

    
IF (NOT EXISTS ( SELECT 1 FROM BPM_UCA_EVENT_TYPE WHERE UCA_EVENT_TYPE_ID = 2))
      INSERT INTO BPM_UCA_EVENT_TYPE(UCA_EVENT_TYPE_ID,
 NAME,
 DESCRIPTION) 
VALUES (2,
 '2',
 'Content')
;

    
IF (NOT EXISTS ( SELECT 1 FROM BPM_GOVERNANCE_EVENT WHERE EVENT_TYPE_ID = 'dbecd816-afed-47b0-ba92-c13256fcb568'))
      INSERT INTO BPM_GOVERNANCE_EVENT(EVENT_TYPE_ID,
 EVENT_TYPE,
 EVENT_TYPE_NAME,
 GOV_DEFAULT_SNAPSHOT_ID,
 GOV_DEFAULT_PROCESS_ID,
 GOV_DEFAULT_PROCESS_TYPE) 
VALUES ('dbecd816-afed-47b0-ba92-c13256fcb568',
 0,
 'Installation Requested',
 '8b0bdb20-6dd1-4357-945a-4cdf0cbd020d',
 'b0d87b96-5044-4390-b0f5-4ba05d63bc28',
 25)
;

    
IF (NOT EXISTS ( SELECT 1 FROM BPM_GOVERNANCE_EVENT WHERE EVENT_TYPE_ID = 'dbecd816-afed-47b0-ba92-c13256fcb569'))
      INSERT INTO BPM_GOVERNANCE_EVENT(EVENT_TYPE_ID,
 EVENT_TYPE,
 EVENT_TYPE_NAME,
 GOV_DEFAULT_SNAPSHOT_ID,
 GOV_DEFAULT_PROCESS_ID,
 GOV_DEFAULT_PROCESS_TYPE) 
VALUES ('dbecd816-afed-47b0-ba92-c13256fcb569',
 1,
 'Snapshot Status Change',
 '8b0bdb20-6dd1-4357-945a-4cdf0cbd020d',
 '291536f1-aa21-4650-8ac9-c62eaa3fa110',
 25)
;

-- This file creates scheduler tables for background thread on PC Sharing feature.
-- Scriptfile to create schema for DB2
-- 1. Process this script in the DB2 command line processor
-- Example:
--             db2 connect to SCHEDDB
--             db2 -tf createTable_Scheduler_Sharing.sql



CREATE TABLE [BPM_PCS_TASK] ( [TASKID] BIGINT NOT NULL ,
               [VERSION] VARCHAR(5) NOT NULL ,
               [ROW_VERSION] INT NOT NULL ,
               [TASKTYPE] INT NOT NULL ,
               [TASKSUSPENDED] TINYINT NOT NULL ,
               [CANCELLED] TINYINT NOT NULL ,
               [NEXTFIRETIME] BIGINT NOT NULL ,
               [STARTBYINTERVAL] VARCHAR(254) NULL ,
               [STARTBYTIME] BIGINT NULL ,
               [VALIDFROMTIME] BIGINT NULL ,
               [VALIDTOTIME] BIGINT NULL ,
               [REPEATINTERVAL] VARCHAR(254) NULL ,
               [MAXREPEATS] INT NOT NULL ,
               [REPEATSLEFT] INT NOT NULL ,
               [TASKINFO] IMAGE NULL ,
               [NAME] VARCHAR(254) NOT NULL ,
               [AUTOPURGE] INT NOT NULL ,
               [FAILUREACTION] INT NULL ,
               [MAXATTEMPTS] INT NULL ,
               [QOS] INT NULL ,
               [PARTITIONID] INT NULL ,
               [OWNERTOKEN] VARCHAR(200) NOT NULL ,
               [CREATETIME] BIGINT NOT NULL ) 
;
 
ALTER TABLE [BPM_PCS_TASK] WITH NOCHECK ADD CONSTRAINT [BPM_PCS_TASK_PK] PRIMARY KEY  NONCLUSTERED ( [TASKID] ) 
;

CREATE INDEX [BPM_PCS_TASK_IDX1] ON [BPM_PCS_TASK] ( [TASKID],
               [OWNERTOKEN] ) 
;

CREATE CLUSTERED INDEX [BPM_PCS_TASK_IDX2] ON [BPM_PCS_TASK] ( [NEXTFIRETIME] ASC,
               [REPEATSLEFT],
               [PARTITIONID] )
;

CREATE TABLE [BPM_PCS_TREG] ( [REGKEY] VARCHAR(254) NOT NULL ,
               [REGVALUE] VARCHAR(254) NULL ,
               PRIMARY KEY ( [REGKEY] ) )
;

CREATE TABLE [BPM_PCS_LMGR] ( [LEASENAME] VARCHAR(254) NOT NULL,
               [LEASEOWNER] VARCHAR(254) NOT NULL,
               [LEASE_EXPIRE_TIME] BIGINT,
               [DISABLED] VARCHAR(5) )
;

ALTER TABLE [BPM_PCS_LMGR] WITH NOCHECK ADD CONSTRAINT [BPM_PCS_LMGR_PK] PRIMARY KEY  NONCLUSTERED ( [LEASENAME] ) 
;

CREATE TABLE [BPM_PCS_LMPR] ( [LEASENAME] VARCHAR(254) NOT NULL,
               [NAME] VARCHAR(254) NOT NULL,
               [VALUE] VARCHAR(254) NOT NULL )
;

CREATE INDEX [BPM_PCS_LMPR_IDX1] ON [BPM_PCS_LMPR] ( [LEASENAME],
               [NAME] ) 
;

